# JSON.jl

A Julia package for reading and writing JSON data.

[![Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaio.github.io/JSON.jl/stable)
[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliaio.github.io/JSON.jl/dev)
[![Build Status](https://github.com/JuliaIO/JSON.jl/workflows/CI/badge.svg)](https://github.com/JuliaIO/JSON.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![codecov.io](http://codecov.io/github/JuliaIO/JSON.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaIO/JSON.jl?branch=master)

## Installation

Install JSON using the Julia package manager:
```julia
import Pkg
Pkg.add("JSON")
```

## Documentation

The [documentation](https://juliaio.github.io/JSON.jl/stable) includes extensive
guides and examples. It also has advice for migrating to JSON.jl v1.0 from
JSON.jl v0.21 or JSON3.jl.

## Basic Usage

```julia
import JSON

# JSON.parse - JSON to Julia
json = """{"a": 1, "b": null, "c": [1, 2, 3]}"""

# parse into default Julia types
j = JSON.parse(json)
# JSON.Object{String, Any} with 3 entries:
#   "a" => 1
#   "b" => nothing
#   "c" => Any[1, 2, 3]

struct MyType
    a::Int
    b::Union{Nothing, String}
    c::Vector{Int}
end

# parse into a custom type
j = JSON.parse(json, MyType)
# MyType(1, nothing, [1, 2, 3])

# parse into existing container
dict = Dict{String, Any}()
JSON.parse!(json, dict)

# JSON.parsefile - JSON file to Julia
x = JSON.parsefile("test.json")

# JSON.json - Julia to JSON
JSON.json([2,3])
#  "[2,3]"

# Julia struct to JSON, pretty printed, written to IO (stdout)
JSON.json(stdout, j; pretty=true)
# {
#     "a": 1,
#     "b": null,
#     "c": [
#         1,
#         2,
#         3
#     ]
# }

# test that JSON is valid
JSON.isvalidjson(json)

# Write JSON to file
JSON.json("test.json", j)

# Download json data and parse into a DataFrame
using HTTP, JSON, Tables, DataFrames
resp = HTTP.get("https://raw.githubusercontent.com/altair-viz/vega_datasets/master/vega_datasets/_data/wheat.json")
# null=missing will read json `null` as Julia `missing; `allownan=true` parses all numbers as Float64
df = DataFrame(Tables.dictrowtable(JSON.parse(resp.body; null=missing, allownan=true)))
```

## Vendor Directory

This package includes a `vendor/` directory containing a simplified,
no-dependency JSON parser (`JSONX`) that can be vendored (copied) into other
projects. See the [vendor README](vendor/README.md) for details.

## Contributing and Questions

Contributions are very welcome, as are feature requests and suggestions. Please
open an [issue](https://github.com/JuliaIO/JSON.jl/issues) if you encounter any
problems or would just like to ask a question.

# JSON.jl

This package provides for parsing and printing JSON in pure Julia.

[![Build Status](https://github.com/JuliaIO/JSON.jl/workflows/CI/badge.svg)](https://github.com/JuliaIO/JSON.jl/actions/workflows/CI.yml?query=branch%3Amaster)
[![codecov.io](http://codecov.io/github/JuliaIO/JSON.jl/coverage.svg?branch=master)](http://codecov.io/github/JuliaIO/JSON.jl?branch=master)

## Installation

Type `] add JSON` and then hit ⏎ Return at the REPL. You should see `pkg> add JSON`.

## Basic Usage

```julia
import JSON

# JSON.parse - string or stream to Julia data structures
s = "{\"a_number\" : 5.0, \"an_array\" : [\"string\", 9]}"
j = JSON.parse(s)
#  Dict{AbstractString,Any} with 2 entries:
#    "an_array" => {"string",9}
#    "a_number" => 5.0

# JSON.json - Julia data structures to a string
JSON.json([2,3])
#  "[2,3]"
JSON.json(j)
#  "{\"an_array\":[\"string\",9],\"a_number\":5.0}"
```

## Documentation

```julia
JSON.print(io::IO, s::AbstractString)
JSON.print(io::IO, s::Union{Integer, AbstractFloat})
JSON.print(io::IO, n::Nothing)
JSON.print(io::IO, b::Bool)
JSON.print(io::IO, a::AbstractDict)
JSON.print(io::IO, v::AbstractVector)
JSON.print(io::IO, v::Array)
```

Writes a compact (no extra whitespace or indentation) JSON representation
to the supplied IO.

```julia
JSON.print(a::AbstractDict, indent)
JSON.print(io::IO, a::AbstractDict, indent)
```

Writes a JSON representation with newlines, and indentation if specified. Non-zero `indent` will be applied recursively to nested elements.


```julia
json(a::Any)
```

Returns a compact JSON representation as an `AbstractString`.

```julia
JSON.parse(s::AbstractString; dicttype=Dict, inttype=Int64)
JSON.parse(io::IO; dicttype=Dict, inttype=Int64)
JSON.parsefile(filename::AbstractString; dicttype=Dict, inttype=Int64, use_mmap=true)
```

Parses a JSON `AbstractString` or IO stream into a nested `Array` or `Dict`.

The `dicttype` indicates the dictionary type (`<: Associative`), or a function that
returns an instance of a dictionary type,
that JSON objects are parsed to.  It defaults to `Dict` (the built-in Julia
dictionary), but a different type can be passed for additional functionality.
For example, if you `import DataStructures`
(assuming the [DataStructures
package](https://github.com/JuliaLang/DataStructures.jl) is
installed)

 - you can pass `dicttype=DataStructures.OrderedDict` to maintain the insertion order
   of the items in the object;
 - or you can pass `()->DefaultDict{String,Any}(Missing)` to having any non-found keys
   return `missing` when you index the result.


The `inttype` argument controls how integers are parsed.  If a number in a JSON
file is recognized to be an integer, it is parsed as one; otherwise it is parsed
as a `Float64`.  The `inttype` defaults to `Int64`, but, for example, if you know
that your integer numbers are all small and want to save space, you can pass
`inttype=Int32`.  Alternatively, if your JSON input has integers which are too large
for Int64, you can pass `inttype=Int128` or `inttype=BigInt`.  `inttype` can be any
subtype of `Real`.

```julia
JSONText(s::AbstractString)
```
A wrapper around a Julia string representing JSON-formatted text,
which is inserted *as-is* in the JSON output of `JSON.print` and `JSON.json`.

```julia
JSON.lower(p::Point2D) = [p.x, p.y]
```

Define a custom serialization rule for a particular data type. Must return a
value that can be directly serialized; see help for more details.

### Customizing JSON

Users may find the default behaviour of JSON inappropriate for their use case. In
such cases, JSON provides two mechanisms for users to customize serialization. The
first method, `JSON.Writer.StructuralContext`, is used to customize the cosmetic
properties of the serialized JSON. (For example, the default pretty printing vs.
compact printing is supported by provided two different `StructuralContext`s.)
Examples of applications for which `StructuralContext` is appropriate include:
particular formatting demands for JSON (maybe not in compliance with the JSON
standard) or JSON-like formats with different syntax.

The second method, `JSON.Serializations.Serialization`, is used to control the
translation of Julia objects into JSON serialization instructions. In most cases,
writing a method for `JSON.lower` (as mentioned above) is sufficient to define
JSON serializations for user-defined objects. However, this is not appropriate for
overriding or deleting predefined serializations (since that would globally affect
users of the `JSON` module and is an instance of dangerous
[type piracy](https://docs.julialang.org/en/v1/manual/style-guide/index.html#Avoid-type-piracy-1)).
For these use-cases, users should define a custom instance of `Serialization`.
An example of an application for this use case includes: a commonly requested
extension to JSON which serializes float NaN and infinite values as `NaN` or `Inf`,
in contravention of the JSON standard.

Both methods are controlled by the `JSON.show_json` function, which has the following
signature:

```
JSON.show_json(io::StructuralContext, serialization::Serialization, object)
```

which is expected to write to `io` in a way appropriate based on the rules of
`Serialization`, but here `io` is usually (but not required to be) handled in a
higher-level manner than a raw `IO` object would ordinarily be.

#### StructuralContext

To define a new `StructuralContext`, the following boilerplate is recommended:

```julia
import JSON.Writer.StructuralContext
[mutable] struct MyContext <: StructuralContext
    io::IO
    [ ... additional state / settings for context goes here ... ]
end
```

If your structural context is going to be very similar to the existing JSON
contexts, it is also possible to instead subtype the abstract subtype
`JSONContext` of `StructuralContext`. If this is the case, an `io::IO` field (as
above) is preferred, although the default implementation will only use this
for `write`, so replacing that method is enough to avoid this requirement.

The following methods should be defined for your context, regardless of whether it
subtypes `JSONContext` or `StructuralContext` directly. If some of these methods
are omitted, then `CommonSerialization` cannot be generally used with this context.

```
# called when the next object in a vector or next pair of a dict is to be written
# (requiring a newline and indent for some contexts)
# can do nothing if the context need not support indenting
JSON.Writer.indent(io::MyContext)

# called for vectors/dicts to separate items, usually writes ","
# unless this is the first element in a JSON array
# (default implementation for JSONContext exists, but requires a mutable bool
#  `first` field, and this is an implementation detail not to be relied on; 
#  to define own or delegate explicitly)
JSON.Writer.delimit(io::MyContext)

# called for dicts to separate key and value, usually writes ": "
JSON.Writer.separate(io::MyContext)

# called to indicate start and end of a vector
JSON.Writer.begin_array(io::MyContext)
JSON.Writer.end_array(io::MyContext)

# called to indicate start and end of a dict
JSON.Writer.begin_object(io::MyContext)
JSON.Writer.end_object(io::MyContext)
```

For the following methods, `JSONContext` provides a default implementation,
but it can be specialized. For `StructuralContext`s which are not
`JSONContext`s, the `JSONContext` defaults are not appropriate and so are
not available.

```julia
# directly write a specific byte (if supported)
# default implementation writes to underlying `.io` field
# note that this enables JSONContext to act as any `io::IO`,
# i.e. one can use `print`, `show`, etc.
Base.write(io::MyContext, byte::UInt8)

# write "null"
# default implementation writes to underlying `.io` field
JSON.Writer.show_null(io::MyContext)

# write an object or string in a manner safe for JSON string
# default implementation calls `print` but escapes each byte as appropriate
# and adds double quotes around the content of `elt`
JSON.Writer.show_string(io::MyContext, elt)

# write a new element of JSON array
# default implementation calls delimit, then indent, then show_json
JSON.Writer.show_element(io::MyContext, elt)

# write a key for a JSON object
# default implementation calls delimit, then indent, then show_string,
# then seperate
JSON.Writer.show_key(io::MyContext, elt)

# write a key-value pair for a JSON object
# default implementation calls show key, then show_json
JSON.Writer.show_pair(io::MyContext, s::Serialization, key, value)
```

What follows is an example of a `JSONContext` subtype which is very similar
to the default context, but which uses `None` instead of `null` for JSON nulls,
which is then generally compatible with Python object literal notation (PYON). It
wraps a default `JSONContext` to delegate all the required methods to. Since
the wrapped context already has a `.io`, this object does not need to include
an `.io` field, and so the `write` method must also be delegated, since the default
is not appropriate. The only other specialization needed is `show_null`.

```julia
import JSON.Writer
import JSON.Writer.JSONContext
mutable struct PYONContext <: JSONContext
    underlying::JSONContext
end

for delegate in [:indent,
                 :delimit,
                 :separate,
                 :begin_array,
                 :end_array,
                 :begin_object,
                 :end_object]
    @eval JSON.Writer.$delegate(io::PYONContext) = JSON.Writer.$delegate(io.underlying)
end
Base.write(io::PYONContext, byte::UInt8) = write(io.underlying, byte)

JSON.Writer.show_null(io::PYONContext) = print(io, "None")
pyonprint(io::IO, obj) = let io = PYONContext(JSON.Writer.PrettyContext(io, 4))
    JSON.print(io, obj)
    return
end
```

The usage of this `pyonprint` function is as any other `print` function, e.g.

```julia
julia> pyonprint(stdout, [1, 2, nothing])
[
    1,
    2,
    None
]

julia> sprint(pyonprint, missing)
"None"
```

#### Serialization

For cases where the JSON cosmetics are unimportant, but how objects are converted into their
JSON equivalents (arrays, objects, numbers, etc.) need to be changed, the appropriate
abstraction is `Serialization`. A `Serialization` instance is used as the second argument in
`show_json`. Thus, specializing `show_json` for custom `Serialization` instances enables
either creating more restrictive or different ways to convert objects into JSON.

The default serialization is called `JSON.Serializations.StandardSerialization`, which is a
subtype of `CommonSerialization`. Methods of `show_json` are not added to
`StandardSerialization`, but rather to `CommonSerialization`, by both `JSON` and by
other packages for their own types. The `lower` functionality is also specific to
`CommonSerialization`. Therefore, to create a serialization instance that inherits from and
may extend or override parts of the standard serialization, it suffices to define a new
serialization subtyping `CommonSerialization`. In the example below, the new serialization
is the same as `StandardSerialization` except that numbers are serialized with an additional
type tag.

```julia
import JSON.Serializations: CommonSerialization, StandardSerialization
import JSON.Writer: StructuralContext, show_json
struct TaggedNumberSerialization <: CommonSerialization end

tag(f::Real) = Dict(:type => string(typeof(f)), :value => f)
show_json(io::StructuralContext,
            ::TaggedNumberSerialization,
           f::Union{Integer, AbstractFloat}) =
    show_json(io, StandardSerialization(), tag(f))
```

Note that the recursive call constructs a `StandardSerialization()`, as otherwise this would
result in a stack overflow, and serializes a `Dict` using that. In this toy example, this is
fine (with only the overhead of constructing a `Dict`), but this is not always possible.
(For instance, if the constructed `Dict` could have other numbers within its values that
need to be tagged.)

To deal with these more complex cases, or simply to eliminate the overhead of constructing
the intermediate `Dict`, the `show_json` method can be implemented more carefully by
explicitly calling the context’s `begin_object`, `show_pair`, and `end_object` methods, as
documented above, and use the `StandardSerialization()` only for the `show_pair` call for
`f`.

```julia
# More careful implementation
# No difference in this case, but could be needed if recursive data structures are to be
# serialized in more complex cases.
import JSON.Writer: begin_object, show_pair, end_object
function show_json(io::StructuralContext,
                    s::TaggedNumberSerialization,
                    f::Union{Integer, AbstractFloat})
    begin_object(io)
    show_pair(io, s, :tag => string(typeof(f)))
    show_pair(io, StandardSerialization(), :value => f)
    end_object(io)
end
```

To use the custom serialization, `sprint` can be used (and this can be encapsulated by a
convenient user-defined inteface):

```julia
julia> JSON.parse(sprint(show_json, TaggedNumberSerialization(), Any[1, 2.0, "hi"]))
3-element Array{Any,1}:
 Dict{String,Any}("value" => 1,"type" => "Int64")
 Dict{String,Any}("value" => 2.0,"type" => "Float64")
 "hi"
```

If it is not desired to inherit all the functionality of `StandardSerialization`, users may
also choose to start from scratch by directly subtyping `JSON.Serializations.Serialization`.
This is useful if the user wishes to enforce a strict JSON which throws errors when
attempting to serialize objects that aren’t explicitly supported. Note that this means you
will need to define a method to support serializing any kind of object, including the
standard JSON objects like booleans, integers, strings, etc.!

# JSONX - Simple JSON Parser

A simple, no-dependency JSON parser that can be vendored (copied/pasted) into other packages.

## Features

### Parsing
- `JSONX.parse(json_str::String)` - Parse a JSON string
- `JSONX.parse(bytes::AbstractVector{UInt8})` - Parse JSON from byte array
- `JSONX.parsefile(filename::String)` - Parse JSON from a file

### Writing
- `JSONX.json(value)` - Convert a Julia value to JSON string
- `JSONX.JSONText(str)` - `str` will be treated as raw JSON and inserted
  directly into the output.

### Supported Types

**Reading (JSON → Julia):**
- `null` → `nothing`
- `true`/`false` → `Bool`
- Numbers → `Int64` or `Float64` (integers without decimal/exponent → Int64, with overflow fallback to Float64)
- Strings → `String` (with full Unicode support)
- Arrays → `Vector{Any}`
- Objects → `Dict{String, Any}`

**Writing (Julia → JSON):**
- `nothing`/`missing` → `null`
- `Bool` → `true`/`false`
- `Number` → JSON number
- `AbstractString` → JSON string
- `AbstractVector`/`AbstractSet`/`Tuple` → JSON array
- `AbstractDict`/`NamedTuple` → JSON object
- `Symbol`/`Enum` → JSON string

### Unicode Support

JSONX includes full Unicode support:
- Proper Unicode escape sequence parsing (`\uXXXX`)
- UTF-16 surrogate pair handling
- Lone surrogate handling
- All standard JSON escape sequences (`\"`, `\\`, `\/`, `\b`, `\f`, `\n`, `\r`, `\t`)

## Usage

```julia
using JSONX

# Parse JSON
data = JSONX.parse("{\"name\":\"John\",\"age\":30}")
# Returns: Dict("name" => "John", "age" => 30.0)

# Parse from bytes
bytes = Vector{UInt8}("{\"key\":\"value\"}")
data = JSONX.parse(bytes)

# Parse from file
data = JSONX.parsefile("data.json")

# Write JSON
json_str = JSONX.json(Dict("a" => 1, "b" => 2))
# Returns: "{\"a\":1,\"b\":2}"

# Unicode examples
JSONX.parse("\"Hello 世界! 🌍\"")  # Full Unicode support
JSONX.parse("\"\\u0048\\u0065\\u006C\\u006C\\u006F\"")  # Unicode escapes
```

## Error Handling

JSONX provides detailed error messages for invalid JSON:
- Unexpected end of input
- Invalid escape sequences
- Malformed Unicode escapes
- Trailing commas
- Control characters in strings
- Invalid number formats

## Limitations

Compared to the full JSON.jl package, JSONX is intentionally simplified:

- **Limited numeric types**: Parses as Int64 or Float64 only (no BigInt/BigFloat for very large numbers)
- **No custom type parsing**: Only returns basic Julia types
- **No configuration options**: Uses fixed defaults
- **No streaming**: Loads entire input into memory
- **No pretty printing**: Output is compact only
- **No schema validation**: Basic JSON validation only
- **No performance optimizations**: Simple, readable implementation

## Implementation Notes

- **No dependencies**: Uses only Base Julia functionality
- **Byte-level processing**: Uses `codeunit` for accurate string handling
- **Memory efficient**: Avoids unnecessary string concatenation
- **Error robust**: Comprehensive error checking and reporting

Note: Functions are not exported, so use `JSONX.parse` and `JSONX.json` with the module prefix.

## Changelog

- Fixed unicode handling when unescaping strings (https://github.com/JuliaIO/JSON.jl/pull/405).
- **Breaking**: Added support for parsing Int64's (https://github.com/JuliaIO/JSON.jl/pull/396).
- Added `JSONText` (https://github.com/JuliaIO/JSON.jl/pull/394).

module JSON

# stdlibs
using Dates, UUIDs, Logging
# external dependencies
using PrecompileTools, Parsers, StructUtils

# reexport some StructUtils macros
import StructUtils: @noarg, @kwarg, @defaults, @tags, @choosetype, @nonstruct, lower, lift
export JSONText, StructUtils, @noarg, @kwarg, @defaults, @tags, @choosetype, @nonstruct, @omit_null, @omit_empty

# Mark documented API as `public` on Julia versions that support it (>= 1.11).
# Wrapped in `eval(Expr(...))` because `public` is a parse error on older versions.
@static if VERSION >= v"1.11"
    eval(Expr(:public,
        :parse, :parse!, :parsefile, :parsefile!,
        :lazy, :lazyfile, :LazyValue,
        :isvalidjson, :DuplicateKeyError,
        :json, :print,
        :lower, :lift,
        :omit_null, :omit_empty,
        :Object, :Null, :Omit, :JSONStyle,
    ))
end

"""
    JSON.DuplicateKeyError

Error thrown when `duplicate_keys=:error` encounters a repeated object key.
`key` is the decoded JSON key and `position` is its one-based byte position.
"""
struct DuplicateKeyError <: Exception
    key::String
    position::Int
end

function Base.showerror(io::IO, err::DuplicateKeyError)
    Base.print(io, "duplicate JSON object key ", repr(err.key), " at byte position ", err.position)
end

@enum Error InvalidJSON UnexpectedEOF ExpectedOpeningObjectChar ExpectedOpeningQuoteChar ExpectedOpeningArrayChar ExpectedClosingArrayChar ExpectedComma ExpectedColon ExpectedNewline InvalidChar InvalidNumber InvalidUTF16

@generated _typename(::Type{T}) where {T} = QuoteNode(string(T))

@noinline invalid(error, buf, pos::Int, ::Type{T}) where {T} =
    _invalid(error, buf, pos, _typename(T))
@noinline invalid(error, buf, pos::Int, typename::String) =
    _invalid(error, buf, pos, typename)

@noinline function _invalid(error, buf, pos::Int, typename::String)
    # compute which line the error falls on by counting “\n” bytes up to pos
    cus = buf isa AbstractString ? codeunits(buf) : buf
    line_no = count(b -> b == UInt8('\n'), view(cus, 1:pos)) + 1

    li = pos > 20 ? pos - 9 : 1
    ri = min(sizeof(cus), pos + 20)
    snippet_bytes = cus[li:ri]
    snippet_pos = pos - li + 1
    snippet = String(copy(snippet_bytes))
    # find error position; if snippet has multi-codepoint chars,
    # translate pos to char index, accounting for textwidth of char
    erri = 1
    st = iterate(snippet)
    while st !== nothing
        c, i = st
        i > snippet_pos && break
        erri += textwidth(c)
        st = iterate(snippet, i)
    end
    snippet = replace(snippet, r"[\b\f\n\r\t]" => " ")
    # we call @invoke here to avoid --trim verify errors
    caret = @invoke(repeat(" "::String, (erri + 2)::Integer)) * "^"
    msg = """
    invalid JSON at byte position $(pos) (line $line_no) parsing type $(typename): $error
    $snippet$(error == UnexpectedEOF ? " <EOF>" : "...")
    $caret
    """
    throw(ArgumentError(msg))
end

include("utils.jl")
include("object.jl")

# default object type for parse
const DEFAULT_OBJECT_TYPE = Object{String, Any}

"""
    JSON.JSONText

Wrapper around a string containing JSON data.
Can be used to insert raw JSON in JSON output, like:
```julia
json(JSONText("{\"key\": \"value\"}"))
```
This will output the JSON as-is, without escaping.
Note that no check is done to ensure that the JSON is valid.

Can also be used to read "raw JSON" when parsing, meaning
no specialized structure (JSON.Object, Vector{Any}, etc.) is created.
Example:
```julia
x = JSON.parse("[1,2,3]", JSONText)
# x.value == "[1,2,3]"
```
"""
struct JSONText
    value::String
end

include("lazy.jl")
include("parse.jl")
include("write.jl")

"""
    JSON.isvalidjson(json) -> Bool

Check if the given JSON is valid.
This function will return `true` if the JSON is valid, and `false` otherwise.
Inputs can be a string, a vector of bytes, or an IO stream, the same inputs
as supported for `JSON.lazy` and `JSON.parse`.
"""
function isvalidjson end

isvalidjson(io::Union{IO, Base.AbstractCmd}; kw...) = isvalidjson(Base.read(io); kw...)

function isvalidjson(buf::Union{AbstractVector{UInt8}, AbstractString}; kw...)
    try
        return isvalidjson(lazy(buf; kw...))
    catch
        return false
    end
end

function isvalidjson(x::LazyValue)
    try
        skip(x)
        return true
    catch
        return false
    end
end

# convenience aliases for pre-1.0 JSON compat
print(io::IO, obj, indent=nothing) = json(io, obj; pretty=something(indent, 0))
print(a, indent=nothing) = print(stdout, a, indent)

"See [`json`](@ref)."
print

# typed-parse workload struct: exercising one struct with the common field
# shapes caches the shared make/lift/array-chain inference in this package's
# image, so downstream typed parses hit those caches instead of re-inferring
# (which also keeps `juliac --trim` edge inference precise on nested families)
struct _WorkloadInner
    x::Int
    y::Float64
end
struct _Workload
    item::Union{Nothing,_WorkloadInner}
    items::Vector{_WorkloadInner}
    tags::Vector{String}
    note::Union{Nothing,String}
end

@compile_workload begin
    x = JSON.parse("{\"a\": 1, \"b\": null, \"c\": true, \"d\": false, \"e\": \"\", \"f\": [1,null,true], \"g\": {\"key\": \"value\"}}")
    json = JSON.json(x)
    isvalidjson(json)
    JSON.parse(
        "{\"item\":{\"x\":1,\"y\":2.0},\"items\":[{\"x\":3,\"y\":4.0}],\"tags\":[\"p\"],\"note\":null}",
        _Workload,
    )
end


end # module

module JSONArrowExt

using JSON, ArrowTypes

const JSON_ARROW_NAME = Symbol("JuliaLang.JSON.Object")

ArrowTypes.ArrowKind(::Type{<:JSON.Object}) = ArrowTypes.StructKind()

ArrowTypes.toarrow(x::JSON.Object) = (; x...)
ArrowTypes.arrowname(::Type{<:JSON.Object}) = JSON_ARROW_NAME
ArrowTypes.JuliaType(::Val{JSON_ARROW_NAME}) = JSON.Object{Symbol,Any}

ArrowTypes.fromarrowstruct(::Type{T}, ::Val{nms}, vals...) where {T <: JSON.Object, nms} =
    T(nms[i] => vals[i] for i in 1:length(nms))

ArrowTypes.ToArrow(x::AbstractArray{T}) where {T <: JSON.Object} = _toarrow(x)
ArrowTypes.ToArrow(x::AbstractArray{Union{T,Missing}}) where {T <: JSON.Object} = _toarrow(x)
ArrowTypes.ToArrow(x::JSON.Object) = toarrow(x)

function _toarrow(x::Union{AbstractArray{T}, AbstractArray{Union{T,Missing}}}) where {T<:JSON.Object}
    isempty(x) && return Missing[]
    x isa AbstractArray{Missing} && return x
    fields = JSON.Object{Symbol, Type}()
    seen_fields = Set{Symbol}()
    for (i, y) in enumerate(x)
        y === missing && continue
        current_fields = Set{Symbol}()
        for (k, vv) in y
            key = Symbol(k)
            push!(current_fields, key)
            v = toarrow(vv)
            vtype = typeof(v)
            existing_type = get(fields, key, nothing)
            if existing_type !== nothing
                if !(vtype <: existing_type)
                    fields[key] = ArrowTypes.promoteunion(existing_type, vtype)
                end
            else
                if i == 1
                    fields[key] = vtype
                else
                    fields[key] = Union{vtype, Missing}
                end
            end
        end
        for field in seen_fields
            if !(field in current_fields)
                existing_type = fields[field]
                if !(Missing <: existing_type)
                    fields[field] = Union{existing_type, Missing}
                end
            end
        end
        union!(seen_fields, current_fields)
    end
    for y in x
        obj = toarrow(y)
        obj === missing && continue
        for (field, _) in fields
            if !haskey(obj, field)
                existing_type = fields[field]
                if !(Missing <: existing_type)
                    fields[field] = Union{existing_type, Missing}
                end
            end
        end
    end
    nms = Tuple(keys(fields))
    NT = NamedTuple{nms, Tuple{values(fields)...}}
    return ArrowTypes.ToArrow{NT,typeof(x)}(x)
end

function ArrowTypes._convert(::Type{NamedTuple{nms,T}}, nt) where {nms,T}
    vals = Tuple((nt !== missing && haskey(nt, nm)) ? toarrow(getproperty(nt, nm)) : missing for nm in nms)
    return NamedTuple{nms,T}(vals)
end

end # module

struct JSONWriteStyle <: JSONStyle end

"""
    JSON.Null()

Singleton sentinel that always serializes as the JSON literal `null`,
even when `omit_null=true` at the struct or callsite level. Useful for
per-field overrides (e.g. `Union{Nothing, JSON.Null}`) or custom field
lowering that must force a `null` emission.
"""
struct Null end

"""
    JSON.Omit()

Singleton sentinel that removes the enclosing value from the JSON output,
regardless of `omit_null` / `omit_empty` settings. Valid within objects
and arrays; using it as the root value throws an error.
"""
struct Omit end

sizeguess(::Nothing) = 4
sizeguess(x::Bool) = 5
sizeguess(x::Integer) = 20
sizeguess(x::AbstractFloat) = 20
sizeguess(x::Union{Float16, Float32, Float64}) = Base.Ryu.neededdigits(typeof(x))
sizeguess(x::AbstractString) = 2 + sizeof(x)
sizeguess(::Null) = 4
sizeguess(::Omit) = 0
sizeguess(_) = 512

const StringLike = Union{Enum, AbstractChar, VersionNumber, Cstring, Cwstring, UUID, Dates.TimeType, Type, Logging.LogLevel}

# Date, DateTime, and Time serialize as exactly `string(x)`, but through
# fixed-format printers instead of the Dates format machinery: DateFormat
# token handling and its diagnostics are too dynamic for static compilation,
# so JSON output of temporal fields would otherwise fail `juliac --trim`
# verification.
@inline function _writetemporal!(buf::Vector{UInt8}, i::Int, value::Integer, width::Int)
    for offset in (width - 1):-1:0
        buf[i + offset] = UInt8('0') + UInt8(value % 10)
        value = divrem(value, 10)[1]
    end
    return i + width
end

function _datestring!(buf::Vector{UInt8}, i::Int, x::Dates.Date)
    y = Dates.year(x)
    if y < 0
        buf[i] = UInt8('-')
        i += 1
        y = -y
    end
    i = _writetemporal!(buf, i, y, max(4, ndigits(y)))
    buf[i] = UInt8('-')
    i = _writetemporal!(buf, i + 1, Dates.month(x), 2)
    buf[i] = UInt8('-')
    return _writetemporal!(buf, i + 1, Dates.day(x), 2)
end

function _lowerdate(x::Dates.Date)
    y = Dates.year(x)
    buf = Vector{UInt8}(undef, 6 + max(4, ndigits(abs(y))) + (y < 0 ? 1 : 0))
    _datestring!(buf, 1, x)
    return String(buf)
end

function _timestring!(buf::Vector{UInt8}, i::Int, x::Dates.Time)
    i = _writetemporal!(buf, i, Dates.hour(x), 2)
    buf[i] = UInt8(':')
    i = _writetemporal!(buf, i + 1, Dates.minute(x), 2)
    buf[i] = UInt8(':')
    i = _writetemporal!(buf, i + 1, Dates.second(x), 2)
    # `string(::Time)` prints the shortest subsecond field that loses
    # nothing — milliseconds, microseconds, or nanoseconds — and then strips
    # the fraction's trailing zeros.
    ms, us, ns = Dates.millisecond(x), Dates.microsecond(x), Dates.nanosecond(x)
    if ns != 0
        fraction, width = ms * 1_000_000 + us * 1_000 + ns, 9
    elseif us != 0
        fraction, width = ms * 1_000 + us, 6
    elseif ms != 0
        fraction, width = ms, 3
    else
        return i
    end
    while fraction % 10 == 0
        fraction = divrem(fraction, 10)[1]
        width -= 1
    end
    buf[i] = UInt8('.')
    return _writetemporal!(buf, i + 1, fraction, width)
end

function _lowertime(x::Dates.Time)
    n = Dates.nanosecond(x) != 0 ? 18 :
        Dates.microsecond(x) != 0 ? 15 :
        Dates.millisecond(x) != 0 ? 12 : 8
    buf = Vector{UInt8}(undef, n)
    return String(resize!(buf, _timestring!(buf, 1, x) - 1))
end

function _lowerdatetime(x::Dates.DateTime)
    d = Dates.Date(x)
    y = Dates.year(d)
    ms = Dates.millisecond(x)
    n = 6 + max(4, ndigits(abs(y))) + (y < 0 ? 1 : 0) + 9 + (ms != 0 ? 4 : 0)
    buf = Vector{UInt8}(undef, n)
    i = _datestring!(buf, 1, d)
    buf[i] = UInt8('T')
    i = _writetemporal!(buf, i + 1, Dates.hour(x), 2)
    buf[i] = UInt8(':')
    i = _writetemporal!(buf, i + 1, Dates.minute(x), 2)
    buf[i] = UInt8(':')
    i = _writetemporal!(buf, i + 1, Dates.second(x), 2)
    # `string(::DateTime)` omits the fraction entirely at zero milliseconds
    # and always prints three digits otherwise.
    if ms != 0
        buf[i] = UInt8('.')
        _writetemporal!(buf, i + 1, ms, 3)
    end
    return String(buf)
end

StructUtils.lower(::JSONStyle, ::Missing) = nothing
StructUtils.lower(::JSONStyle, x::Symbol) = String(x)
StructUtils.lower(::JSONStyle, x::StringLike) = string(x)
StructUtils.lower(::JSONStyle, x::Dates.Date) = _lowerdate(x)
StructUtils.lower(::JSONStyle, x::Dates.Time) = _lowertime(x)
StructUtils.lower(::JSONStyle, x::Dates.DateTime) = _lowerdatetime(x)
StructUtils.lower(::JSONStyle, x::Regex) = x.pattern
StructUtils.lower(::JSONStyle, x::Complex) = (re=real(x), im=imag(x))
StructUtils.lower(::JSONStyle, x::AbstractArray{<:Any,0}) = x[1]
StructUtils.lower(::JSONStyle, x::AbstractArray{<:Any, N}) where {N} = (view(x, ntuple(_ -> :, N - 1)..., j) for j in axes(x, N))
StructUtils.lower(::JSONStyle, x::AbstractVector) = x
StructUtils.arraylike(::JSONStyle, x::AbstractVector{<:Pair}) = false
StructUtils.structlike(::JSONStyle, ::Type{<:NamedTuple}) = true

# for pre-1.0 compat, which serialized Tuple object keys by default
StructUtils.lowerkey(::JSONStyle, x::Tuple) = string(x)

"""
    JSON.omit_null(::Type{T})::Bool
    JSON.omit_null(::JSONStyle, ::Type{T})::Bool
    
Controls whether struct fields that are undefined or are `nothing` are included in the JSON output.
Returns `false` by default, meaning all fields are included, regardless of undef or `nothing`. To instead
ensure only *non-null* fields are written, set this to `true`.
This can also be controlled via the `omit_null` keyword argument in [`JSON.json`](@ref).

```julia
# Override for a specific type
JSON.omit_null(::Type{MyStruct}) = true

# Override for a custom style
struct MyStyle <: JSON.JSONStyle end
JSON.omit_null(::MyStyle, ::Type{T}) where {T} = true
```
"""
omit_null(::Type{T}) where {T} = false
omit_null(::JSONStyle, ::Type{T}) where {T} = omit_null(T)

"""
    @omit_null struct T ...
    @omit_null T

Convenience macro to set `omit_null(::Type{T})` to `true` for the struct `T`.
Can be used in three ways:
1. In front of a struct definition: `@omit_null struct T ... end`
2. Applied to an existing struct name: `@omit_null T`
3. Chained with other macros: `@omit_null @defaults struct T ... end`

The macro automatically handles complex macro expansions by walking the expression
tree to find struct definitions, making it compatible with macros like `StructUtils.@defaults`.

# Examples
```julia
# Method 1: Struct annotation
@omit_null struct Person
    name::String
    email::Union{Nothing, String}
end

# Method 2: Apply to existing struct
struct User
    id::Int
    profile::Union{Nothing, String}
end
@omit_null User

# Method 3: Chain with @defaults
@omit_null @defaults struct Employee
    name::String = "Anonymous"
    manager::Union{Nothing, String} = nothing
end
```
"""
macro omit_null(expr)
    return _omit_macro_impl(expr, :omit_null, __module__)
end

"""
    JSON.omit_empty(::Type{T})::Bool
    JSON.omit_empty(::JSONStyle, ::Type{T})::Bool

Controls whether struct fields that are empty are included in the JSON output.
Returns `false` by default, meaning empty fields *are* included. To instead exclude empty fields,
set this to `true`. A field is considered empty if it is `nothing`, an empty collection
(empty array, dict, string, tuple, or named tuple), or `missing`.
This can also be controlled via the `omit_empty` keyword argument in [`JSON.json`](@ref).

```julia
# Override for a specific type
JSON.omit_empty(::Type{MyStruct}) = true

# Override for a custom style
struct MyStyle <: JSON.JSONStyle end
JSON.omit_empty(::MyStyle, ::Type{T}) where {T} = true
```
"""
omit_empty(::Type{T}) where {T} = false
omit_empty(::JSONStyle, ::Type{T}) where {T} = omit_empty(T)

is_empty(x) = false
is_empty(::Nothing) = true
is_empty(x::Union{AbstractDict, AbstractArray, AbstractString, Tuple, NamedTuple}) = Base.isempty(x)

"""
    @omit_empty struct T ...
    @omit_empty T

Convenience macro to set `omit_empty(::Type{T})` to `true` for the struct `T`.
Can be used in three ways:
1. In front of a struct definition: `@omit_empty struct T ... end`
2. Applied to an existing struct name: `@omit_empty T`
3. Chained with other macros: `@omit_empty @other_macro struct T ... end`
"""
macro omit_empty(expr)
    return _omit_macro_impl(expr, :omit_empty, __module__)
end

# Helper function to generate the appropriate type signature for omit functions
function _make_omit_type_sig(T, is_parametric)
    if is_parametric
        # For parametric types, use <: to match all instantiations
        return :(<:$T)
    else
        return T
    end
end

# Helper function for both @omit_null and @omit_empty macros
function _omit_macro_impl(expr, omit_func_name, module_context)
    original_expr = expr
    expr = macroexpand(module_context, expr)
    # Case 1: Just a type name (Symbol or more complex type expression)
    if isa(expr, Symbol) || (Meta.isexpr(expr, :curly) || Meta.isexpr(expr, :where))
        # Extract the base type name
        T, is_parametric = _extract_type_name(expr)
        type_sig = _make_omit_type_sig(T, is_parametric)
        return esc(quote
            JSON.$omit_func_name(::Type{$type_sig}) = true
        end)
    end
    # Case 2: Struct definition (possibly from macro expansion)
    if Meta.isexpr(expr, :struct)
        ismutable, T, fieldsblock = expr.args
        T, is_parametric = _extract_type_name(T)
        type_sig = _make_omit_type_sig(T, is_parametric)
        return esc(quote
            # insert original expr as-is
            $expr
            # omit function overload
            JSON.$omit_func_name(::Type{$type_sig}) = true
        end)
    end
    # Case 3: Block expression (from complex macros like @defaults)
    if Meta.isexpr(expr, :block)
        # Try to find a struct definition in the block
        struct_expr = _find_struct_in_block(expr)
        if struct_expr !== nothing
            ismutable, T, fieldsblock = struct_expr.args
            T, is_parametric = _extract_type_name(T)
            type_sig = _make_omit_type_sig(T, is_parametric)
            return esc(quote
                # insert original expr as-is
                $original_expr
                # omit function overload
                JSON.$omit_func_name(::Type{$type_sig}) = true
            end)
        end
    end
    # Case 4: Macro expression that we hope expands to a struct
    if Meta.isexpr(original_expr, :macrocall)
        # Try to see if the expanded form is a struct
        if Meta.isexpr(expr, :struct)
            ismutable, T, fieldsblock = expr.args
            T, is_parametric = _extract_type_name(T)
            type_sig = _make_omit_type_sig(T, is_parametric)
            return esc(quote
                # insert original expr as-is
                $original_expr
                # omit function overload
                JSON.$omit_func_name(::Type{$type_sig}) = true
            end)
        else
            throw(ArgumentError("Macro $(original_expr.args[1]) did not expand to a struct definition"))
        end
    end
    throw(ArgumentError("Invalid usage of @$omit_func_name macro. Expected: struct definition, type name, or macro that expands to struct definition"))
end

# Helper function to recursively find a struct definition in a block expression
function _find_struct_in_block(expr)
    if Meta.isexpr(expr, :struct)
        return expr
    elseif Meta.isexpr(expr, :block)
        for arg in expr.args
            result = _find_struct_in_block(arg)
            if result !== nothing
                return result
            end
        end
    end
    return nothing
end

# Helper function to extract the base type name from various type expressions
# Returns (base_type, is_parametric) tuple
function _extract_type_name(T)
    if isa(T, Symbol)
        return (T, false)
    elseif Meta.isexpr(T, :<:)
        # Handle subtyping: struct Foo <: Bar
        return _extract_type_name(T.args[1])
    elseif Meta.isexpr(T, :curly)
        # Handle parametric types: return just the base type name (e.g., Foo from Foo{T})
        # and indicate it's parametric
        return (T.args[1], true)
    elseif Meta.isexpr(T, :where)
        # Handle where clauses: struct Foo{T} where T
        return _extract_type_name(T.args[1])
    else
        return (T, false)
    end
end

StructUtils.lowerkey(::JSONStyle, s::AbstractString) = s
StructUtils.lowerkey(::JSONStyle, sym::Symbol) = String(sym)
StructUtils.lowerkey(::JSONStyle, s::Union{StringLike, Real}) = string(s)
StructUtils.lowerkey(::JSONStyle, x) = throw(ArgumentError("No key representation for $(typeof(x)). Define StructUtils.lowerkey(::JSON.JSONStyle, ::$(typeof(x)))"))
"""
    JSON.json(x) -> String
    JSON.json(io, x)
    JSON.json(file_name, x)

Serialize `x` to JSON format. The 1st method takes just the object and returns a `String`.
In the 2nd method, `io` is an `IO` object, and the JSON output will be written to it.
For the 3rd method, `file_name` is a `String`, a file will be opened and the JSON output will be written to it.

All methods accept the following keyword arguments:

- `omit_null::Union{Bool, Nothing}=nothing`: Controls whether struct fields that are undefined or are `nothing` are included in the JSON output.
  If `true`, only non-null fields are written. If `false`, all fields are included regardless of being undefined or `nothing`.
  If `nothing`, the behavior is determined by `JSON.omit_null(::Type{T})`, which is `false` by default.

- `omit_empty::Union{Bool, Nothing}=nothing`: Controls whether struct fields that are empty are included in the JSON output.
  If `true`, empty fields are excluded. If `false`, empty fields are included.
  If `nothing`, the behavior is determined by `JSON.omit_empty(::Type{T})`.

- `JSON.Null()` / `JSON.Omit()` sentinels: `JSON.Null()` always emits a JSON `null`
  literal even when `omit_null=true`, enabling per-field overrides (for example by
  declaring a field as `Union{Nothing, JSON.Null}`) or defining a custom `lower` function for a field that returns `JSON.Null`.
  `JSON.Omit()` removes the enclosing value from the output regardless of global omit settings, making it easy for field-level
  lowering code to drop optional data entirely. For example, by defining a custom `lower` function for a field that returns `JSON.Omit`.
    
- `allownan::Bool=false`: If `true`, allow `Inf`, `-Inf`, and `NaN` in the output.
  If `false`, throw an error if `Inf`, `-Inf`, or `NaN` is encountered.

- `jsonlines::Bool=false`: If `true`, input must be array-like and the output will be written in the JSON Lines format,
  where each element of the array is written on a separate line (i.e. separated by a single newline character '\`\\n\`').
  If `false`, the output will be written in the standard JSON format.

- `pretty::Union{Integer,Bool}=false`: Controls pretty printing of the JSON output.
  If `true`, the output will be pretty-printed with 2 spaces of indentation.
  If an integer, it will be used as the number of spaces of indentation.
  If `false` or `0`, the output will be compact.
  Note: Pretty printing is not supported when `jsonlines=true`.

- `sort_keys::Union{Bool, Nothing}=nothing`: Controls whether dictionary keys are sorted before writing.
  If `true`, keys for all `AbstractDict` objects are sorted by their lowered string representation.
  If `false`, dictionary iteration order is preserved. If `nothing`, plain `Dict` keys are sorted
  by default while other dictionary-like containers preserve their iteration order.

- `inline_limit::Int=0`: For arrays shorter than this limit, pretty printing will be disabled (indentation set to 0).

- `ninf::String="-Infinity"`: Custom string representation for negative infinity.

- `inf::String="Infinity"`: Custom string representation for positive infinity.

- `nan::String="NaN"`: Custom string representation for NaN.

- `float_style::Symbol=:shortest`: Controls how floating-point numbers are formatted.
  Options are:
  - `:shortest`: Use the shortest representation that preserves the value
  - `:fixed`: Use fixed-point notation
  - `:exp`: Use exponential notation

- `float_precision::Int=1`: Number of decimal places to use when `float_style` is `:fixed` or `:exp`.

- `bufsize::Int=2^22`: Buffer size in bytes for IO operations. When writing to IO, the buffer will be flushed 
  to the IO stream once it reaches this size. This helps control memory usage during large write operations.
  Default is 4MB (2^22 bytes). This parameter is ignored when returning a String.

- `style::JSONStyle=JSONWriteStyle()`: Custom style object that controls serialization behavior. This allows customizing
    certain aspects of serialization, like defining a custom `lower` method for a non-owned type. Like `struct MyStyle <: JSONStyle end`,
    `JSON.lower(x::Rational) = (num=x.num, den=x.den)`, then calling `JSON.json(1//3; style=MyStyle())` will output
    `{"num": 1, "den": 3}`.

By default, `x` must be a JSON-serializable object. Supported types include:
  * `AbstractString` => JSON string: types must support the `AbstractString` interface, specifically with support for
    `ncodeunits` and `codeunit(x, i)`.
  * `Bool` => JSON boolean: must be `true` or `false`
  * `Nothing` => JSON null: must be the `nothing` singleton value
  * `Number` => JSON number: `Integer` subtypes or `Union{Float16, Float32, Float64}` have default implementations
    for other `Number` types, [`JSON.tostring`](@ref) is first called to convert
    the value to a `String` before being written directly to JSON output
  * `AbstractArray`/`Tuple`/`AbstractSet` => JSON array: objects for which `JSON.arraylike` returns `true`
     are output as JSON arrays. `arraylike` is defined by default for
    `AbstractArray`, `AbstractSet`, `Tuple`, and `Base.Generator`. For other types that define,
    they must also properly implement `StructUtils.applyeach` to iterate over the index => elements pairs.
    Note that arrays with dimensionality > 1 are written as nested arrays, with `N` nestings for `N` dimensions,
    and the 1st dimension is always the innermost nested JSON array (column-major order).
  * `AbstractDict`/`NamedTuple`/structs => JSON object: if a value doesn't fall into any of the above categories,
    it is output as a JSON object. `StructUtils.applyeach` is called, which has appropriate implementations
    for `AbstractDict`, `NamedTuple`, and structs, where field names => values are iterated over. Field names can
    be output with an alternative name via field tag overload, like `field::Type &(json=(name="alternative_name",),)`

If an object is not JSON-serializable, an override for `JSON.lower` can
be defined to convert it to a JSON-serializable object. Some default `lower` defintions
are defined in JSON itself, for example:
  * `StructUtils.lower(::Missing) = nothing`
  * `StructUtils.lower(x::Symbol) = String(x)`
  * `StructUtils.lower(x::Union{Enum, AbstractChar, VersionNumber, Cstring, Cwstring, UUID, Dates.TimeType}) = string(x)`
  * `StructUtils.lower(x::Regex) = x.pattern`

These allow common Base/stdlib types to be serialized in an expected format.

Circular references are tracked automatically and cycles are broken by writing `null` for any children references.

For pre-formatted JSON data as a String, use `JSONText(json)` to write the string out as-is.

For `AbstractDict` objects with non-string keys, `StructUtils.lowerkey` will be called before serializing. This allows aggregate
or other types of dict keys to be converted to an appropriate string representation. See `StructUtils.liftkey`
for the reverse operation, which is called when parsing JSON data back into a dict type.

*NOTE*: `JSON.json` should _not_ be overloaded directly by custom
types as this isn't robust for various output options (IO, String, etc.)
nor recursive situations. Types should define an appropriate
`JSON.lower` definition instead.

*NOTE*: `JSON.json(str, indent::Integer)` is special-cased for backwards compatibility with pre-1.0 JSON.jl,
as this typically would mean "write out the `indent` integer to file `str`". As writing out a single integer to
a file is extremely rare, it was decided to keep the pre-1.0 behavior for compatibility reasons.

Examples:
```julia
using Dates

abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

struct Percent <: Number
    value::Float64
end

JSON.lower(x::Percent) = x.value
StructUtils.lowerkey(x::Percent) = string(x.value)

@noarg mutable struct FrankenStruct
    id::Int
    name::String # no default to show serialization of an undefined field
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = JSON.Object("key" => "value")
    monster::AbstractMonster = Dracula(10) &(json=(lower=x -> x isa Dracula ? (monster_type="vampire", num_victims=x.num_victims) : (monster_type="werewolf", witching_hour=x.witching_hour),),)
    percent::Percent = Percent(0.5)
    birthdate::Date = Date(2025, 1, 1) &(json=(dateformat="yyyy/mm/dd",),)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}(Percent(0.0) => 0, Percent(1.0) => 1)
    json_properties::JSONText = JSONText("{\"key\": \"value\"}")
    matrix::Matrix{Float64} = [1.0 2.0; 3.0 4.0]
    extra_field::Any = nothing &(json=(ignore=true,),)
end

franken = FrankenStruct()
franken.id = 1

json = JSON.json(franken; omit_null=false)
# "{\"id\":1,\"name\":null,\"address\":null,\"rate\":null,\"franken_type\":\"a\",\"notsure\":{\"key\":\"value\"},\"monster\":{\"monster_type\":\"vampire\",\"num_victims\":10},\"percent\":0.5,\"birthdate\":\"2025/01/01\",\"percentages\":{\"1.0\":1,\"0.0\":0},\"json_properties\":{\"key\": \"value\"},\"matrix\":[[1.0,3.0],[2.0,4.0]]}"
```

A few comments on the JSON produced in the example above:
  - The `name` field was `#undef`, and thus was serialized as `null`.
  - The `address` and `rate` fields were `nothing` and `missing`, respectively, and thus were serialized as `null`.
  - The `type` field has a `name` field tag, so the JSON key for this field is `franken_type` instead of `type`.
  - The `notsure` field is a `JSON.Object`, so it is serialized as a JSON object.
  - The `monster` field is a `AbstractMonster`, which is a custom type. It has a `lower` field tag that specifies how the value of this field specifically (not all AbstractMonster) should be serialized
  - The `percent` field is a `Percent`, which is a custom type. It has a `lower` method that specifies how `Percent` values should be serialized
  - The `birthdate` field has a `dateformat` field tag, so the value follows the format (`yyyy/mm/dd`) instead of the default date ISO format (`yyyy-mm-dd`)
  - The `percentages` field is a `Dict{Percent, Int}`, which is a custom type. It has a `lowerkey` method that specifies how `Percent` keys should be serialized as strings
  - The `json_properties` field is a `JSONText`, so the JSONText value is serialized as-is
  - The `matrix` field is a `Matrix{Float64}`, which is a custom type. It is serialized as a JSON array, with the first dimension being the innermost nested JSON array (column-major order)
  - The `extra_field` field has a `ignore` field tag, so it is skipped when serializing

"""
function json end

@kwdef struct WriteOptions{S}
    omit_null::Union{Bool, Nothing} = nothing
    omit_empty::Union{Bool, Nothing} = nothing
    allownan::Bool = false
    jsonlines::Bool = false
    pretty::Int = 0
    ninf::String = "-Infinity"
    inf::String = "Infinity"
    nan::String = "NaN"
    inline_limit::Int = 0
    float_style::Symbol = :shortest # :shortest, :fixed, :exp
    float_precision::Int = 1
    sort_keys::Union{Bool, Nothing} = nothing
    bufsize::Int = 2^22 # 4MB default buffer size for IO flushing
    style::S = JSONWriteStyle()
end

@noinline float_style_throw(fs) = throw(ArgumentError("Invalid float style: $fs"))
float_style_check(fs) = fs == :shortest || fs == :fixed || fs == :exp || float_style_throw(fs)

@noinline float_precision_throw(fs, fp) = throw(ArgumentError("float_precision must be positive when float_style is $fs; got $fp"))
float_precision_check(fs, fp) = (fs == :shortest || fp > 0) || float_precision_throw(fs, fp)

# if jsonlines and pretty is not 0 or false, throw an ArgumentError
@noinline _jsonlines_pretty_throw() = throw(ArgumentError("pretty printing is not supported when writing jsonlines"))
_jsonlines_pretty_check(jsonlines, pretty) = jsonlines && pretty !== false && !iszero(pretty) && _jsonlines_pretty_throw()
@noinline _root_omit_throw() = throw(ArgumentError("JSON.Omit() is only valid inside arrays or objects"))

function json(io::IO, x::T; pretty::Union{Integer,Bool}=false, kw...) where {T}
    opts = WriteOptions(; pretty=pretty === true ? 2 : Int(pretty), kw...)
    _jsonlines_pretty_check(opts.jsonlines, opts.pretty)
    float_style_check(opts.float_style)
    float_precision_check(opts.float_style, opts.float_precision)
    y = StructUtils.lower(opts.style, x)
    # Use smaller initial buffer size, limited by bufsize
    initial_size = min(sizeguess(y), opts.bufsize)
    buf = Vector{UInt8}(undef, initial_size)
    pos = json!(buf, 1, y, opts, Any[y], io)
    # Write any remaining buffer contents to IO
    if pos > 1
        write(io, view(buf, 1:pos-1))
    end
    return nothing
end

if isdefined(Base, :StringVector)
    stringvec(n) = Base.StringVector(n)
else
    stringvec(n) = Vector{UInt8}(undef, n)
end

function json(x; pretty::Union{Integer,Bool}=false, kw...)
    opts = WriteOptions(; pretty=pretty === true ? 2 : Int(pretty), kw...)
    _jsonlines_pretty_check(opts.jsonlines, opts.pretty)
    float_style_check(opts.float_style)
    float_precision_check(opts.float_style, opts.float_precision)
    y = StructUtils.lower(opts.style, x)
    buf = stringvec(sizeguess(y))
    pos = json!(buf, 1, y, opts, Any[y], nothing)
    return String(resize!(buf, pos - 1))
end

function json(fname, obj; kw...)
    if obj isa Integer
        # special-case for pre-1.0 JSON compat
        return json(fname; pretty=obj)
    else
        @assert fname isa AbstractString "filename must be a string"
    end
    open(fname, "w") do io
        json(io, obj; kw...)
    end
    return fname
end

# we use the same growth strategy as Base julia does for array growing
# which starts with small N at ~5x and approaches 1.125x as N grows
# ref: https://github.com/JuliaLang/julia/pull/40453
newlen(n₀) = ceil(Int, n₀ + 4*n₀^(7 / 8) + n₀ / 8)

macro checkn(n, force_resize=false)
    esc(quote
        if (pos + $n - 1) > length(buf)
            # If we have an IO object and buffer would exceed bufsize, flush to IO first
            # unless force_resize is true (used for comma writing to avoid flushing partial JSON)
            if io !== nothing && length(buf) >= bufsize && pos > 1 && !$force_resize
                write(io, view(buf, 1:pos-1))
                pos = 1
            end
            # Resize buffer if still needed
            if (pos + $n - 1) > length(buf)
                resize!(buf, newlen(pos + $n))
            end
        end
    end)
end

struct WriteClosure{JS, arraylike, T, I} # T is the type of the parent object/array being written
    buf::Vector{UInt8}
    pos::Ptr{Int}
    wroteany::Ptr{Bool} # to track if we wrote any data to the buffer
    indent::Int
    depth::Int
    opts::JS
    ancestor_stack::Vector{Any} # to track circular references
    io::I
    bufsize::Int
end

function indent(buf, pos, ind, depth, io, bufsize)
    if ind > 0
        n = ind * depth + 1
        @checkn n
        buf[pos] = UInt8('\n')
        for i = 1:(n - 1)
            buf[pos + i] = UInt8(' ')
        end
        pos += n
    end
    return pos
end

checkkey(s) = s isa AbstractString || throw(ArgumentError("Value returned from `StructUtils.lowerkey` must be a string: $(typeof(s))"))

_sort_keys_by_default(x) = x isa Dict

function (f::WriteClosure{JS, arraylike, T, I})(key, val) where {JS, arraylike, T, I}
    track_ref = ismutabletype(typeof(val))
    is_circ_ref = track_ref && any(x -> x === val, f.ancestor_stack)
    val isa Omit && return
    if !arraylike
        # for objects, check omit_null/omit_empty
        # and skip if the value is null or empty
        if f.opts.omit_null === true || (f.opts.omit_null === nothing && omit_null(f.opts.style, T))
            (is_circ_ref || val === nothing) && return
        end
        if f.opts.omit_empty === true || (f.opts.omit_empty === nothing && omit_empty(f.opts.style, T))
            (is_circ_ref || is_empty(val)) && return
        end
    end
    pos = unsafe_load(f.pos)
    unsafe_store!(f.wroteany, true) # at this point, we know something will be written
    buf = f.buf
    ind = f.indent
    io = f.io
    bufsize = f.bufsize
    pos = indent(buf, pos, ind, f.depth, io, bufsize)
    # if not an array, we need to write the key + ':'
    if !arraylike
        # skey = StructUtils.lowerkey(f.opts, key)
        # check if the key is a string
        checkkey(key)
        pos = _string(buf, pos, key, io, bufsize)
        @checkn 1
        buf[pos] = UInt8(':')
        pos += 1
        if ind > 0
            @checkn 1
            buf[pos] = UInt8(' ')
            pos += 1
        end
    end
    # check if the lowered value is in our ancestor stack
    if is_circ_ref
        # if so, it's a circular reference! so we just write `null`
        pos = _null(buf, pos, io, bufsize)
    else
        track_ref && push!(f.ancestor_stack, val)
        # if jsonlines, we need to recursively set to false
        if f.opts.jsonlines
            opts = WriteOptions(; omit_null=f.opts.omit_null, omit_empty=f.opts.omit_empty, allownan=f.opts.allownan, jsonlines=false, pretty=f.opts.pretty, ninf=f.opts.ninf, inf=f.opts.inf, nan=f.opts.nan, inline_limit=f.opts.inline_limit, float_style=f.opts.float_style, float_precision=f.opts.float_precision, sort_keys=f.opts.sort_keys)
        else
            opts = f.opts
        end
        pos = json!(buf, pos, val, opts, f.ancestor_stack, io, ind, f.depth, bufsize)
        track_ref && pop!(f.ancestor_stack)
    end
    @checkn 1 true
    @inbounds buf[pos] = f.opts.jsonlines ? UInt8('\n') : UInt8(',')
    pos += 1
    # store our updated pos
    unsafe_store!(f.pos, pos)
    return
end

@noinline throwjsonlines() = throw(ArgumentError("jsonlines only supported for arraylike"))

# assume x is lowered value
function json!(buf, pos, x, opts::WriteOptions, ancestor_stack::Union{Nothing, Vector{Any}}=nothing, io::Union{Nothing, IO}=nothing, ind::Int=opts.pretty, depth::Int=0, bufsize::Int=opts.bufsize)
    # string
    if x isa Omit
        _root_omit_throw()
    elseif x isa Null
        return _null(buf, pos, io, bufsize)
    elseif x isa AbstractString
        return _string(buf, pos, x, io, bufsize)
    # write JSONText out directly
    elseif x isa JSONText
        val = x.value
        @checkn sizeof(val)
        for i = 1:sizeof(val)
            @inbounds buf[pos + i - 1] = codeunit(val, i)
        end
        return pos + sizeof(val)
    # bool; check before Number since Bool <: Number
    elseif x isa Bool
        if x
            @checkn 4
            @inbounds buf[pos] = 't'
            @inbounds buf[pos + 1] = 'r'
            @inbounds buf[pos + 2] = 'u'
            @inbounds buf[pos + 3] = 'e'
            return pos + 4
        else
            @checkn 5
            @inbounds buf[pos] = 'f'
            @inbounds buf[pos + 1] = 'a'
            @inbounds buf[pos + 2] = 'l'
            @inbounds buf[pos + 3] = 's'
            @inbounds buf[pos + 4] = 'e'
            return pos + 5
        end
    # number
    elseif x isa Number
        return _number(buf, pos, x, opts, io, bufsize)
    # null
    elseif x === nothing
        return _null(buf, pos, io, bufsize)
    # object or array
    elseif StructUtils.dictlike(opts.style, x) || StructUtils.arraylike(opts.style, x) || StructUtils.structlike(opts.style, x)
        al = StructUtils.arraylike(opts.style, x)
        # override pretty indent to 0 for arrays shorter than inline_limit
        if al && opts.pretty > 0 && opts.inline_limit > 0 && length(x) < opts.inline_limit
            local_ind = 0
        else
            local_ind = ind
        end
        if !opts.jsonlines
            @checkn 1
            @inbounds buf[pos] = al ? UInt8('[') : UInt8('{')
            pos += 1
        else
            al || throwjsonlines()
        end
        ref = Ref(pos)
        wroteany = false
        wroteanyref = Ref(false)
        GC.@preserve ref wroteanyref begin
            c = WriteClosure{typeof(opts), al, typeof(x), typeof(io)}(buf, Base.unsafe_convert(Ptr{Int}, ref), Base.unsafe_convert(Ptr{Bool}, wroteanyref), local_ind, depth + 1, opts, ancestor_stack, io, bufsize)
            _sort_keys = opts.sort_keys === true || (opts.sort_keys === nothing && !al && _sort_keys_by_default(x))
            if _sort_keys && !al && x isa AbstractDict
                sorted_keys = sort!(collect(keys(x)), by=k -> StructUtils.lowerkey(opts.style, k))
                for k in sorted_keys
                    c(StructUtils.lowerkey(opts.style, k), StructUtils.lower(opts.style, x[k]))
                end
            else
                StructUtils.applyeach(opts.style, c, x)
            end
            # get updated pos
            pos = unsafe_load(c.pos)
            wroteany = unsafe_load(c.wroteany)
        end
        # in WriteClosure, we eagerly write a comma after each element
        # so for non-empty object/arrays, we can just overwrite the last comma with the closechar
        if wroteany
            pos -= 1
            pos = indent(buf, pos, local_ind, depth, io, bufsize)
        end
        # even if the input is empty and we're jsonlines, the spec says it's ok to end w/ a newline
        @checkn 1
        @inbounds buf[pos] = opts.jsonlines ? UInt8('\n') : al ? UInt8(']') : UInt8('}')
        return pos + 1
    else
        return _string(buf, pos, x, io, bufsize)
    end
end

function _null(buf, pos, io, bufsize)
    @checkn 4
    @inbounds buf[pos] = 'n'
    @inbounds buf[pos + 1] = 'u'
    @inbounds buf[pos + 2] = 'l'
    @inbounds buf[pos + 3] = 'l'
    return pos + 4
end

_string(buf, pos, x, io, bufsize) = _string(buf, pos, string(x), io, bufsize)
_string(buf, pos, x::LazyValues, io, bufsize) = _string(buf, pos, getindex(x), io, bufsize)
_string(buf, pos, x::PtrString, io, bufsize) = _string(buf, pos, convert(String, x), io, bufsize)

function _string(buf, pos, x::AbstractString, io, bufsize)
    sz = ncodeunits(x)
    el = escapelength(x)
    @checkn (el + 2)
    @inbounds buf[pos] = UInt8('"')
    pos += 1
    if el > sz
        for i = 1:sz
            @inbounds escbytes = ESCAPECHARS[codeunit(x, i) + 1]
            for j = 1:length(escbytes)
                @inbounds buf[pos] = escbytes[j]
                pos += 1
            end
        end
    else
        @simd for i = 1:sz
            @inbounds buf[pos] = codeunit(x, i)
            pos += 1
        end
    end
    @inbounds buf[pos] = UInt8('"')
    return pos + 1
end

"""
    JSON.tostring(x)

Overloadable function that allows non-`Integer` `Number` types
to convert themselves to a `String` that is then used
when serializing `x` to JSON. Note that if the result of `tostring`
is not a valid JSON number, it will be serialized as a JSON string,
with double quotes around it.

An example overload would look something like:
```julia
JSON.tostring(x::MyDecimal) = string(x)
```
"""
tostring(x) = string(Float64(x))

split_sign(n::Integer) = unsigned(abs(n)), n < 0
split_sign(n::Unsigned) = n, false
split_sign(x::BigInt) = (abs(x), x < 0)

@noinline infcheck(x, allownan) = isfinite(x) || allownan || throw(ArgumentError("$x not allowed to be written in JSON spec; pass `allownan=true` to allow anyway"))

function _number(buf, pos, x::Number, opts::WriteOptions, io, bufsize)
    if x isa Integer
        y, neg = split_sign(x)
        n = i = ndigits(y, base=10, pad=1)
        @checkn (i + neg)
        if neg
            @inbounds buf[pos] = UInt8('-')
            pos += 1
        end
        while i > 0
            @inbounds buf[pos + i - 1] = 48 + rem(y, 10)
            y = oftype(y, div(y, 10))
            i -= 1
        end
        return pos + n
    elseif x isa Union{Float16, Float32, Float64}
        infcheck(x, opts.allownan)
        if isnan(x)
            nan = opts.nan
            @checkn sizeof(nan)
            for i = 1:sizeof(nan)
                @inbounds buf[pos + i - 1] = UInt8(codeunit(nan, i))
            end
            return pos + sizeof(nan)
        elseif isinf(x)
            if x < 0
                inf = opts.ninf
            else
                inf = opts.inf
            end
            @checkn sizeof(inf)
            for i = 1:sizeof(inf)
                @inbounds buf[pos + i - 1] = UInt8(codeunit(inf, i))
            end
            return pos + sizeof(inf)
        end
        if opts.float_style == :shortest
            @checkn Base.Ryu.neededdigits(typeof(x))
            return Base.Ryu.writeshortest(buf, pos, x)
        elseif opts.float_style == :fixed
            @checkn (opts.float_precision + Base.Ryu.neededdigits(typeof(x)))
            return Base.Ryu.writefixed(buf, pos, x, opts.float_precision, false, false, true)
        elseif opts.float_style == :exp
            @checkn (opts.float_precision + Base.Ryu.neededdigits(typeof(x)))
            return Base.Ryu.writeexp(buf, pos, x, opts.float_precision, false, false, true)
        else
            # unreachable as we validate float_style inputs
            @assert false
        end
    else
        str = tostring(x)
        if anyinvalidnumberchars(str)
            # serialize as string
            return _string(buf, pos, str, io, bufsize)
        end
        bytes = codeunits(str)
        sz = sizeof(bytes)
        @checkn sz
        for i = 1:sz
            @inbounds buf[pos + i - 1] = bytes[i]
        end
        return pos + sz
    end
end

function anyinvalidnumberchars(x)
    for i = 1:sizeof(x)
        b = codeunit(x, i)
        if !(b == UInt8('-') || b == UInt8('.') || b == UInt8('e') || b == UInt8('E') ||
            UInt8('0') <= b <= UInt8('9'))
            return true
        end
    end
    return false
end

using JSON, Test

@testset "JSON.Object Tests" begin
    # Test empty JSON.Object
    @testset "Empty Object" begin
        obj = JSON.Object{String, Int}()
        @test isempty(obj)
        @test length(obj) == 0
        @test collect(obj) == []
        @test propertynames(obj) == ()
        @test get(obj, "key", nothing) === nothing
        @test get(() -> 42, obj, "key") == 42
        @test_throws KeyError obj["key"]
        @test isempty(empty(obj))
        @test_throws KeyError obj.key
        @test !haskey(obj, "key")
        @test length(obj) == length(delete!(obj, "key"))
        @test isempty(JSON.Object())
    end

    # Test JSON.Object with one entry
    @testset "Single Entry Object" begin
        obj = JSON.Object{String, Int}()
        # internal way to add a key-value pair
        JSON.Object{String, Int}(obj, "key", 42)
        @test !isempty(obj)
        @test length(obj) == 1
        @test collect(obj) == ["key" => 42]
        @test propertynames(obj) == (:key,)
        @test get(obj, "key", nothing) == 42
        @test obj["key"] == 42
        @test get(() -> 0, obj, "key") == 42
        @test_throws KeyError obj["nonexistent_key"]
        # Object with String or Symbol key supports getproperty
        @test obj.key == 42
        @test haskey(obj, "key")
        @test !haskey(obj, "nonexistent_key")
        # test setindex! and delete!
        obj["key"] = 100
        @test obj["key"] == 100
        delete!(obj, "key")
        @test isempty(obj)
        obj.key = 200
        @test obj.key == 200
    end

    # Test JSON.Object with multiple entries
    @testset "Multiple Entry Object" begin
        obj = JSON.Object{String, Int}()
        ch = JSON.Object{String, Int}(obj, "key1", 1)
        ch = JSON.Object{String, Int}(ch, "key2", 2)
        ch = JSON.Object{String, Int}(ch, "key3", 3)
        @test !isempty(obj)
        @test length(obj) == 3
        @test propertynames(obj) == (:key1, :key2, :key3)
        @test collect(obj) == ["key1" => 1, "key2" => 2, "key3" => 3]
        @test get(obj, "key2", nothing) == 2
        @test obj["key3"] == 3
        obj["key3"] = 100
        @test obj["key3"] == 100
        delete!(obj, "key2")
        @test length(obj) == 2
        @test collect(obj) == ["key1" => 1, "key3" => 100]
    end

    # Test iteration over keys, values, and pairs
    @testset "Iteration" begin
        obj = JSON.Object{String, Int}()
        obj["a"] = 1
        obj["b"] = 2
        obj["c"] = 3

        @test collect(keys(obj)) == ["a", "b", "c"]
        @test collect(values(obj)) == [1, 2, 3]
        @test collect(pairs(obj)) == ["a" => 1, "b" => 2, "c" => 3]
    end

    # Test membership
    @testset "Membership" begin
        obj = JSON.Object{String, Int}()
        obj["x"] = 10
        @test haskey(obj, "x")
        @test !haskey(obj, "y")
        @test "x" in keys(obj)
        @test 10 in values(obj)
    end

    # Test modification
    @testset "Modification" begin
        obj = JSON.Object{String, Int}()
        obj["key1"] = 100
        obj["key2"] = 200
        merge!(obj, Dict("key3" => 300, "key4" => 400))
        @test length(obj) == 4
        @test obj["key3"] == 300
        empty!(obj)
        @test isempty(obj)
    end

    # Test copying
    @testset "Copying" begin
        obj = JSON.Object{String, Int}()
        obj["a"] = 1
        obj["b"] = 2
        obj_copy = copy(obj)
        @test obj == obj_copy
        obj["a"] = 10
        @test obj != obj_copy
    end

    # Test equality
    @testset "Equality" begin
        obj1 = JSON.Object{String, Int}()
        obj2 = JSON.Object{String, Int}()
        obj1["key"] = 42
        obj2["key"] = 42
        @test obj1 == obj2
        obj2["key"] = 100
        @test obj1 != obj2
    end

    # Test edge cases
    @testset "Edge Cases" begin
        obj = JSON.Object{Union{String, Nothing}, Int}()
        obj["key"] = 1
        obj[nothing] = 2
        @test obj["key"] == 1
        @test obj[nothing] == 2
        obj["key"] = 100
        @test obj["key"] == 100
    end

    # Test serialization
    @testset "Serialization" begin
        obj = JSON.Object{String, Int}()
        obj["a"] = 1
        obj["b"] = 2
        dict = Dict(obj)
        @test dict == Dict("a" => 1, "b" => 2)
        obj2 = JSON.Object{String, Int}(dict)
        @test obj == obj2
    end

    # constructors
    @testset "Constructors" begin
        obj = JSON.Object(Dict("a" => 1, "b" => 2))
        @test obj["a"] == 1
        @test obj["b"] == 2
        obj2 = JSON.Object("a" => 1, "b" => 2)
        @test obj2["a"] == 1
        @test obj2["b"] == 2
        obj3 = JSON.Object(:a => 1, :b => 2)
        @test obj3[:a] == 1
        @test obj3[:b] == 2
        obj = JSON.Object{Symbol, Int}()
        obj[:a] = 1
        @test obj.a == 1
        obj.a = 2
        @test obj[:a] == 2
    end

    # Test performance (basic check for large dictionaries)
    @testset "Performance" begin
        obj = JSON.Object{Int, Int}()
        for i in 1:10_000
            obj[i] = i
        end
        @test length(obj) == 10_000
        @test obj[5_000] == 5_000
    end

    # Test new iterator constructors
    @testset "Iterator Constructors" begin
        # Test generic Object(itr) constructor with Pairs
        pairs = ["a" => 1, "b" => 2, "c" => 3]
        obj1 = JSON.Object(pairs)
        @test obj1["a"] == 1
        @test obj1["b"] == 2
        @test obj1["c"] == 3
        @test length(obj1) == 3

        # Test generic Object(itr) constructor with Tuples
        tuples = [("x", 10), ("y", 20), ("z", 30)]
        obj2 = JSON.Object(tuples)
        @test obj2["x"] == 10
        @test obj2["y"] == 20
        @test obj2["z"] == 30
        @test length(obj2) == 3

        # Test generic Object(itr) constructor with consistent types
        symbols = [:a => 1, :b => 2, :c => 3]
        obj3 = JSON.Object(symbols)
        @test obj3[:a] == 1
        @test obj3[:b] == 2
        @test obj3[:c] == 3
        @test length(obj3) == 3
        
        # Test that mixed types require explicit Any type specification
        mixed = [:a => 1, :b => "hello", :c => 3.14]
        @test_throws MethodError JSON.Object(mixed)
        
        # But works with explicit Any type
        obj3_any = JSON.Object{Symbol,Any}(mixed)
        @test obj3_any[:a] == 1
        @test obj3_any[:b] == "hello"
        @test obj3_any[:c] == 3.14
        @test length(obj3_any) == 3

        # Test empty iterator
        empty_iter = Pair{String, Int}[]
        obj4 = JSON.Object(empty_iter)
        @test isempty(obj4)
        @test length(obj4) == 0

        # Test typed Object{K,V}(itr) constructor
        typed_pairs = ["key1" => 100, "key2" => 200]
        obj5 = JSON.Object{String, Int}(typed_pairs)
        @test obj5["key1"] == 100
        @test obj5["key2"] == 200
        @test length(obj5) == 2

        # Test typed constructor with tuples
        typed_tuples = [("a", 1), ("b", 2)]
        obj6 = JSON.Object{String, Int}(typed_tuples)
        @test obj6["a"] == 1
        @test obj6["b"] == 2
        @test length(obj6) == 2

        # Test error handling for invalid iterator elements
        invalid_iter = [1, 2, 3]  # Not pairs or tuples
        @test_throws ArgumentError JSON.Object(invalid_iter)
        @test_throws ArgumentError JSON.Object{String, Int}(invalid_iter)

        # Test with generator expression
        gen_pairs = (string(i) => i^2 for i in 1:5)
        obj7 = JSON.Object(gen_pairs)
        @test obj7["1"] == 1
        @test obj7["3"] == 9
        @test obj7["5"] == 25
        @test length(obj7) == 5

        # Test with Dict as iterator
        dict_input = Dict("foo" => 42, "bar" => 24)
        obj8 = JSON.Object(dict_input)
        @test obj8["foo"] == 42
        @test obj8["bar"] == 24
        @test length(obj8) == 2
    end

    # Test enhanced haskey for String objects with Symbol keys
    @testset "Enhanced haskey for String Objects" begin
        obj = JSON.Object{String, Any}()
        obj["hello"] = "world"
        obj["count"] = 42

        # Test basic string key lookup
        @test haskey(obj, "hello")
        @test haskey(obj, "count")
        @test !haskey(obj, "missing")

        # Test Symbol key lookup (should convert to String)
        @test haskey(obj, :hello)
        @test haskey(obj, :count)
        @test !haskey(obj, :missing)

        # Test that Symbol keys work for both existing and non-existing keys
        obj["symbol_test"] = "value"
        @test haskey(obj, :symbol_test)
        @test !haskey(obj, :nonexistent_symbol)

        # Test that indexing with both String and Symbol keys work
        @test obj[:symbol_test] == obj["symbol_test"]
        
        # Test overwriting with Symbol key 
        obj[:symbol_test] = "newvalue"
        @test obj[:symbol_test] == obj["symbol_test"] == "newvalue"

        # Test deletion with Symbol key
        delete!(obj, :symbol_test)
        @test !haskey(obj, :symbol_test)
        @test !haskey(obj, "symbol_test")

        # Test get with Symbol key (should convert to String)
        obj["get_test"] = "got it"
        @test get(obj, :get_test, "default") == "got it"
        @test get(obj, :nonexistent, "default") == "default"
        @test get(() -> "fallback", obj, :get_test) == "got it"
        @test get(() -> "fallback", obj, :nonexistent) == "fallback"

        # Test with empty object
        empty_obj = JSON.Object{String, Any}()
        @test !haskey(empty_obj, :anything)
        @test !haskey(empty_obj, "anything")
    end

    @testset "AbstractString key support for parsed String objects" begin
        obj = JSON.parse("{\"foo\": \"bar\"}")
        s = "abc.foo.xyz"
        k = split(s, ".")[2]

        @test k isa SubString{String}
        @test haskey(obj, k)
        @test get(obj, k, nothing) == "bar"
        @test obj[k] == "bar"

        obj[k] = "baz"
        @test obj["foo"] == "baz"

        delete!(obj, k)
        @test !haskey(obj, "foo")
        @test get(obj, k, "default") == "default"
        @test_throws KeyError obj[k]
    end

    # Test enhanced haskey for Symbol objects with String keys
    @testset "Enhanced haskey for Symbol Objects" begin
        obj = JSON.Object{Symbol, Any}()
        obj[:hello] = "world"
        obj[:count] = 42

        # Test basic string key lookup
        @test haskey(obj, :hello)
        @test haskey(obj, :count)
        @test !haskey(obj, :missing)
        
        # Test String key lookup (should convert to Symbol)
        @test haskey(obj, "hello")
        @test haskey(obj, "count")
        @test !haskey(obj, "missing")

        # Test that String keys work for both existing and non-existing keys
        obj[:symbol_test] = "value"
        @test haskey(obj, "symbol_test")
        @test !haskey(obj, "nonexistent_symbol")

        # Test that indexing with both String and Symbol keys work
        @test obj[:symbol_test] == obj["symbol_test"]

        # Test overwriting with String key 
        obj["symbol_test"] = "newvalue"
        @test obj[:symbol_test] == obj["symbol_test"] == "newvalue"

        # Test deletion with String key
        delete!(obj, "symbol_test")
        @test !haskey(obj, :symbol_test)
        @test !haskey(obj, "symbol_test")

        # Test get with String key (should convert to Symbol)
        obj[:get_test] = "got it"
        @test get(obj, "get_test", "default") == "got it"
        @test get(obj, "nonexistent", "default") == "default"
        @test get(() -> "fallback", obj, "get_test") == "got it"
        @test get(() -> "fallback", obj, "nonexistent") == "fallback"

        # Test with empty object
        empty_obj = JSON.Object{Symbol, Any}()
        @test !haskey(empty_obj, :anything)
        @test !haskey(empty_obj, "anything")
    end

    # Test merge functionality with NamedTuple
    @testset "NamedTuple Merge" begin
        # Test basic merge
        nt = (a = 1, b = 2, c = 3)
        obj = JSON.Object{String, Any}()
        obj["x"] = 10
        obj["y"] = 20

        merged = merge(nt, obj)
        @test merged.a == 1
        @test merged.b == 2
        @test merged.c == 3
        @test merged.x == 10
        @test merged.y == 20

        # Test merge with overlapping keys (Object values should override NamedTuple)
        nt2 = (a = 100, d = 400)
        obj2 = JSON.Object{String, Any}()
        obj2["a"] = 999  # This should override the NamedTuple value
        obj2["b"] = 200

        merged2 = merge(nt2, obj2)
        @test merged2.a == 999  # Object value overrides NamedTuple
        @test merged2.d == 400  # NamedTuple value preserved
        @test merged2.b == 200  # Object value added

        # Test merge with empty NamedTuple
        empty_nt = NamedTuple()
        obj3 = JSON.Object{String, Any}()
        obj3["key"] = "value"

        merged3 = merge(empty_nt, obj3)
        @test merged3.key == "value"
        @test length(merged3) == 1

        # Test merge with empty Object
        nt4 = (x = 1, y = 2)
        empty_obj = JSON.Object{String, Any}()

        merged4 = merge(nt4, empty_obj)
        @test merged4.x == 1
        @test merged4.y == 2
        @test length(merged4) == 2

        # Test that the result is a NamedTuple
        result = merge((a = 1,), JSON.Object{String, Any}("b" => 2))
        @test result isa NamedTuple
        @test haskey(result, :a)
        @test haskey(result, :b)

        # Test with various value types
        obj_mixed = JSON.Object{String, Any}()
        obj_mixed["string"] = "hello"
        obj_mixed["number"] = 42
        obj_mixed["float"] = 3.14
        obj_mixed["bool"] = true

        nt_mixed = (existing = "original",)
        merged_mixed = merge(nt_mixed, obj_mixed)
        @test merged_mixed.existing == "original"
        @test merged_mixed.string == "hello"
        @test merged_mixed.number == 42
        @test merged_mixed.float == 3.14
        @test merged_mixed.bool == true
    end
end

# Tests for JSONX module
using Test

# Include the JSONX module
include("jsonx.jl")

@testset "JSONX Tests" begin
    @testset "Basic Types" begin
        # Test null
        @test JSONX.parse("null") === nothing
        # Test booleans
        @test JSONX.parse("true") === true
        @test JSONX.parse("false") === false
        # Test integers (return Int64)
        @test JSONX.parse("0") === Int64(0)
        @test JSONX.parse("123") === Int64(123)
        @test JSONX.parse("-123") === Int64(-123)
        # Test floats (return Float64)
        @test JSONX.parse("3.14") == 3.14
        @test JSONX.parse("-3.14") == -3.14
        @test JSONX.parse("1e2") == 100.0
        @test JSONX.parse("1E2") == 100.0
        @test JSONX.parse("1.5e-2") == 0.015
        # Test strings
        @test JSONX.parse("\"hello\"") == "hello"
        @test JSONX.parse("\"\"") == ""
        @test JSONX.parse("\"\\\"quoted\\\"\"") == "\"quoted\""
        @test JSONX.parse("\"\\\\backslash\\\\\"") == "\\backslash\\"
        @test JSONX.parse("\"\\n\\t\\r\\b\\f\"") == "\n\t\r\b\f"
    end

    @testset "Integer vs Float Parsing" begin
        # Integers without decimal/exponent -> Int64
        @test JSONX.parse("42") === Int64(42)
        @test JSONX.parse("-100") === Int64(-100)
        @test JSONX.parse("0") === Int64(0)

        # Numbers with decimal point -> Float64
        @test JSONX.parse("42.0") === 42.0
        @test JSONX.parse("1.5") === 1.5

        # Numbers with exponent -> Float64
        @test JSONX.parse("1e10") === 1e10
        @test JSONX.parse("1E5") === 1e5
        @test JSONX.parse("2.5e3") === 2500.0
        @test JSONX.parse("1e10") isa Float64

        # Int64 overflow fallback to Float64
        @test JSONX.parse("99999999999999999999") == 1e20

        # Negative overflow
        @test JSONX.parse("-99999999999999999999") == -1e20

        # Edge case: numbers at Int64 boundary
        @test JSONX.parse(string(typemax(Int64))) === typemax(Int64)
        @test JSONX.parse(string(typemin(Int64))) === typemin(Int64)
    end
    
    @testset "Arrays" begin
        # Test empty array
        @test JSONX.parse("[]") == []
        # Test simple arrays
        @test JSONX.parse("[1,2,3]") == [1, 2, 3]
        @test JSONX.parse("[\"a\",\"b\",\"c\"]") == ["a", "b", "c"]
        @test JSONX.parse("[true,false,null]") == [true, false, nothing]
        # Test nested arrays
        @test JSONX.parse("[[1,2],[3,4]]") == [[1, 2], [3, 4]]
        @test JSONX.parse("[1,[2,3],4]") == [1, [2, 3], 4]
        # Test mixed types
        @test JSONX.parse("[1,\"two\",3.0,true,null]") == [1, "two", 3.0, true, nothing]
    end
    
    @testset "Objects" begin
        # Test empty object
        @test JSONX.parse("{}") == Dict{String, Any}()
        # Test simple objects
        @test JSONX.parse("{\"key\":\"value\"}") == Dict("key" => "value")
        @test JSONX.parse("{\"a\":1,\"b\":2}") == Dict("a" => 1, "b" => 2)
        # Test nested objects
        @test JSONX.parse("{\"a\":{\"b\":\"c\"}}") == Dict("a" => Dict("b" => "c"))
        @test JSONX.parse("{\"a\":[1,2,3]}") == Dict("a" => [1, 2, 3])
        # Test mixed types
        @test JSONX.parse("{\"str\":\"hello\",\"num\":123,\"bool\":true,\"null\":null}") ==
              Dict("str" => "hello", "num" => 123, "bool" => true, "null" => nothing)
    end
    
    @testset "Whitespace Handling" begin
        # Test various whitespace
        @test JSONX.parse("  null  ") === nothing
        @test JSONX.parse("\t\n\r null \t\n\r") === nothing
        @test JSONX.parse("[ 1 , 2 , 3 ]") == [1, 2, 3]
        @test JSONX.parse("{ \"key\" : \"value\" }") == Dict("key" => "value")
        # Vertical tab and form feed are NOT valid JSON whitespace (RFC 8259 §2)
        @test_throws ArgumentError JSONX.parse("\x0bnull")  # vertical tab
        @test_throws ArgumentError JSONX.parse("\x0cnull")  # form feed
    end
    
    @testset "Error Cases" begin
        # Test invalid JSON
        @test_throws ArgumentError JSONX.parse("")
        @test_throws ArgumentError JSONX.parse("   ")
        @test_throws ArgumentError JSONX.parse("invalid")
        @test_throws ArgumentError JSONX.parse("nul")
        @test_throws ArgumentError JSONX.parse("tru")
        @test_throws ArgumentError JSONX.parse("fals")
        # Test incomplete structures
        @test_throws ArgumentError JSONX.parse("[1,2,")
        @test_throws ArgumentError JSONX.parse("{\"key\":")
        @test_throws ArgumentError JSONX.parse("\"unterminated")
        @test_throws ArgumentError JSONX.parse("123abc")
        # Test invalid escape sequences
        @test_throws ArgumentError JSONX.parse("\"\\x\"")
        @test_throws ArgumentError JSONX.parse("\"\\u123\"")
        # Leading '+' is not valid JSON (only '-' is a valid leading sign)
        @test_throws ArgumentError JSONX.parse("+1")
        @test_throws ArgumentError JSONX.parse("+3.14")
    end
    
    @testset "JSON Writing" begin
        # Test basic types
        @test JSONX.json(nothing) == "null"
        @test JSONX.json(true) == "true"
        @test JSONX.json(false) == "false"
        @test JSONX.json(123) == "123"
        @test JSONX.json(3.14) == "3.14"
        @test JSONX.json("hello") == "\"hello\""
        @test JSONX.json(missing) == "null"
        # Test arrays
        @test JSONX.json([]) == "[]"
        @test JSONX.json([1, 2, 3]) == "[1,2,3]"
        @test JSONX.json(["a", "b", "c"]) == "[\"a\",\"b\",\"c\"]"
        @test JSONX.json([1, "two", 3.0, true, nothing]) == "[1,\"two\",3.0,true,null]"
        # Test objects
        @test JSONX.json(Dict{String, Any}()) == "{}"
        @test JSONX.json(Dict("key" => "value")) == "{\"key\":\"value\"}"
        # Note: Dictionary order is not guaranteed, so we parse and compare
        @test JSONX.parse(JSONX.json(Dict("a" => 1, "b" => 2))) == Dict("a" => 1, "b" => 2)
        # Test nested structures
        @test JSONX.json(Dict("a" => Dict("b" => "c"))) == "{\"a\":{\"b\":\"c\"}}"
        @test JSONX.json(Dict("a" => [1, 2, 3])) == "{\"a\":[1,2,3]}"
        # Test other types
        @test JSONX.json(:symbol) == "\"symbol\""
        @test JSONX.json((1, 2, 3)) == "[1,2,3]"
        # Note: NamedTuple order is not guaranteed, so we parse and compare
        @test JSONX.parse(JSONX.json((a=1, b=2))) == Dict("a" => 1, "b" => 2)
        # Test JSONText
        @test JSONX.json(JSONX.JSONText("{\"x\": invalid json}")) == "{\"x\": invalid json}"
    end
    
    @testset "AbstractSet Support" begin
        # Test Set types
        @test JSONX.json(Set([1, 2, 3])) == "[1,2,3]" || JSONX.json(Set([1, 2, 3])) == "[1,3,2]" || JSONX.json(Set([1, 2, 3])) == "[2,1,3]" || JSONX.json(Set([1, 2, 3])) == "[2,3,1]" || JSONX.json(Set([1, 2, 3])) == "[3,1,2]" || JSONX.json(Set([1, 2, 3])) == "[3,2,1]"
        @test JSONX.json(Set(["a", "b", "c"])) == "[\"a\",\"b\",\"c\"]" || JSONX.json(Set(["a", "b", "c"])) == "[\"a\",\"c\",\"b\"]" || JSONX.json(Set(["a", "b", "c"])) == "[\"b\",\"a\",\"c\"]" || JSONX.json(Set(["a", "b", "c"])) == "[\"b\",\"c\",\"a\"]" || JSONX.json(Set(["a", "b", "c"])) == "[\"c\",\"a\",\"b\"]" || JSONX.json(Set(["a", "b", "c"])) == "[\"c\",\"b\",\"a\"]"
        # Test round trip for Set
        set_data = Set([1, "two", 3.0, true])
        json_str = JSONX.json(set_data)
        parsed = JSONX.parse(json_str)
        @test Set(parsed) == set_data
    end
    
    @testset "String Escaping" begin
        # Test string escaping in writing
        @test JSONX.json("\"quoted\"") == "\"\\\"quoted\\\"\""
        @test JSONX.json("\\backslash\\") == "\"\\\\backslash\\\\\""
        @test JSONX.json("line1\nline2") == "\"line1\\nline2\""
        @test JSONX.json("tab\there") == "\"tab\\there\""
        @test JSONX.json("carriage\rreturn") == "\"carriage\\rreturn\""
        @test JSONX.json("backspace\bhere") == "\"backspace\\bhere\""
        @test JSONX.json("form\ffeed") == "\"form\\ffeed\""
        # Test control characters
        @test JSONX.json("control\x01char") == "\"control\\u0001char\""
    end
    
    @testset "Round Trip" begin
        # Test that parse(json(x)) == x for various types
        test_cases = [
            nothing,
            true,
            false,
            0,
            123,
            -123,
            3.14,
            -3.14,
            "",
            "hello",
            "quoted \"string\"",
            [],
            [1, 2, 3],
            ["a", "b", "c"],
            [1, "mixed", 3.0, true, nothing],
            Dict{String, Any}(),
            Dict("key" => "value"),
            Dict("a" => 1, "b" => 2),
            Dict("nested" => Dict("key" => "value")),
            Dict("array" => [1, 2, 3]),
        ]

        for case in test_cases
            json_str = JSONX.json(case)
            parsed = JSONX.parse(json_str)
            @test parsed == case
        end
    end
    
    @testset "Edge Cases" begin
        # Test very large numbers
        @test JSONX.parse("1234567890123456789") === 1234567890123456789
        @test JSONX.parse("1.234567890123456789") == 1.234567890123456789
        # Test scientific notation
        @test JSONX.parse("1e10") == 1e10
        @test JSONX.parse("1E-10") == 1e-10
        @test JSONX.parse("1.5e+5") == 1.5e5
        # Test empty strings and arrays
        @test JSONX.parse("\"\"") == ""
        @test JSONX.parse("[]") == []
        @test JSONX.parse("{}") == Dict{String, Any}()
        # Test nested structures
        complex_json = """
        {
            "name": "John",
            "age": 30,
            "active": true,
            "scores": [85, 92, 78],
            "address": {
                "street": "123 Main St",
                "city": "Anytown"
            },
            "tags": ["developer", "programmer"],
            "metadata": null
        }
        """
        expected = Dict(
            "name" => "John",
            "age" => 30,
            "active" => true,
            "scores" => [85, 92, 78],
            "address" => Dict("street" => "123 Main St", "city" => "Anytown"),
            "tags" => ["developer", "programmer"],
            "metadata" => nothing
        )
        @test JSONX.parse(complex_json) == expected
    end
    
    @testset "Error Handling" begin
        # Test writing unsupported types
        @test_throws ArgumentError JSONX.json(Complex(1, 2))
        # Test malformed JSON
        @test_throws ArgumentError JSONX.parse("[1,2,]")
        @test_throws ArgumentError JSONX.parse("{\"key\":}")
        @test_throws ArgumentError JSONX.parse("{\"key\"}")
        @test_throws ArgumentError JSONX.parse("[1,2,3")
        @test_throws ArgumentError JSONX.parse("{\"key\":\"value\"")
    end

    @testset "AbstractVector{UInt8} Support" begin
        @test JSONX.parse(Vector{UInt8}("null")) === nothing
        @test JSONX.parse(Vector{UInt8}("42")) === Int64(42)
        @test JSONX.parse(Vector{UInt8}("\"hello\"")) == "hello"
        @test JSONX.parse(Vector{UInt8}("[1,2,3]")) == [1, 2, 3]
        @test JSONX.parse(Vector{UInt8}("{\"a\":1}")) == Dict("a" => 1)
    end

    @testset "Unicode Handling" begin
        # Basic Unicode escapes
        @test JSONX.parse("\"\\u0041\"") == "A"
        @test JSONX.parse("\"\\u0048\\u0065\\u006C\\u006C\\u006F\"") == "Hello"
        # Surrogate pairs
        @test JSONX.parse("\"\\uD83D\\uDE00\"") == "😀"  # Grinning face emoji
        @test JSONX.parse("\"\\uD83C\\uDF55\"") == "🍕"  # Pizza emoji
        # Mixed content
        @test JSONX.parse("\"Hello \\u0041\\u006E\\u0064\\u0072\\u0065\\u0077!\"") == "Hello Andrew!"
        # String unescaping
        @test JSONX.parse(raw"\"𝔸\\a\"") == "𝔸\\a"
        # Writing Unicode
        @test JSONX.json("A") == "\"A\""
        @test JSONX.json("😀") == "\"😀\""
        @test JSONX.json("Hello Andrew!") == "\"Hello Andrew!\""
    end

    @testset "Escape Sequences" begin
        @test JSONX.parse("\"\\\"\"") == "\""
        @test JSONX.parse("\"\\\\\"") == "\\"
        @test JSONX.parse("\"\\/\"") == "/"
        @test JSONX.parse("\"\\b\"") == "\b"
        @test JSONX.parse("\"\\f\"") == "\f"
        @test JSONX.parse("\"\\n\"") == "\n"
        @test JSONX.parse("\"\\r\"") == "\r"
        @test JSONX.parse("\"\\t\"") == "\t"
        # Writing escape sequences
        @test JSONX.json("\"") == "\"\\\"\""
        @test JSONX.json("\\") == "\"\\\\\""
        @test JSONX.json("/") == "\"/\""
        @test JSONX.json("\b") == "\"\\b\""
        @test JSONX.json("\f") == "\"\\f\""
        @test JSONX.json("\n") == "\"\\n\""
        @test JSONX.json("\r") == "\"\\r\""
        @test JSONX.json("\t") == "\"\\t\""
    end

    @testset "Error Cases for Unicode" begin
        @test_throws ArgumentError JSONX.parse("\"\\u\"")  # Incomplete Unicode escape
        @test_throws ArgumentError JSONX.parse("\"\\u123\"")  # Incomplete Unicode escape
        @test_throws ArgumentError JSONX.parse("\"\\u123G\"")  # Invalid hex digit
        @test length(JSONX.parse("\"\\uD83D\"")) == 1  # Lone surrogate produces a character
        @test_throws ArgumentError JSONX.parse("\"\\uD83D\\u\"")  # Incomplete surrogate pair
        @test_throws ArgumentError JSONX.parse("\"\\uD83D\\u123G\"")  # Invalid hex in surrogate pair
    end

    @testset "Complex Unicode Round-trip" begin
        # Test complex Unicode content
        unicode_text = "Hello 世界! 🌍 こんにちは! Привет! مرحبا!"
        json_str = JSONX.json(unicode_text)
        parsed = JSONX.parse(json_str)
        @test parsed == unicode_text
        # Test with simple escape sequences
        mixed_text = "Hello\nWorld\tTest\rSimple"
        json_str = JSONX.json(mixed_text)
        parsed = JSONX.parse(json_str)
        @test parsed == mixed_text
    end

    @testset "File I/O" begin
        # Create a temporary file for testing
        test_file = tempname()
        try
            # Write test JSON to file
            write(test_file, "{\"test\":\"value\",\"number\":42}")
            # Test parsefile
            result = JSONX.parsefile(test_file)
            @test result == Dict("test" => "value", "number" => 42)
            # Test with Unicode content
            write(test_file, "\"Hello 世界! 🌍\"")
            result = JSONX.parsefile(test_file)
            @test result == "Hello 世界! 🌍"
        finally
            # Clean up
            isfile(test_file) && rm(test_file)
        end
    end
end

println("All JSONX tests passed!")

using Documenter, JSON

makedocs(
    modules = [JSON],
    sitename = "JSON.jl",
    pages = [
        "Home" => "index.md",
        "JSON Writing" => "writing.md",
        "JSON Reading" => "reading.md",
        "Migration Guides" => "migrate.md",
        "API Reference" => "reference.md",
    ],
)

deploydocs(repo = "github.com/JuliaIO/JSON.jl.git", push_preview = true)

using JSON, Test

JSON.StructUtils.@defaults struct JSONIgnoredField
    id::Int = 1
    secret::Int = 99 &(json=(ignore=true,),)
end

JSON.StructUtils.@noarg mutable struct JSONMutableIgnoredField
    id::Int = 1
    secret::Int = 99 &(json=(ignore=true,),)
end

@testset "JSON inbound field tags" begin
    @test JSON.parse(
        "{\"id\":2,\"secret\":200}",
        JSONIgnoredField;
        unknown_fields=:error,
    ) == JSONIgnoredField(2, 99)
    @test_throws ArgumentError JSON.parse(
        "{\"id\":2,\"extra\":200}",
        JSONIgnoredField;
        unknown_fields=:error,
    )

    value = JSONMutableIgnoredField()
    value.secret = 55
    JSON.parse!(
        "{\"id\":2,\"secret\":200}",
        value;
        unknown_fields=:error,
    )
    @test value.id == 2
    @test value.secret == 55
end

using JSON, Test

struct EscapedPlainKey
    alpha::Int
end

struct EscapedUnicodeKey
    café::Int
end

JSON.StructUtils.@tags struct EscapedQuoteTag
    value::Int & (name="display\"name",)
end

JSON.StructUtils.@tags struct EscapedAliasTag
    value::Int & (name=("alias", "slash\\key"),)
end

JSON.StructUtils.@tags struct EscapedSymbolTag
    value::Int & (name=:alpha,)
end

JSON.StructUtils.@defaults struct EscapedAliasCollision
    a::Int = -1 & (json=(name="b",),)
    b::Int = -2
end

@enum EscapedEnumKey alpha

struct EscapedOrderedKeys
    a::Int
    b::Int
    c::Int
end

struct LazyDispatchProbe end
JSON.parse(::JSON.LazyValue, ::Type{LazyDispatchProbe}; kw...) = :lazy_dispatch

module EscapedErrorScope
struct Box{T}
    value::T
end
end

function capture_error(f)
    try
        f()
        return nothing
    catch err
        return err
    end
end

@testset "escaped object keys" begin
    @test JSON.parse("{\"\\u0061lpha\":11}", EscapedPlainKey) == EscapedPlainKey(11)
    @test JSON.parse("{\"caf\\u00e9\":12}", EscapedUnicodeKey) == EscapedUnicodeKey(12)
    @test JSON.parse("{\"display\\\"name\":13}", EscapedQuoteTag) == EscapedQuoteTag(13)
    @test JSON.parse("{\"slash\\\\key\":14}", EscapedAliasTag) == EscapedAliasTag(14)
    @test JSON.parse("{\"\\u0061lpha\":15}", EscapedSymbolTag) == EscapedSymbolTag(15)
    @test JSON.parse("{\"b\":19}", EscapedAliasCollision) ==
        EscapedAliasCollision(19, -2)
    @test JSON.parse("{\"c\":3,\"\\u0061\":1,\"b\":2}", EscapedOrderedKeys) ==
        EscapedOrderedKeys(1, 2, 3)
    @test JSON.parse("{\"\\u0061lpha\":15}", EscapedPlainKey; unknown_fields=:error) ==
        EscapedPlainKey(15)

    key = Ref{Any}()
    source = JSON.lazy("{\"\\u0061lpha\":1}")
    GC.@preserve source begin
        JSON.applyobject(source) do k, _
            key[] = k
        end
    end
    @test key[] == "alpha"
    @test isequal(key[], "alpha")
    @test hash(key[]) == hash("alpha")
    @test convert(Symbol, key[]) === :alpha

    plain_key = Ref{Any}()
    escaped_key = Ref{Any}()
    plain_source = JSON.lazy("{\"alpha\":1}")
    escaped_source = JSON.lazy("{\"\\u0061lpha\":1}")
    GC.@preserve plain_source escaped_source begin
        JSON.applyobject(plain_source) do k, _
            plain_key[] = k
        end
        JSON.applyobject(escaped_source) do k, _
            escaped_key[] = k
        end
        @test plain_key[] == escaped_key[]
        @test isequal(plain_key[], escaped_key[])
        @test hash(plain_key[]) == hash(escaped_key[])
        keys = Dict{Any,Int}(plain_key[] => 1, escaped_key[] => 2)
        @test length(keys) == 1
        @test keys[plain_key[]] == 2
    end

    @test JSON.parse("{\"\\u0061lpha\":16}") == Dict("alpha" => 16)
    @test JSON.parse("{\"\\u0061lpha\":17}", Dict{Symbol,Int}) == Dict(:alpha => 17)
    @test JSON.parse("{\"\\u0061lpha\":18}", Dict{EscapedEnumKey,Int}) ==
        Dict(alpha => 18)

    for input in (
        "{\"alpha\":1,\"\\u0061lpha\":2}",
        "{\"café\":1,\"caf\\u00e9\":2}",
        "{\"display\\\"name\":1,\"display\\u0022name\":2}",
        "{\"slash\\\\key\":1,\"slash\\u005ckey\":2}",
    )
        @test_throws JSON.DuplicateKeyError JSON.parse(input; duplicate_keys=:error)
        @test_throws JSON.DuplicateKeyError JSON.parse(
            input,
            Dict{String,Int};
            duplicate_keys=:error,
        )
    end

    err = capture_error() do
        JSON.parse("{\"bog\\u0075s\":1}", EscapedPlainKey; unknown_fields=:error)
    end
    @test err isa ArgumentError
    @test occursin("unknown JSON member \"bogus\"", sprint(showerror, err))

    @testset "error rendering" begin
        for (input, rendered) in (
            ("{\"a\\\"b\":1}", "\"a\\\"b\""),
            ("{\"a\\\\b\":1}", "\"a\\\\b\""),
            ("{\"line\\nbreak\":1}", "\"line\\nbreak\""),
        )
            escaped = capture_error() do
                JSON.parse(input, EscapedPlainKey; unknown_fields=:error)
            end
            @test escaped isa ArgumentError
            @test occursin("unknown JSON member $rendered", sprint(showerror, escaped))
        end

        option = capture_error() do
            JSON.parse("{}", EscapedPlainKey; unknown_fields=Symbol("bad\n\""))
        end
        @test option isa ArgumentError
        option_message = sprint(showerror, option)
        @test occursin("Symbol(\"bad\\n\\\"\")", option_message)
        @test !occursin('\n', option_message)

        simple_option = capture_error() do
            JSON.parse("{}", EscapedPlainKey; unknown_fields=:boom)
        end
        @test simple_option isa ArgumentError
        @test occursin("got :boom", sprint(showerror, simple_option))

        symbol_key = JSON.unknownfielderror(EscapedPlainKey, :boom)
        @test occursin("unknown JSON member :boom", sprint(showerror, symbol_key))

        integer_key = JSON.unknownfielderror(EscapedPlainKey, 7)
        @test occursin("unknown JSON member 7", sprint(showerror, integer_key))

        fallback_key = JSON.unknownfielderror(EscapedPlainKey, (value=1,))
        @test occursin("unknown JSON member <key>", sprint(showerror, fallback_key))

        for T in (Vector{Int}, EscapedErrorScope.Box{Int}, Union{Float64,Int})
            typed = capture_error() do
                JSON.invalid(JSON.InvalidChar, "x", 1, T)
            end
            @test typed isa ArgumentError
            @test occursin("parsing type $(string(T))", sprint(showerror, typed))
        end

        scalar = capture_error() do
            JSON.parse("1", EscapedPlainKey)
        end
        @test scalar isa ArgumentError
        scalar_message = sprint(showerror, scalar)
        @test occursin(string(typeof(JSON.lazy("1"))), scalar_message)
        @test occursin("JSONTypes.NUMBER", scalar_message)
    end

    @test JSON.parse(JSON.lazy("{}"), LazyDispatchProbe) === :lazy_dispatch
end

using JSON, Test

# helper struct for testing reading json from files
struct File end

make(::Type{String}, x) = x
make(::Type{SubString{String}}, x) = SubString(x)
make(::Type{Vector{UInt8}}, x) = Vector{UInt8}(x)
make(::Type{IOBuffer}, x) = IOBuffer(x)
function make(::Type{File}, x)
    _, io = mktemp()
    write(io, x)
    seekstart(io)
    return io
end

function makefile(nm, x)
    dir = mktempdir()
    file = joinpath(dir, nm)
    open(file, "w") do io
        write(io, x)
    end
    return file
end

@testset "JSON.lazy" begin
    for T in (String, SubString{String}, IOBuffer, Vector{UInt8}, File)
        @test JSON.gettype(JSON.lazy(make(T, "1"))) == JSON.JSONTypes.NUMBER
        @test JSON.gettype(JSON.lazy(make(T, "true"))) == JSON.JSONTypes.TRUE
        @test JSON.gettype(JSON.lazy(make(T, "false"))) == JSON.JSONTypes.FALSE
        @test JSON.gettype(JSON.lazy(make(T, "null"))) == JSON.JSONTypes.NULL
        @test JSON.gettype(JSON.lazy(make(T, "[]"))) == JSON.JSONTypes.ARRAY
        @test JSON.gettype(JSON.lazy(make(T, "{}"))) == JSON.JSONTypes.OBJECT
        @test JSON.gettype(JSON.lazy(make(T, "\"\""))) == JSON.JSONTypes.STRING
        @test_throws ArgumentError JSON.lazy(make(T, "a"))
    end
    # lazyfile
    x = JSON.lazyfile(makefile("empty_object.json", "{}"))
    @test JSON.gettype(x) == JSON.JSONTypes.OBJECT
    @test length(x) == 0
    # LazyObject with all possible JSON types
    x = JSON.lazy("{\"a\": 1, \"b\": null, \"c\": true, \"d\": false, \"e\": \"\", \"f\": [], \"g\": {}}")
    @test length(x) == 7
    if VERSION >= v"1.7"
        @test sprint(show, x) == "LazyObject{String} with 7 entries:\n  \"a\" => JSON.LazyValue(1)\n  \"b\" => JSON.LazyValue(nothing)\n  \"c\" => JSON.LazyValue(true)\n  \"d\" => JSON.LazyValue(false)\n  \"e\" => JSON.LazyValue(\"\")\n  \"f\" => LazyValue[]\n  \"g\" => LazyObject{String}()"
    end
    i = 0
    foreach(x) do (k, v)
        i += 1
        @test k isa String
        @test v isa JSON.LazyValue
    end
    @test i == 7
    # LazyArray with all possible JSON types
    x = JSON.lazy("[1, null, true, false, \"\", [], {}]")
    @test length(x) == 7
    @test JSON.gettype(x[end]) == JSON.JSONTypes.OBJECT
    if VERSION >= v"1.7"
        @test sprint(show, x) == "7-element LazyArray{String}:\n JSON.LazyValue(1)\n JSON.LazyValue(nothing)\n JSON.LazyValue(true)\n JSON.LazyValue(false)\n JSON.LazyValue(\"\")\n LazyValue[]\n LazyObject{String}()"
    end
    i = 0
    foreach(x) do v
        i += 1
        @test v isa JSON.LazyValue
    end
    @test i == 7
    # error cases
    x = JSON.lazy("{}")
    @test_throws ArgumentError JSON.applyarray((i, v) -> nothing, x)
    @test_throws ArgumentError JSON.parsestring(x)
    x = JSON.lazy("{}"; allownan=true)
    @test_throws ArgumentError JSON.parsenumber(x)

    str = JSON.lazy("\"alpha\"")
    key, _ = JSON.parsestring(str)
    @test key == "alpha"
    @test "alpha" == key
    @test isequal(key, "alpha")
    @test isequal("alpha", key)
    @test hash(key) == hash("alpha")
    @test haskey(Dict{Any,Int}(key => 1), "alpha")
    @test "alpha" in Set{Any}([key])

    # lazy indexing selection support
    # examples from https://support.smartbear.com/alertsite/docs/monitors/api/endpoint/jsonpath.html
    json = """
    {
    "store": {
        "book": [
        {
            "category": "reference",
            "author": "Nigel Rees",
            "title": "Sayings of the Century",
            "price": 8.95
        },
        {
            "category": "fiction",
            "author": "Herman Melville",
            "title": "Moby Dick",
            "isbn": "0-553-21311-3",
            "price": 8.99
        },
        {
            "category": "fiction",
            "author": "J.R.R. Tolkien",
            "title": "The Lord of the Rings",
            "isbn": "0-395-19395-8",
            "price": 22.99
        }
        ],
        "bicycle": {
        "color": "red",
        "price": 19.95
        }
    },
    "expensive": 10
    }
    """
    x = JSON.lazy(json)
    @test propertynames(x) == [:store, :expensive]
    y = x.store[:][] # All direct properties of store (not recursive).
    @test length(y) == 2 && y[1] isa Vector{Any} && y[2] isa JSON.Object{String, Any}
    y = x.store.bicycle.color[] # The color of the bicycle in the store.
    @test y == "red"
    y = x[~, "price"][] # The prices of all items in the store.
    @test y == [8.95, 8.99, 22.99, 19.95]
    y = x.store.book[:][] # All books in the store.
    @test length(y) == 3 && eltype(y) == JSON.Object{String, Any}
    y = x[~, "book"][1].title[] # The titles of all books in the store.
    @test y == ["Sayings of the Century", "Moby Dick", "The Lord of the Rings"]
    y = x[~, "book"][1][1][] # The first book in the store.
    @test y == Dict("category" => "reference", "author" => "Nigel Rees", "title" => "Sayings of the Century", "price" => 8.95)
    y = x[~, "book"][1][1].author[] # The author of the first book in the store.
    @test y == "Nigel Rees"
    # @test_throws ArgumentError x[~, "book"][1].author[~]
    y = x[~, "book"][1][:, (i, z) -> z.author[] == "J.R.R. Tolkien"].title[] # The titles of all books by J.R.R. Tolkien
    @test y == ["The Lord of the Rings"]
    y = x[~, :][] # All properties of the root object flattened in one list/array
    @test length(y) == 17
    @test_throws KeyError x.foo
    @test_throws KeyError x.store.book[100]
    list = x.store.book[:]
    @test eltype(list) == Any
    @test isassigned(list, 1)
    @test list[:] === list
    @test length(list[[1, 3]]) == 2
    # test that we correctly skip over all kinds of values
    json = """
    {
        "a": 1,
        "a1": 3.14,
        "a2": 100000000000000000000000,
        "a3": 170141183460469231731687303715884105728,
        "a4": 1.7976931348623157e310,
        "b": null,
        "c": true,
        "d": false,
        "e": "hey there sailor",
        "f": [],
        "g": {},
        "h": [1, 2, 3],
        "i": {"a": 1, "b": 2},
        "j": [1, {"a": 1, "b": 2}, 3],
        "k": {"a": 1, "b": [1, 2, 3]},
        "l": [1, {"a": 1, "b": [1, 2, 3]}, 3],
        "m": {"a": 1, "b": {"a": 1, "b": 2}},
        "n": [1, {"a": 1, "b": {"a": 1, "b": 2}}, 3],
        "o": {"a": 1, "b": {"a": 1, "b": [1, 2, 3]}},
        "p": [1, {"a": 1, "b": {"a": 1, "b": [1, 2, 3]}}, 3],
        "q": {"a": 1, "b": {"a": 1, "b": {"a": 1, "b": 2}}},
        "r": [1, {"a": 1, "b": {"a": 1, "b": {"a": 1, "b": 2}}}, 3],
        "s": {"a": 1, "b": {"a": 1, "b": {"a": 1, "b": [1, 2, 3]}}},
        "t": [1, {"a": 1, "b": {"a": 1, "b": {"a": 1, "b": [1, 2, 3]}}}, 3],
        "z": 602
    }
    """
    x = JSON.lazy(json)
    @test x.z[] == 602
    @test JSON.isvalidjson(x)
    json = """
    [
        {
            "a": [1, 2, 3]
        },
        {
            "a": [1, 2, 3]
        }
    ]
    """
    x = JSON.lazy(json)
    @test x[~, "a"][] == [[1, 2, 3], [1, 2, 3]]
    @test x[:].a[] == [[1, 2, 3], [1, 2, 3]]
    @test JSON.isvalidjson(x)
end

using JSON
using Random
using Serialization

const MIN_JSON_BYTES = 512
const MAX_JSON_BYTES = 1024
const MAX_DEPTH = 3
const MIN_CONTAINER_LEN = 3
const MAX_CONTAINER_LEN = 8
const ROOT_STRING_MIN = 32
const ROOT_STRING_MAX = 72
const MAX_STRING_LEN = 64
const PRINT_INTERVAL = 256

function random_ascii_code(rng::AbstractRNG)::UInt8
    return rand(rng, UInt8(32):UInt8(126))
end

function random_string(rng::AbstractRNG, depth::Int)::String
    base = depth == 0 ? rand(rng, ROOT_STRING_MIN:ROOT_STRING_MAX) : rand(rng, 0:MAX_STRING_LEN)
    buffer = Vector{UInt8}(undef, base)
    for i in eachindex(buffer)
        buffer[i] = random_ascii_code(rng)
    end
    return String(buffer)
end

function random_leaf(rng::AbstractRNG)::Any
    choice = rand(rng, 1:8)
    choice == 1 && return rand(rng, -1_000_000:1_000_000)
    choice == 2 && return randn(rng)
    choice == 3 && return rand(rng)
    choice == 4 && return rand(rng, Bool)
    choice == 5 && return nothing
    choice == 6 && return missing
    choice == 7 && return random_string(rng, 1)
    return string(rand(rng, 1:1_000_000), "-", random_string(rng, 1))
end

function random_array(rng::AbstractRNG, depth::Int)::Vector{Any}
    len = rand(rng, MIN_CONTAINER_LEN:MAX_CONTAINER_LEN)
    values = Any[]
    sizehint!(values, len)
    for _ in 1:len
        push!(values, random_value(rng, depth + 1))
    end
    return values
end

function random_object(rng::AbstractRNG, depth::Int)::Dict{String, Any}
    len = rand(rng, MIN_CONTAINER_LEN:MAX_CONTAINER_LEN)
    dict = Dict{String, Any}()
    while length(dict) < len
        key = random_string(rng, depth)
        dict[key] = random_value(rng, depth + 1)
    end
    return dict
end

function random_value(rng::AbstractRNG, depth::Int)::Any
    depth >= MAX_DEPTH && return random_leaf(rng)
    choice = rand(rng)
    choice < 0.4 && return random_array(rng, depth)
    choice < 0.8 && return random_object(rng, depth)
    return random_leaf(rng)
end

function replay_candidate(seed::Integer, attempt::Integer)::Any
    rng = MersenneTwister(seed)
    candidate = nothing
    for i in 1:attempt
        candidate = random_value(rng, 0)
    end
    return candidate
end

function fuzz_pretty(; max_seeds::Int=50_000, attempts_per_seed::Int=64, indent::Int=2,
    min_bytes::Int=MIN_JSON_BYTES, max_bytes::Int=MAX_JSON_BYTES, verbose::Bool=true)
    for seed in 0:max_seeds - 1
        rng = MersenneTwister(seed)
        for attempt in 1:attempts_per_seed
            candidate = random_value(rng, 0)
            compact_len = 0
            try
                compact_len = ncodeunits(JSON.json(candidate))
            catch e
                if e isa BoundsError
                    println("BoundsError (compact) with seed=$(seed) attempt=$(attempt)")
                    filename = joinpath(@__DIR__, "fuzz_pretty_failure_seed$(seed)_attempt$(attempt).bin")
                    Serialization.serialize(filename, candidate)
                    println("Serialized failing candidate to $(filename)")
                    return (seed=seed, attempt=attempt, candidate=candidate, error=e)
                end
                rethrow()
            end
            if compact_len < min_bytes || compact_len > max_bytes
                continue
            end
            try
                JSON.json(candidate, indent)
            catch e
                if e isa BoundsError
                    println("BoundsError with seed=$(seed) attempt=$(attempt) compact_len=$(compact_len)")
                    context = IOContext(stdout, :limit => true)
                    println("Candidate Julia expression:")
                    show(context, MIME"text/plain"(), candidate)
                    println()
                    filename = joinpath(@__DIR__, "fuzz_pretty_failure_seed$(seed)_attempt$(attempt).bin")
                    Serialization.serialize(filename, candidate)
                    println("Serialized failing candidate to $(filename)")
                    return (seed=seed, attempt=attempt, candidate=candidate, error=e)
                end
                rethrow()
            end
            if verbose && attempt % PRINT_INTERVAL == 0
                println("Checked seed=$(seed) attempt=$(attempt) compact_len=$(compact_len)")
            end
        end
    end
    verbose && println("No failure found up to $(max_seeds) seeds")
    return nothing
end

if abspath(PROGRAM_FILE) == @__FILE__
    max_seeds = parse(Int, get(ENV, "JSON_FUZZ_MAX_SEEDS", "50000"))
    attempts = parse(Int, get(ENV, "JSON_FUZZ_ATTEMPTS", "64"))
    result = fuzz_pretty(max_seeds=max_seeds, attempts_per_seed=attempts)
    result === nothing && exit(0)
    println("Replay with replay_candidate($(result.seed), $(result.attempt))")
end

using Test, JSON, Arrow

obj1 = JSON.parse("""
{
    "int": 1,
    "float": 2.1
}
""")

obj2 = JSON.parse("""
{
    "int": 1,
    "float": 2.1,
    "bool1": true,
    "bool2": false,
    "none": null,
    "str": "\\"hey there sailor\\"",
    "arr": [null, 1, "hey"],
    "arr2": [1.2, 3.4, 5.6]
}
""")

obj3 = JSON.parse("""
{
    "int": 1,
    "float": 2.1,
    "bool1": true,
    "bool2": false,
    "none": null,
    "str": "\\"hey there sailor\\"",
    "obj": {
                "a": 1,
                "b": null,
                "c": [null, 1, "hey"],
                "d": [1.2, 3.4, 5.6]
            },
    "arr": [null, 1, "hey"],
    "arr2": [1.2, 3.4, 5.6]
}
""")

tbl = (; json=[obj1, obj2, obj3])

arrow = Arrow.Table(Arrow.tobuffer(tbl))
@test arrow.json[1].int == 1
@test arrow.json[1].float == 2.1

@test arrow.json[2].int == 1
@test arrow.json[2].float == 2.1
@test arrow.json[2].bool1 == true
@test arrow.json[2].bool2 == false
@test arrow.json[2].none === missing
@test arrow.json[2].str == "\"hey there sailor\""
@test isequal(arrow.json[2].arr, [missing, 1, "hey"])
@test arrow.json[2].arr2 == [1.2, 3.4, 5.6]

@test arrow.json[3].int == 1
@test arrow.json[3].float == 2.1
@test arrow.json[3].bool1 == true
@test arrow.json[3].bool2 == false
@test arrow.json[3].none === missing
@test arrow.json[3].str == "\"hey there sailor\""
@test arrow.json[3].obj.a == 1
@test arrow.json[3].obj.b === nothing
@test isequal(arrow.json[3].obj.c, [missing, 1, "hey"])
@test arrow.json[3].obj.d == [1.2, 3.4, 5.6]
@test isequal(arrow.json[3].arr, [missing, 1, "hey"])
@test arrow.json[3].arr2 == [1.2, 3.4, 5.6]

"""
    JSON.parse(json)
    JSON.parse(json, T)
    JSON.parse!(json, x)
    JSON.parsefile(filename)
    JSON.parsefile(filename, T)
    JSON.parsefile!(filename, x)

Parse a JSON input (string, vector, stream, LazyValue, etc.) into a Julia value. The `parsefile` variants
take a filename, open the file, and pass the `IOStream` to `parse`.

Currently supported keyword arguments include:
  * `allownan`: allows parsing `NaN`, `Inf`, and `-Inf` since they are otherwise invalid JSON
  * `ninf`: string to use for `-Inf` (default: `"-Infinity"`)
  * `inf`: string to use for `Inf` (default: `"Infinity"`)
  * `nan`: string to use for `NaN` (default: `"NaN"`)
  * `jsonlines`: treat the `json` input as an implicit JSON array, delimited by newlines, each element being parsed from each row/line in the input
  * `isroot`: whether this is the root LazyValue encompassing the entire json buffer. If `false` parses only the first JSON value and ignores trailing characters. (default: `true`)
  * `dicttype`: a custom `AbstractDict` type to use instead of `$DEFAULT_OBJECT_TYPE` as the default type for JSON object materialization
  * `null`: a custom value to use for JSON null values (default: `nothing`)
  * `unknown_fields`: controls how unmatched JSON object keys or positional values are handled when parsing into a target type or existing object; supported values are `:ignore` (default) and `:error`
  * `style`: a custom `StructUtils.StructStyle` subtype instance to be used in calls to `StructUtils.make` and `StructUtils.lift`. This allows overriding
    default behaviors for non-owned types.

The methods without a type specified (`JSON.parse(json)`, `JSON.parsefile(filename)`), do a generic materialization into
predefined default types, including:
  * JSON object => `$DEFAULT_OBJECT_TYPE` (**see note below**)
  * JSON array => `Vector{Any}`
  * JSON string => `String`
  * JSON number => `Int64`, `BigInt`, `Float64`, or `BigFloat`
  * JSON true => `true`
  * JSON false => `false`
  * JSON null => `nothing`

When a type `T` is specified (`JSON.parse(json, T)`, `JSON.parsefile(filename, T)`), materialization to a value
of type `T` will be attempted utilizing machinery and interfaces provided by the StructUtils.jl package, including:
  * For JSON objects, JSON keys will be matched against field names of `T` with a value being constructed via `T(args...)`
  * If `T` was defined with the `@noarg` macro, an empty instance will be constructed, and field values set as JSON keys match field names
  * If `T` had default field values defined using the `@defaults` or `@kwarg` macros (from StructUtils.jl package), those will be set in the value of `T` unless different values are parsed from the JSON
  * If `T` was defined with the `@nonstruct` macro, the struct will be treated as a primitive type and constructed using the `lift` function rather than from field values
  * JSON keys that don't match field names in `T` will be ignored (skipped over) by default; pass `unknown_fields=:error` to reject them
  * If a field in `T` has a `name` fieldtag, the `name` value will be used to match JSON keys instead
  * If `T` or any recursive field type of `T` is abstract, an appropriate `JSON.@choosetype T x -> ...` definition should exist for "choosing" a concrete type at runtime; default type choosing exists for `Union{T, Missing}` and `Union{T, Nothing}` where the JSON value is checked if `null`. If the `Any` type is encountered, the default materialization types will be used (`JSON.Object`, `Vector{Any}`, etc.)
  * For any non-JSON-standard non-aggregate (i.e. non-object, non-array) field type of `T`, a `JSON.lift(::Type{T}, x) = ...` definition can be defined for how to "lift" the default JSON value (String, Number, Bool, `nothing`) to the type `T`; a default lift definition exists, for example, for `JSON.lift(::Type{Missing}, x) = missing` where the standard JSON value for `null` is `nothing` and it can be "lifted" to `missing`
  * For any `T` or recursive field type of `T` that is `AbstractDict`, non-string/symbol/integer keys will need to have a `StructUtils.liftkey(::Type{T}, x))` definition for how to "lift" the JSON string key to the key type of `T`

For any `T` or recursive field type of `T` that is `JSON.JSONText`, the next full raw JSON value will be preserved in the `JSONText` wrapper as-is.

For the unique case of nested JSON arrays and prior knowledge of the expected dimensionality,
a target type `T` can be given as an `AbstractArray{T, N}` subtype. In this case, the JSON array data is materialized as an
n-dimensional array, where: the number of JSON array nestings must match the Julia array dimensionality (`N`),
nested JSON arrays at matching depths are assumed to have equal lengths, and the length of
the innermost JSON array is the 1st dimension length and so on. For example, the JSON array `[[[1.0,2.0]]]`
would be materialized as a 3-dimensional array of `Float64` with sizes `(2, 1, 1)`, when called
like `JSON.parse("[[[1.0,2.0]]]", Array{Float64, 3})`. Note that n-dimensional Julia
arrays are written to json as nested JSON arrays by default, to enable lossless re-parsing,
though the dimensionality must still be provided explicitly to the call to `parse` (i.e. default parsing via `JSON.parse(json)`
will result in plain nested `Vector{Any}`s returned).

Examples:
```julia
using Dates

abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

JSON.@choosetype AbstractMonster x -> x.monster_type[] == "vampire" ? Dracula : Werewolf

struct Percent <: Number
    value::Float64
end

JSON.lift(::Type{Percent}, x) = Percent(Float64(x))
StructUtils.liftkey(::Type{Percent}, x::String) = Percent(parse(Float64, x))

@defaults struct FrankenStruct
    id::Int = 0
    name::String = "Jim"
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = nothing
    monster::AbstractMonster = Dracula(0)
    percent::Percent = Percent(0.0)
    birthdate::Date = Date(0) &(json=(dateformat="yyyy/mm/dd",),)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}()
    json_properties::JSONText = JSONText("")
    matrix::Matrix{Float64} = Matrix{Float64}(undef, 0, 0)
end

json = \"\"\"
{
    "id": 1,
    "address": "123 Main St",
    "rate": null,
    "franken_type": "b",
    "notsure": {"key": "value"},
    "monster": {
        "monster_type": "vampire",
        "num_victims": 10
    },
    "percent": 0.1,
    "birthdate": "2023/10/01",
    "percentages": {
        "0.1": 1,
        "0.2": 2
    },
    "json_properties": {"key": "value"},
    "matrix": [[1.0, 2.0], [3.0, 4.0]],
    "extra_key": "extra_value"
}
\"\"\"
JSON.parse(json, FrankenStruct)
# FrankenStruct(1, "Jim", "123 Main St", missing, :b, JSON.Object{String, Any}("key" => "value"), Dracula(10), Percent(0.1), Date("2023-10-01"), Dict{Percent, Int64}(Percent(0.2) => 2, Percent(0.1) => 1), JSONText("{\"key\": \"value\"}"), [1.0 3.0; 2.0 4.0])
```

Let's walk through some notable features of the example above:
  * The `name` field isn't present in the JSON input, so the default value of `"Jim"` is used.
  * The `address` field uses a default `@choosetype` to determine that the JSON value is not `null`, so a `String` should be parsed for the field value.
  * The `rate` field has a `null` JSON value, so the default `@choosetype` recognizes it should be "lifted" to `Missing`, which then uses a predefined `lift` definition for `Missing`.
  * The `type` field is a `Symbol`, and has a fieldtag `json=(name="franken_type",)` which means the JSON key `franken_type` will be used to set the field value instead of the default `type` field name. A default `lift` definition for `Symbol` is used to convert the JSON string value to a `Symbol`.
  * The `notsure` field is of type `Any`, so the default object type `JSON.Object{String, Any}` is used to materialize the JSON value.
  * The `monster` field is a polymorphic type, and the JSON value has a `monster_type` key that determines which concrete type to use. The `@choosetype` macro is used to define the logic for choosing the concrete type based on the JSON input. Note that teh `x` in `@choosetype` is a `LazyValue`, so we materialize via `x.monster_type[]` in order to compare with the string `"vampire"`.
  * The `percent` field is a custom type `Percent` and the `JSON.lift` defines how to construct a `Percent` from the JSON value, which is a `Float64` in this case.
  * The `birthdate` field uses a custom date format for parsing, specified in the JSON input.
  * The `percentages` field is a dictionary with keys of type `Percent`, which is a custom type. The `liftkey` function is defined to convert the JSON string keys to `Percent` types (parses the Float64 manually)
  * The `json_properties` field has a type of `JSONText`, which means the raw JSON will be preserved as a String of the `JSONText` type.
  * The `matrix` field is a `Matrix{Float64}`, so the JSON input array-of-arrays are materialized as such.
  * The `extra_key` field is not defined in the `FrankenStruct` type, so it is ignored and skipped over.

NOTE:
Why use `JSON.Object{String, Any}` as the default object type? It provides several benefits:
  * Behaves as a drop-in replacement for `Dict{String, Any}`, so no loss of functionality
  * Performance! It's internal representation means memory savings and faster construction for small objects typical in JSON (vs `Dict`)
  * Insertion order is preserved, so the order of keys in the JSON input is preserved in `JSON.Object`
  * Convenient `getproperty` (i.e. `obj.key`) syntax is supported, even for `Object{String,Any}` key types (again ideal/specialized for JSON usage)

`JSON.Object` internal representation uses a linked list, thus key lookups are linear time (O(n)). For *large* JSON objects,
(hundreds or thousands of keys), consider using a `Dict{String, Any}` instead, like `JSON.parse(json; dicttype=Dict{String, Any})`.
"""
function parse end

import StructUtils: StructStyle

abstract type JSONStyle <: StructStyle end

# defining a custom style allows us to pass a non-default dicttype `O` through JSON.parse,
# while still delegating custom behavior to an inner StructStyle if one was provided
struct JSONReadStyle{O,T,S} <: JSONStyle
    null::T
    style::S
    ignore_unknown_fields::Bool
end

JSONReadStyle{O}(null::T, style::S=StructUtils.DefaultStyle(), ignore_unknown_fields::Bool=true) where {O,T,S} =
    JSONReadStyle{O,T,S}(null, style, ignore_unknown_fields)

objecttype(::StructStyle) = DEFAULT_OBJECT_TYPE
objecttype(::JSONReadStyle{OT}) where {OT} = OT
nullvalue(::StructStyle) = nothing
nullvalue(st::JSONReadStyle) = st.null

StructUtils.initialize(::JSONReadStyle, ::Type{Object}, source) = DEFAULT_OBJECT_TYPE()

# this allows struct fields to specify tags under the json key specifically to override JSON behavior
StructUtils.fieldtagkey(::JSONStyle) = :json
StructUtils.defaultstate(st::JSONReadStyle) = StructUtils.defaultstate(st.style)
StructUtils.orderedfields(::JSONReadStyle) = true

# forward StructUtils API to the inner style so user-provided JSONStyle dispatches are honored
StructUtils.dictlike(st::JSONReadStyle, ::Type{T}) where {T} = StructUtils.dictlike(st.style, T)
StructUtils.arraylike(st::JSONReadStyle, ::Type{T}) where {T} = StructUtils.arraylike(st.style, T)
StructUtils.nulllike(st::JSONReadStyle, ::Type{T}) where {T} = StructUtils.nulllike(st.style, T)
# Keep structlike forwarding specific to custom JSONStyle wrappers so type-level StructStyle
# specializations (for example @nonstruct types) continue to dispatch without ambiguity.
StructUtils.structlike(st::JSONReadStyle{O,N,S}, ::Type{T}) where {O,N,S<:JSONStyle,T} =
    StructUtils.structlike(st.style, T)
StructUtils.structlike(st::JSONReadStyle{O,N,S}, ::Type{T}) where {O,N,S<:JSONStyle,T<:NamedTuple} =
    StructUtils.structlike(st.style, T)

function jsonreadstyle(::Type{T}, ::Type{O}, null, style::StructStyle, unknown_fields::Symbol) where {T,O}
    ignore_unknown_fields =
        unknown_fields === :ignore ? true :
        unknown_fields === :error ? false :
        throw(ArgumentError(string(
            "`unknown_fields` must be `:ignore` or `:error`, got ",
            _unknownoption(unknown_fields),
        )))
    if T === Any && !ignore_unknown_fields
        throw(ArgumentError("`unknown_fields` is only supported when parsing into a target type or existing object"))
    end
    return JSONReadStyle{O}(null, style, ignore_unknown_fields)
end

# Use the writer's existing byte escape table. This keeps error text accurate
# without pulling generic `repr` and type-display machinery into trim images.
function _quotedstring(key::AbstractString)
    n = escapelength(key) + 2
    buf = Vector{UInt8}(undef, n)
    _string(buf, 1, key, nothing, n)
    return String(buf)
end

function _unknownoption(option::Symbol)
    value = String(option)
    return Base.isidentifier(value) ? string(':', value) :
        string("Symbol(", _quotedstring(value), ')')
end
_unknownkey(key::PtrString) = _quotedstring(convert(String, key))
_unknownkey(key::AbstractString) = _quotedstring(key)
_unknownkey(key::Symbol) = _unknownoption(key)
_unknownkey(key::Integer) = string(key)
_unknownkey(key) = "<key>"

@noinline unknownfielderror(::Type{T}, key) where {T} = ArgumentError(string(
    "encountered unknown JSON member ",
    _unknownkey(key),
    " while parsing `",
    _typename(T),
    "`",
))

function StructUtils.unknownfield(st::JSONReadStyle, ::Type{T}, key, value) where {T}
    st.ignore_unknown_fields || throw(unknownfielderror(T, key))
    return StructUtils.unknownfield(st.style, T, key, value)
end

"See [`parse`](@ref)."
function parsefile end

"See [`parse`](@ref)."
function parsefile! end

parsefile(file; jsonlines::Union{Bool,Nothing}=nothing, kw...) = open(io -> parse(io; jsonlines=(jsonlines === nothing ? isjsonl(file) : jsonlines), kw...), file)
parsefile(file, ::Type{T}; jsonlines::Union{Bool,Nothing}=nothing, kw...) where {T} = open(io -> parse(io, T; jsonlines=(jsonlines === nothing ? isjsonl(file) : jsonlines), kw...), file)
parsefile!(file, x::T; jsonlines::Union{Bool,Nothing}=nothing, kw...) where {T} = open(io -> parse!(io, x; jsonlines=(jsonlines === nothing ? isjsonl(file) : jsonlines), kw...), file)

parse(io::Union{IO,Base.AbstractCmd}, ::Type{T}=Any; kw...) where {T} = parse(Base.read(io), T; kw...)

parse!(io::Union{IO,Base.AbstractCmd}, x::T; kw...) where {T} = parse!(Base.read(io), x; kw...)

# No forced @inline through the entry chain: inlining the typed descent into
# these forwarding bodies makes each entry's compilation unit re-optimize the
# entire per-type parse tower instead of calling the already-compiled
# instances (measured at +12s on the first parse of a 35-field Union-typed
# struct, and 30-50% of the first parse of a 13-type struct family). The buffer
# entry therefore calls the positional core directly. Typed customization for
# buffer inputs stays at the StructUtils style/make/lift boundary. A parse
# method specialized on LazyValue applies when the caller passes one directly.
parse(buf::Union{AbstractVector{UInt8},AbstractString}, ::Type{T}=Any;
    dicttype::Type{O}=DEFAULT_OBJECT_TYPE, null=nothing, style::StructStyle=StructUtils.DefaultStyle(),
    unknown_fields::Symbol=:ignore, kw...) where {T,O} =
    _parse(lazy(buf; kw...), T, dicttype, null, jsonreadstyle(T, O, null, style, unknown_fields))

parse!(buf::Union{AbstractVector{UInt8},AbstractString}, x::T;
    dicttype::Type{O}=DEFAULT_OBJECT_TYPE, null=nothing, style::StructStyle=StructUtils.DefaultStyle(),
    unknown_fields::Symbol=:ignore, kw...) where {T,O} =
    StructUtils.make!(jsonreadstyle(typeof(x), O, null, style, unknown_fields), x, lazy(buf; kw...))

parse(x::LazyValue, ::Type{T}=Any;
    dicttype::Type{O}=DEFAULT_OBJECT_TYPE, null=nothing, style::StructStyle=StructUtils.DefaultStyle(),
    unknown_fields::Symbol=:ignore) where {T,O} =
    _parse(x, T, dicttype, null, jsonreadstyle(T, O, null, style, unknown_fields))

function _parse(x::LazyValue, ::Type{T}, dicttype::Type{O}, null, style::StructStyle) where {T,O}
    y, pos = StructUtils.make(style, T, x)
    getisroot(x) && checkendpos(x, T, pos)
    return y
end

mutable struct ValueClosure
    value::Any
    ValueClosure() = new()
end

(f::ValueClosure)(v) = setfield!(f, :value, v)

function _parse(x::LazyValue, ::Type{Any}, ::Type{DEFAULT_OBJECT_TYPE}, null, ::StructStyle)
    out = ValueClosure()
    pos = applyvalue(out, x, null)
    getisroot(x) && checkendpos(x, Any, pos)
    return out.value
end

parse!(x::LazyValue, obj::T;
    dicttype::Type{O}=DEFAULT_OBJECT_TYPE, null=nothing, style::StructStyle=StructUtils.DefaultStyle(),
    unknown_fields::Symbol=:ignore) where {T,O} =
    StructUtils.make!(jsonreadstyle(T, O, null, style, unknown_fields), obj, x)

# for LazyValue, if x started at the beginning of the JSON input,
# then we want to ensure that the entire input was consumed
# and error if there are any trailing invalid JSON characters
function checkendpos(x::LazyValue, ::Type{T}, pos::Int) where {T}
    buf = getbuf(x)
    len = getlength(buf)
    if pos <= len
        b = getbyte(buf, pos)
        while b == UInt8('\t') || b == UInt8(' ') || b == UInt8('\n') || b == UInt8('\r')
            pos += 1
            pos > len && break
            b = getbyte(buf, pos)
        end
    end
    if (pos - 1) != len
        invalid(InvalidChar, buf, pos, T)
    end
    return nothing
end

# specialized closure to optimize Object{String, Any} insertions
# to avoid doing a linear scan on each insertion, we use a Set
# to track keys seen so far. In the common case of non-duplicated key,
# we can insert the new key-val pair directly after the latest leaf node
mutable struct ObjectClosure{T}
    root::Object{String,Any}
    obj::Object{String,Any}
    keys::Set{String}
    null::T
end

ObjectClosure(obj, null) = ObjectClosure(obj, obj, sizehint!(Set{String}(), 16), null)

@inline function insert_or_overwrite!(oc::ObjectClosure, key, val)
    # in! does both a hash lookup and also sets the key if not present
    if _in!(key, oc.keys)
        # slow path for dups; does a linear scan from our root object
        setindex!(oc.root, val, key)
        return
    end
    # this uses an "unsafe" constructor that returns the new leaf node
    # and sets the child of the previous node to the new node
    oc.obj = Object{String,Any}(oc.obj, key, val) # fast append path
end

(oc::ObjectClosure)(k, v) = applyvalue(val -> insert_or_overwrite!(oc, convert(String, k), val), v, oc.null)

# generic apply `f` to LazyValue, using default types to materialize, depending on type
function applyvalue(f, x::LazyValues, null)
    type = gettype(x)
    if type == JSONTypes.OBJECT
        obj = Object{String,Any}()
        pos = applyobject(ObjectClosure(obj, null), x)
        f(obj)
        return pos
    elseif type == JSONTypes.ARRAY
        # basically free to allocate 16 instead of Julia-default 8 and avoids
        # a reallocation in many cases
        arr = Vector{Any}(undef, 16)
        resize!(arr, 0)
        pos = applyarray(x) do _, v
            applyvalue(val -> push!(arr, val), v, null)
        end
        f(arr)
        return pos
    elseif type == JSONTypes.STRING
        buf = getbuf(x)
        GC.@preserve buf begin
            str, pos = parsestring(x)
            f(convert(String, str))
        end
        return pos
    elseif type == JSONTypes.NUMBER
        num, pos = parsenumber(x)
        if isint(num)
            f(num.int)
        elseif isfloat(num)
            f(num.float)
        elseif isbigint(num)
            f(num.bigint)
        else
            f(num.bigfloat)
        end
        return pos
    elseif type == JSONTypes.NULL
        f(null)
        return getpos(x) + 4
    elseif type == JSONTypes.TRUE
        f(true)
        return getpos(x) + 4
    elseif type == JSONTypes.FALSE
        f(false)
        return getpos(x) + 5
    else
        throw(ArgumentError("cannot parse json"))
    end
end

# we overload make! for Any for LazyValues because we can dispatch to more specific
# types base on the LazyValue type
function StructUtils.make(st::StructStyle, ::Type{Any}, x::LazyValues)
    type = gettype(x)
    if type == JSONTypes.OBJECT
        return StructUtils.make(st, objecttype(st), x)
    elseif type == JSONTypes.ARRAY
        return StructUtils.make(st, Vector{Any}, x)
    elseif type == JSONTypes.STRING
        return StructUtils.lift(st, String, x)
    elseif type == JSONTypes.NUMBER
        return StructUtils.lift(st, Number, x)
    elseif type == JSONTypes.NULL
        return StructUtils.lift(st, Nothing, x)
    elseif type == JSONTypes.TRUE || type == JSONTypes.FALSE
        return StructUtils.lift(st, Bool, x)
    else
        throw(ArgumentError("cannot parse $x"))
    end
end

# catch PtrString via lift or make! so we can ensure it never "escapes" to user-level
StructUtils.liftkey(st::JSONReadStyle, ::Type{T}, x::PtrString) where {T} =
    StructUtils.liftkey(st, T, convert(String, x))
StructUtils.lift(st::JSONReadStyle, ::Type{T}, x::PtrString, tags) where {T} =
    StructUtils.lift(st, T, convert(String, x), tags)
StructUtils.lift(st::JSONReadStyle, ::Type{T}, x::PtrString) where {T} =
    StructUtils.lift(st, T, convert(String, x))

# liftkey for numeric dict key types to enable round-tripping Dict{Int,V}, Dict{Float64,V}, etc.
# these correspond to the lowerkey definitions in write.jl that convert numeric keys to strings
StructUtils.liftkey(::JSONReadStyle, ::Type{T}, x::AbstractString) where {T<:Integer} = Base.parse(T, x)
StructUtils.liftkey(::JSONReadStyle, ::Type{T}, x::AbstractString) where {T<:AbstractFloat} = Base.parse(T, x)

_isliftpair(x) = x isa Tuple && !(x isa NamedTuple) && length(x) == 2
_liftresult(x, st) = _isliftpair(x) ? x : (x, StructUtils.defaultstate(st))
_liftresult(x, pos::Int) = _isliftpair(x) ? x : (x, pos)

struct _NoCustomLazyLift end
const _NO_CUSTOM_LAZY_LIFT = _NoCustomLazyLift()

StructUtils.lift(::JSONStyle, ::Type{T}, ::LazyValues, tags) where {T} = _NO_CUSTOM_LAZY_LIFT
StructUtils.lift(::JSONStyle, ::Type{T}, ::LazyValues) where {T} = _NO_CUSTOM_LAZY_LIFT

StructUtils.lift(style::JSONReadStyle, ::Type{T}, x, tags) where {T} =
    _liftresult(StructUtils.lift(style.style, T, x, tags), style)
StructUtils.lift(style::JSONReadStyle, ::Type{T}, x) where {T} =
    _liftresult(StructUtils.lift(style.style, T, x), style)

function customlazylift(style::JSONReadStyle, ::Type{T}, x::LazyValues, tags) where {T}
    inner = style.style
    inner isa JSONStyle || return nothing
    ret = StructUtils.lift(inner, T, x, tags)
    ret === _NO_CUSTOM_LAZY_LIFT || return _liftresult(ret, skip(x))
    ret = StructUtils.lift(inner, T, x)
    ret === _NO_CUSTOM_LAZY_LIFT || return _liftresult(ret, skip(x))
    return nothing
end

function StructUtils.lift(style::JSONReadStyle, ::Type{T}, x::LazyValues) where {T<:AbstractArray{E,0}} where {E}
    m = T(undef)
    m[1], pos = StructUtils.lift(style, E, x)
    return m, pos
end

function StructUtils.lift(style::JSONReadStyle, ::Type{T}, x::LazyValues, tags=(;)) where {T}
    type = gettype(x)
    buf = getbuf(x)
    if type == JSONTypes.OBJECT || type == JSONTypes.ARRAY
        custom = customlazylift(style, T, x, tags)
        custom === nothing || return custom
    end
    if type == JSONTypes.STRING
        GC.@preserve buf begin
            ptrstr, pos = parsestring(x)
            str, _ = StructUtils.lift(style, T, ptrstr, tags)
        end
        return str, pos
    elseif type == JSONTypes.NUMBER
        num, pos = parsenumber(x)
        if isint(num)
            T === Int64 && return num.int, pos
            int, _ = StructUtils.lift(style, T, num.int, tags)
            return int, pos
        elseif isfloat(num)
            T === Float64 && return num.float, pos
            float, _ = StructUtils.lift(style, T, num.float, tags)
            return float, pos
        elseif isbigint(num)
            T === BigInt && return num.bigint, pos
            bigint, _ = StructUtils.lift(style, T, num.bigint, tags)
            return bigint, pos
        else
            T === BigFloat && return num.bigfloat, pos
            bigfloat, _ = StructUtils.lift(style, T, num.bigfloat, tags)
            return bigfloat, pos
        end
    elseif type == JSONTypes.NULL
        null, _ = StructUtils.lift(style, T, nullvalue(style), tags)
        return null, getpos(x) + 4
    elseif type == JSONTypes.TRUE
        tr, _ = StructUtils.lift(style, T, true, tags)
        return tr, getpos(x) + 4
    elseif type == JSONTypes.FALSE
        fl, _ = StructUtils.lift(style, T, false, tags)
        return fl, getpos(x) + 5
    elseif Base.issingletontype(T)
        sglt, _ = StructUtils.lift(style, T, T(), tags)
        return sglt, skip(x)
    else
        out = ValueClosure()
        pos = applyvalue(out, x, nothing)
        val1 = out.value
        # big switch here for --trim verify-ability
        if val1 isa Object{String,Any}
            val, _ = StructUtils.lift(style, T, val1, tags)
            return val, pos
        elseif val1 isa Vector{Any}
            val, _ = StructUtils.lift(style, T, val1, tags)
            return val, pos
        elseif val1 isa String
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa Int64
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa Float64
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa BigInt
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa BigFloat
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa Bool
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        elseif val1 isa Nothing
            val, _ = StructUtils.lift(style, T, val1)
            return val, pos
        else
            throw(ArgumentError("cannot parse json"))
        end
    end
end

function StructUtils.make(::StructStyle, ::Type{JSONText}, x::LazyValues)
    buf = getbuf(x)
    pos = getpos(x)
    endpos = skip(x)
    val = GC.@preserve buf JSONText(unsafe_string(pointer(buf, pos), endpos - pos))
    return val, endpos
end

@generated function StructUtils.maketuple(st::StructStyle, ::Type{T}, x::LazyValues) where {T<:Tuple}
    N = fieldcount(T)
    ex = quote
        pos::Int = getpos(x)
        buf = getbuf(x)
        len = getlength(buf)
        opts = getopts(x)
        b = getbyte(buf, pos)
        typ = gettype(x)
        if typ == JSONTypes.OBJECT && b != UInt8('{')
            error = ExpectedOpeningObjectChar
            @goto invalid
        elseif typ == JSONTypes.ARRAY && b != UInt8('[')
            error = ExpectedOpeningArrayChar
            @goto invalid
        elseif typ != JSONTypes.OBJECT && typ != JSONTypes.ARRAY
            error = InvalidJSON
            @goto invalid
        end
        pos += 1
        @nextbyte
        Base.@nexprs $N i -> begin
            if typ == JSONTypes.OBJECT
                # consume key
                GC.@preserve buf begin
                    _, pos = @inline parsestring(LazyValue(buf, pos, JSONTypes.STRING, opts, false))
                end
                @nextbyte
                if b != UInt8(':')
                    error = ExpectedColon
                    @goto invalid
                end
                pos += 1
                @nextbyte
            end
            x = _lazy(buf, pos, len, b, opts)
            j_{i}, pos = StructUtils.make(st, fieldtype(T, i), x)
            @nextbyte
            if typ == JSONTypes.OBJECT && b == UInt8('}')
                if Base.@nany($N, k->!@isdefined(j_{k}))
                    error = InvalidJSON
                    @goto invalid
                end
                return Base.@ntuple($N, j), pos + 1
            elseif typ == JSONTypes.ARRAY && b == UInt8(']')
                if Base.@nany($N, k->!@isdefined(j_{k}))
                    error = InvalidJSON
                    @goto invalid
                end
                return Base.@ntuple($N, j), pos + 1
            elseif b != UInt8(',')
                error = ExpectedComma
                @goto invalid
            end
            pos += 1
            @nextbyte
        end
        # skip extra fields not used by tuple
        while true
            if typ == JSONTypes.OBJECT
                # consume key
                GC.@preserve buf begin
                    _, pos = @inline parsestring(LazyValue(buf, pos, JSONTypes.STRING, opts, false))
                end
                @nextbyte
                if b != UInt8(':')
                    error = ExpectedColon
                    @goto invalid
                end
                pos += 1
                @nextbyte
            end
            pos = skip(_lazy(buf, pos, len, b, opts))
            @nextbyte
            if typ == JSONTypes.OBJECT && b == UInt8('}')
                return Base.@ntuple($N, j), pos + 1
            elseif typ == JSONTypes.ARRAY && b == UInt8(']')
                return Base.@ntuple($N, j), pos + 1
            elseif b != UInt8(',')
                error = ExpectedComma
                @goto invalid
            end
            pos += 1
            @nextbyte
        end
        @label invalid
        invalid(error, buf, pos, "tuple")
    end
    return ex
end

struct NotSet end
const notset = NotSet()

"""
    JSON.Object{K,V}

A mutable `AbstractDict` type for JSON objects. Internally is a linked list of key-value pairs, where each pair is represented by an `Object` instance. The first instance is the root object.
The `Object` type is used to represent JSON objects in a mutable way, allowing for efficient insertion and deletion of key-value pairs. It is designed to be used with the `JSON` package for parsing and deserializing JSON data.

Because of the linked-list representation, key lookups are O(n), using a simple linear scan.
For small objects, this is very efficient, and worth the memory overhead vs. a full `Dict` or `OrderedDict`.
For Objects with many entries (hundreds or thousands), this is not as efficient. In that case, consider using a `Dict` or `OrderedDict` instead.
"""
# empty Object: key, value, child all notset
# root Object: key, value are notset, child is defined
# non-root Object: key, value are set, child is notset for last node
mutable struct Object{K,V} <: AbstractDict{K,V}
    key::Union{NotSet, K} # for root object, key/value are notset
    value::Union{NotSet, V}
    child::Union{NotSet, Object{K,V}} # possibly notset

    # root constructor: key is const notset
    function Object{K,V}() where {K,V}
        x = new{K,V}(notset, notset, notset)
        return x
    end

    # all non-root Objects *must* be set as the child of another Object
    # WARNING: this constructor can allow duplicate `k` in a root Object as no check is done
    function Object{K,V}(obj::Object{K,V}, k, v) where {K,V}
        @assert _ch(obj) === notset "Object child already defined"
        nobj = new{K,V}(k, v, notset)
        setfield!(obj, :child, nobj)
        return nobj
    end
end

Object() = Object{Any, Any}() # default empty object

_k(obj::Object) = getfield(obj, :key)
_v(obj::Object) = getfield(obj, :value)
_ch(obj::Object) = getfield(obj, :child)

Object(d::AbstractDict{K,V}) where {K,V} = Object{K,V}(d)

function Object{K,V}(d::AbstractDict{K,V}) where {K,V}
    root = obj = Object{K,V}()
    for (k, v) in d
        obj = Object{K,V}(obj, k, v)
    end
    return root
end

Object(pairs::Pair{K,V}...) where {K,V} = Object{K,V}(pairs...)
Object(pairs::Pair...) = Object{Any,Any}(pairs...)

function Object{K,V}(pairs::Pair...) where {K,V}
    root = obj = Object{K,V}()
    for (k, v) in pairs
        obj = Object{K,V}(obj, k, v)
    end
    return root
end

# generic iterator constructors
function Object(itr)
    root = obj = nothing
    st = iterate(itr)
    while st !== nothing
        kv, state = st
        if kv isa Pair || kv isa Tuple{Any,Any}
            k, v = kv
            if root === nothing
                root = Object{typeof(k), typeof(v)}()
                obj = root
            end
            obj = Object{typeof(k), typeof(v)}(obj, k, v)
        else
            throw(ArgumentError("Iterator must yield Pair or 2-tuple, got $(typeof(kv))"))
        end
        st = iterate(itr, state)
    end
    return root === nothing ? Object{Any,Any}() : root
end

function Object{K,V}(itr) where {K,V}
    root = obj = Object{K,V}()
    st = iterate(itr)
    while st !== nothing
        kv, state = st
        if kv isa Pair || kv isa Tuple{Any,Any}
            k, v = kv
            obj = Object{K, V}(obj, k, v)
        else
            throw(ArgumentError("Iterator must yield Pair or 2-tuple, got $(typeof(kv))"))
        end
        st = iterate(itr, state)
    end
    return root
end

function Base.iterate(orig::Object{K,V}, obj=orig) where {K,V}
    obj === nothing && return nothing
    if _k(obj) === notset
        # if key is notset, we either have to iterate from the child or we're done
        return _ch(obj) === notset ? nothing : iterate(_ch(obj)::Object{K,V})
    end
    return (Pair{K,V}(_k(obj)::K, _v(obj)::V), _ch(obj) === notset ? nothing : _ch(obj)::Object{K,V})
end

function Base.length(obj::Object{K,V}) where {K,V}
    count = 0
    while true
        _k(obj) !== notset && (count += 1)
        _ch(obj) === notset && break
        obj = _ch(obj)::Object{K,V}
    end
    return count
end
Base.isempty(obj::Object) = _k(obj) === notset && _ch(obj) === notset
Base.empty(::Object{K,V}) where {K,V} = Object{K,V}() # empty object

# linear node lookup
@inline function find_node_by_key(obj::Object{K,V}, key) where {K,V}
    while true
        _k(obj) !== notset && isequal(_k(obj)::K, key) && return obj
        _ch(obj) === notset && break
        obj = _ch(obj)::Object{K,V}
    end
    return nothing
end

# get with fallback callable
function Base.get(f::Base.Callable, obj::Object{K,V}, key) where {K,V}
    node = find_node_by_key(obj, key)
    node !== nothing && return _v(node)::V
    return f()
end
Base.get(f::Base.Callable, obj::Object{String}, key::Symbol) = get(f, obj, String(key))
Base.get(f::Base.Callable, obj::Object{Symbol}, key::String) = get(f, obj, Symbol(key))

Base.getindex(obj::Object, key) = get(() -> throw(KeyError(key)), obj, key)
Base.getindex(obj::Object{String}, key::Symbol) = get(() -> throw(KeyError(key)), obj, String(key))
Base.getindex(obj::Object{Symbol}, key::String) = get(() -> throw(KeyError(key)), obj, Symbol(key))
Base.setindex!(obj::Object{String,V}, value, key::AbstractString) where {V} = _setindex!(obj, value, String(key))
Base.setindex!(obj::Object{String,V}, value, key::Symbol) where {V} = _setindex!(obj, value, String(key))
Base.setindex!(obj::Object{Symbol}, value, key::String) = setindex!(obj, value, Symbol(key))
Base.delete!(obj::Object{String,V}, key::AbstractString) where {V} = _delete!(obj, String(key))
Base.delete!(obj::Object{String,V}, key::Symbol) where {V} = _delete!(obj, String(key))
Base.delete!(obj::Object{Symbol}, key::String) = delete!(obj, Symbol(key))
Base.get(obj::Object, key, default) = get(() -> default, obj, key)
Base.get(obj::Object{String}, key::Symbol, default) = get(obj, String(key), default)
Base.get(obj::Object{Symbol}, key::String, default) = get(obj, Symbol(key), default)

# support getproperty for dot access
Base.getproperty(obj::Object{Symbol}, sym::Symbol) = getindex(obj, sym)
Base.getproperty(obj::Object{String}, sym::Symbol) = getindex(obj, String(sym))
Base.propertynames(obj::Object{K,V}) where {K,V} = _k(obj) === notset && _ch(obj) === notset ? () : _propertynames(_ch(obj)::Object{K,V}, ())

function _propertynames(obj::Object{K,V}, acc) where {K,V}
    new = (acc..., Symbol(_k(obj)::K))
    return _ch(obj) === notset ? new : _propertynames(_ch(obj)::Object{K,V}, new)
end

# haskey
Base.haskey(obj::Object, key) = find_node_by_key(obj, key) !== nothing
Base.haskey(obj::Object{String}, key::Symbol) = haskey(obj, String(key))
Base.haskey(obj::Object{Symbol}, key::String) = haskey(obj, Symbol(key))

# setindex! finds node with key and sets value or inserts a new node
function _setindex!(obj::Object{K,V}, value, key::K) where {K,V}
    root = obj
    while true
        if _k(obj) !== notset && isequal(_k(obj)::K, key)
            setfield!(obj, :value, convert(V, value))
            return root
        end
        _ch(obj) === notset && break
        obj = _ch(obj)::Object{K,V}
    end
    # if we reach here, we need to insert a new node
    Object{K,V}(obj, key, value)
    return value
end
Base.setindex!(obj::Object{K,V}, value, key::K) where {K,V} = _setindex!(obj, value, key)

# delete! removes node
function _delete!(obj::Object{K,V}, key::K) where {K,V}
    # check empty case
    _ch(obj) === notset && return obj
    root = parent = obj
    obj = _ch(obj)::Object{K,V}
    while true
        if _k(obj) !== notset && isequal(_k(obj)::K, key)
            # we found the node to remove
            # if node is leaf, we need to set parent as leaf
            # otherwise, we set child as child of parent
            if _ch(obj) === notset
                setfield!(parent, :child, notset)
            else
                setfield!(parent, :child, _ch(obj)::Object{K,V})
            end
        end
        _ch(obj) === notset && break
        parent = obj
        obj = _ch(obj)::Object{K,V}
    end
    return root
end
Base.delete!(obj::Object{K,V}, key::K) where {K,V} = _delete!(obj, key)

function Base.empty!(obj::Object)
    setfield!(obj, :child, notset)
    return obj
end

# support setproperty for dot access
Base.setproperty!(obj::Object, sym::Symbol, val) = setindex!(obj, val, sym)
Base.setproperty!(obj::Object{String}, sym::Symbol, val) = setindex!(obj, val, String(sym))

Base.merge(a::NamedTuple, b::Object{String,Any}) = merge(a, (Symbol(k) => v for (k, v) in b))

const root_json = """
{
  "store": {
    "book": [
      {
        "id": 1,
        "category": "reference",
        "author": "Nigel Rees",
        "title": "Sayings of the Century",
        "price": 8.95,
        "tags": ["classic", "quotes"],
        "available": true,
        "metadata": null
      },
      {
        "id": 2,
        "category": "fiction",
        "author": "Herman Melville",
        "title": "Moby Dick",
        "isbn": "0-553-21311-3",
        "price": 8.99,
        "tags": ["whale", "sea", "epic"],
        "available": false,
        "metadata": {
          "pages": 635,
          "language": "en",
          "awards": []
        }
      },
      {
        "id": 3,
        "category": "fiction",
        "author": "J.R.R. Tolkien",
        "title": "The Lord of the Rings",
        "isbn": "0-395-19395-8",
        "price": 22.99,
        "tags": ["fantasy", "adventure"],
        "available": true,
        "metadata": {
          "pages": 1216,
          "language": "en",
          "awards": ["Prometheus Hall of Fame"]
        }
      }
    ],
    "bicycle": {
      "id": "bike123",
      "color": "red",
      "price": 19.95,
      "features": {
        "gears": 21,
        "electric": false,
        "dimensions": {
          "length_cm": 180,
          "height_cm": 110,
          "weight_kg": 14.5
        }
      }
    },
    "warehouse": [
      {
        "location": "North",
        "inventory": {
          "books": 1500,
          "bicycles": 34,
          "lastRestock": "2024-11-15T10:30:00Z",
          "active": true
        }
      },
      {
        "location": "South",
        "inventory": {
          "books": 980,
          "bicycles": 12,
          "lastRestock": null,
          "active": false
        }
      }
    ]
  },
  "expensive": 10,
  "config": {
    "version": "1.2.3",
    "featuresEnabled": ["wishlist", "reviews", "recommendations"],
    "limits": {
      "maxBooksPerUser": 20,
      "maxSessions": 5,
      "discounts": {
        "student": 0.15,
        "senior": 0.2
      }
    },
    "debug": false
  },
  "users": [
    {
      "id": 1001,
      "name": "Alice",
      "email": "alice@example.com",
      "lastLogin": "2025-03-27T16:45:00Z",
      "preferences": {
        "language": "en",
        "currency": "USD",
        "newsletter": true
      }
    },
    {
      "id": 1002,
      "name": "Bob",
      "email": null,
      "lastLogin": null,
      "preferences": {
        "language": "fr",
        "currency": "EUR",
        "newsletter": false
      }
    }
  ]
}
"""
struct Preferences
    language::String
    currency::String
    newsletter::Bool
end

struct User
    id::Int
    name::String
    email::Union{String, Nothing}
    lastLogin::Union{String, Nothing}
    preferences::Preferences
end

struct Discounts
    student::Float64
    senior::Float64
end

struct Limits
    maxBooksPerUser::Int
    maxSessions::Int
    discounts::Discounts
end

struct Config
    version::String
    featuresEnabled::Vector{String}
    limits::Limits
    debug::Bool
end

struct Inventory
    books::Int
    bicycles::Int
    lastRestock::Union{String, Nothing}
    active::Bool
end

struct Warehouse
    location::String
    inventory::Inventory
end

struct BikeDimensions
    length_cm::Int
    height_cm::Int
    weight_kg::Float64
end

struct BikeFeatures
    gears::Int
    electric::Bool
    dimensions::BikeDimensions
end

struct Bicycle
    id::String
    color::String
    price::Float64
    features::BikeFeatures
end

struct BookMetadata
    pages::Int
    language::String
    awards::Vector{String}
end

struct Book
    id::Int
    category::String
    author::String
    title::String
    price::Float64
    tags::Vector{String}
    available::Bool
    metadata::Union{BookMetadata, Nothing}
end

struct Store
    book::Vector{Book}
    bicycle::Bicycle
    warehouse::Vector{Warehouse}
end

struct Root
    store::Store
    expensive::Int
    config::Config
    users::Vector{User}
end

using JSON, Test, Tar

include(joinpath(dirname(pathof(JSON)), "../test/object.jl"))
include(joinpath(dirname(pathof(JSON)), "../test/lazy.jl"))
include(joinpath(dirname(pathof(JSON)), "../test/parse.jl"))
include(joinpath(dirname(pathof(JSON)), "../test/escaped_keys.jl"))
include(joinpath(dirname(pathof(JSON)), "../test/inbound_tags.jl"))
include(joinpath(dirname(pathof(JSON)), "../test/json.jl"))
# Arrow.jl is broken on 32 bit systems for now :(
if Sys.WORD_SIZE == 64
    include(joinpath(dirname(pathof(JSON)), "../test/arrow.jl"))
end
include(joinpath(dirname(pathof(JSON)), "../test/trim_compile_tests.jl"))

function tar_files(tarball::String)
    data = Dict{String, Vector{UInt8}}()
    buf = Vector{UInt8}(undef, Tar.DEFAULT_BUFFER_SIZE)
    io = IOBuffer()
    open(tarball) do tio
        Tar.read_tarball(_ -> true, tio; buf=buf) do header, _
            if header.type == :file
                take!(io) # In case there are multiple entries for the file
                Tar.read_data(tio, io; size=header.size, buf)
                data[header.path] = take!(io)
            end
        end
    end
    data
end

# JSONTestSuite

function parse_testfile(i, file, data)
    # known failures on 14, 32, 33 (all are "i_...", meaning the spec is ambiguous anyway)
      # 14: i_string_UTF-16LE_with_BOM.json, we don't support UTF-16
      # 32: i_string_utf16BE_no_BOM.json, we don't support UTF-16
      # 33: i_string_utf16LE_no_BOM.json, we don't support UTF-16
    if startswith(file, "n_")
        try
            JSON.parse(data)
            @warn "no error thrown while parsing json test file" file=file i=i
            @test !(file isa String)
        catch
            @test file isa String
        end
    elseif startswith(file, "i_")
        try
            JSON.parse(data)
        catch
            @warn "error thrown while parsing json test file" file=file i=i
        end
    else
        try
            JSON.parse(data)
            @test file isa String
        catch
            @warn "error thrown while parsing json test file" file=file i=i
            @test !(file isa String)
            rethrow()
        end
    end
end

println("\nTest cases 70, 85, and 104 are expected to emit warnings next\n")
const jsontestsuite = tar_files(joinpath(dirname(pathof(JSON)), "../test/JSONTestSuite.tar"))
@testset "JSONTestSuite" begin
    for (i, (file, data)) in enumerate(jsontestsuite)
        parse_testfile(i, file, data)
    end
end

# jsonchecker

function parse_testfile2(i, file, data)
    if startswith(file, "fail")
        try
            JSON.parse(data)
            @warn "no error thrown while parsing json test file" file=file i=i
            @test !(file isa String)
        catch
            @test file isa String
        end
    else
        try
            JSON.parse(data)
            @test file isa String
        catch
            @warn "error thrown while parsing json test file" file=file i=i
            @test !(file isa String)
            rethrow()
        end
    end
end

const jsonchecker = tar_files(joinpath(dirname(pathof(JSON)), "../test/jsonchecker.tar"))
@testset "jsonchecker" begin
    for (i, (file, data)) in enumerate(jsonchecker)
        parse_testfile2(i, file, data)
    end
end

@testset "fuzz_catch" begin
    x = [
        "688665-N6iC);2mb[)>uBbVU@].&/r7[8bB",
        false,
        Any[Dict{String, Any}("nMJe 9'H9l1z;15`(\"{a62V[N[y:GWb" => 339018, "8<\"7-~fgEzt5edi@-Q" => -0.24880373028918779, "UT)*=)&kQu[,< g;E+.('v=,1_zZUZuV*" => 939542, "=BYKHNx>y" => "UsTIrR[.G!(9a~y V8eX\",3q8Ue^B]lFpbU7x6@8]l5.wr;RN~", "" => false, "JOg*[CX.c4Zd!qG )CQN;RPq3J&Iq]0,!rc+,XWd}'`[ZE:/e[\$Py}<CCS\\Op" => "8+iqM[[x7U9M?\\`?DNm", "QMW<`6S[" => missing, "mf&,q;4=fIsz5&Hf:H!1<Y2?qCSYT|o5qW/}0:vDJ*^FX!*|F\" N=8.1+{#\\ +IH" => 710995), Any[936790, false, nothing, "954676-=\$\"u+bblP;RihZ}ME{0h^C`#F4!2AY[VvYD\$eqK0x-)GOn_o3gc` nf^1_MZuh", "850152-\$:QqPP8-v%{'U^& B0%"], Any[true, false, 0.22466108267242246, 841509, "%?-NI"]],
        nothing
    ]
    @test JSON.json(x, 2) isa String
end

using Test
using JSON
import Pkg

const _TRIM_SUPPORTED = VERSION >= v"1.12.0-rc1"
const _JULIAC_ENTRYPOINT_EXPR = "using JuliaC; if isdefined(JuliaC, :main); JuliaC.main(ARGS); else JuliaC._main_cli(ARGS); end"
const _TRIM_COMPILE_TIMEOUT_S = 300.0
const _TRIM_RUN_TIMEOUT_S = 60.0

function _json_project_path()::String
    return normpath(joinpath(dirname(pathof(JSON)), ".."))
end

function _prepare_trim_project(project_path::String, trim_project::String)::Nothing
    mkpath(trim_project)
    cp(joinpath(@__DIR__, "trim", "Project.toml"), joinpath(trim_project, "Project.toml"))
    original_project = Base.active_project()
    try
        Pkg.activate(trim_project)
        Pkg.develop(Pkg.PackageSpec(path = project_path))
        Pkg.instantiate()
    finally
        if original_project !== nothing
            Pkg.activate(dirname(original_project))
        end
    end
    return nothing
end

function _run_command_with_timeout(cmd::Cmd; timeout_s::Float64, log_label::String)
    output_path = tempname()
    out = open(output_path, "w")
    exit_code = -1
    timed_out = false
    try
        proc = run(pipeline(ignorestatus(cmd), stdout = out, stderr = out); wait = false)
        timed_out = _wait_process_with_timeout!(proc; timeout_s, log_label)
        exit_code = something(proc.exitcode, -1)
    finally
        close(out)
    end
    output = try
        read(output_path, String)
    catch
        ""
    finally
        rm(output_path; force = true)
    end
    return exit_code, output, timed_out
end

function _wait_process_with_timeout!(proc::Base.Process; timeout_s::Float64, log_label::String)::Bool
    started_at = time()
    next_log_at = started_at + 10.0
    while Base.process_running(proc)
        now = time()
        if now - started_at >= timeout_s
            try
                kill(proc)
            catch
            end
            return true
        end
        if now >= next_log_at
            elapsed = round(now - started_at; digits = 1)
            println("[trim] $(log_label) WAIT $(elapsed)s")
            flush(stdout)
            next_log_at = now + 10.0
        end
        sleep(0.1)
    end
    try
        wait(proc)
    catch
    end
    return false
end

function _trim_timeout_error(kind::String, script_file::String, output::String = "")
    msg = "trim $(kind) timed out for $(script_file)"
    if !isempty(output)
        msg = string(msg, "\n---- captured output ----\n", output, "\n---- end captured output ----")
    end
    throw(ArgumentError(msg))
end

function _maybe_print_output(header::String, output::String)::Nothing
    isempty(output) && return nothing
    println(header)
    println(output)
    println("---- end output ----")
    return nothing
end

function _run_trim_compile(trim_project::String, script_path::String, output_name::String)
    julia_exe = joinpath(Sys.BINDIR, Base.julia_exename())
    cmd = `$julia_exe --startup-file=no --history-file=no --code-coverage=none --project=$trim_project -e $(_JULIAC_ENTRYPOINT_EXPR) -- --output-exe $output_name --project=$trim_project --experimental --trim=safe $script_path`
    return _run_command_with_timeout(cmd; timeout_s = _TRIM_COMPILE_TIMEOUT_S, log_label = "compile")
end

function _run_trim_executable(run_path::String)
    return _run_command_with_timeout(`$(abspath(run_path))`; timeout_s = _TRIM_RUN_TIMEOUT_S, log_label = "run")
end

function _parse_trim_verify_totals(output::String)
    m = match(r"Trim verify finished with\s+(\d+)\s+errors,\s+(\d+)\s+warnings\.", output)
    m === nothing && return nothing
    return parse(Int, m.captures[1]), parse(Int, m.captures[2])
end

function _count_trim_verify_messages(output::String)::Tuple{Int, Int}
    errors = length(collect(eachmatch(r"Verifier error #\d+:", output)))
    warnings = length(collect(eachmatch(r"Verifier warning #\d+:", output)))
    return errors, warnings
end

function _run_trim_case(trim_project::String, script_file::String, output_name::String)::Nothing
    script_path = joinpath(@__DIR__, script_file)
    @test isfile(script_path)
    println("[trim] compile START $(script_file)")
    start_t = time()
    mktempdir() do tmpdir
        cd(tmpdir) do
            exit_code, output, timed_out = _run_trim_compile(trim_project, script_path, output_name)
            timed_out && _trim_timeout_error("compile", script_file, output)
            totals = _parse_trim_verify_totals(output)
            trim_errors, trim_warnings = if totals === nothing
                fallback = _count_trim_verify_messages(output)
                if exit_code == 0 && fallback == (0, 0)
                    fallback
                else
                    error("failed to parse trim verifier summary:\n$output")
                end
            else
                totals
            end
            if trim_errors > 0 || trim_warnings > 0
                _maybe_print_output("---- trim compile output ($(script_file)) ----", output)
            end
            @test trim_errors == 0
            @test trim_warnings == 0
            output_path = Sys.iswindows() ? "$(output_name).exe" : output_name
            @test exit_code == 0
            @test isfile(output_path)
            run_exit, run_output, run_timed_out = _run_trim_executable(output_path)
            run_timed_out && _trim_timeout_error("executable run", script_file, run_output)
            if run_exit != 0
                _maybe_print_output("---- trim executable output ($(script_file)) ----", run_output)
            end
            @test run_exit == 0
        end
    end
    println("[trim] compile DONE $(script_file) ($(round(time() - start_t; digits = 2))s)")
    return nothing
end

@testset "Trim compile" begin
    if Sys.iswindows()
        println("[trim] skip Windows: JuliaC trim compilation is currently too slow or stalls on Windows CI")
        @test true
    elseif Sys.WORD_SIZE != 64
        println("[trim] skip 32-bit Julia: JuliaC trim compilation is only covered on 64-bit test jobs")
        @test true
    elseif !_TRIM_SUPPORTED
        println("[trim] skip Julia < 1.12: JuliaC trim compilation is unavailable")
        @test true
    else
        project_path = _json_project_path()
        mktempdir() do tmpdir
            trim_project = joinpath(tmpdir, "trim_project")
            _prepare_trim_project(project_path, trim_project)
            _run_trim_case(trim_project, "json_trim_public_entrypoints.jl", "json_trim_public_entrypoints")
        end
    end
end

"""
    JSON.lazy(json; kw...)
    JSON.lazyfile(file; kw...)

Detect the initial JSON value in `json`, returning a `JSON.LazyValue` instance. `json` input can be:
  * `AbstractString`
  * `AbstractVector{UInt8}`
  * `IO`, `IOStream`, `Cmd` (bytes are fully read into a `Vector{UInt8}` for parsing, i.e. `read(json)` is called)

`lazyfile` is a convenience method that takes a filename and opens the file before calling `lazy`.

The `JSON.LazyValue` supports the "selection" syntax
for lazily navigating the JSON value. For example (`x = JSON.lazy(json)`):
  * `x.key`, `x[:key]` or `x["key"]` for JSON objects
  * `x[1]`, `x[2:3]`, `x[end]` for JSON arrays
  * `propertynames(x)` to see all keys in the JSON object
  * `x.a.b.c` for selecting deeply nested values
  * `x[~, (k, v) -> k == "foo"]` for recursively searching for key "foo" and return matching values

NOTE: Selecting values from a `LazyValue` will always return a `LazyValue`.
Selecting a specific key of an object or index of an array will only parse
what is necessary before returning. This leads to a few conclusions about
how to effectively utilize `LazyValue`:
  * `JSON.lazy` is great for one-time access of a value in JSON
  * It's also great for finding a required deeply nested value
  * It's not great for any case where repeated access to values is required;
    this results in the same JSON being parsed on each access (i.e. naively iterating a lazy JSON array will be O(n^2))
  * Best practice is to use `JSON.lazy` sparingly unless there's a specific case where it will benefit;
    or use `JSON.lazy` as a means to access a value that is then fully materialized

Another option for processing `JSON.LazyValue` is calling `foreach(f, x)` which is defined on
`JSON.LazyValue` for JSON objects and arrays. For objects, `f` should be of the form
`f(kv::Pair{String, LazyValue})` where `kv` is a key-value pair, and for arrays,
`f(v::LazyValue)` where `v` is the value at the index. This allows for iterating over all key-value pairs in an object
or all values in an array without materializing the entire structure.

Lazy values can be materialized via `JSON.parse` in a few different forms:
  * `JSON.parse(json)`: Default materialization into `JSON.Object` (a Dict-like type), `Vector{Any}`, etc.
  * `JSON.parse(json, T)`: Materialize into a user-provided type `T` (following rules/programmatic construction from StructUtils.jl)
  * `JSON.parse!(json, x)`: Materialize into an existing object `x` (following rules/programmatic construction from StructUtils.jl)

Thus for completeness sake, here's an example of ideal usage of `JSON.lazy`:

```julia
x = JSON.lazy(very_large_json_object)
# find a deeply nested value
y = x.a.b.c.d.e.f.g
# materialize the value
z = JSON.parse(y)
# now mutate/repeatedly access values in z
```

In this example, we only parsed as much of the `very_large_json_object` as was required to find the value `y`.
Then we fully materialized `y` into `z`, which is now a normal Julia object. We can now mutate or access values in `z`.

Currently supported keyword arguments include:
  - `allownan::Bool = false`: whether "special" float values shoudl be allowed while parsing (`NaN`, `Inf`, `-Inf`); these values are specifically _not allowed_ in the JSON spec, but many JSON libraries allow reading/writing
  - `ninf::String = "-Infinity"`: the string that will be used to parse `-Inf` if `allownan=true`
  - `inf::String = "Infinity"`: the string that will be used to parse `Inf` if `allownan=true`
  - `nan::String = "NaN"`: the string that will be sued to parse `NaN` if `allownan=true`
  - `jsonlines::Bool = false`: whether the JSON input should be treated as an implicit array, with newlines separating individual JSON elements with no leading `'['` or trailing `']'` characters. Common in logging or streaming workflows. Defaults to `true` when used with `JSON.parsefile` and the filename extension is `.jsonl` or `ndjson`. Note this ensures that parsing will _always_ return an array at the root-level.
  - `duplicate_keys::Symbol = :overwrite`: how repeated object keys are handled. `:overwrite` preserves the default last-value-wins behavior. `:error` throws [`JSON.DuplicateKeyError`](@ref).
  - `isroot::Bool = true`: whether this is the root LazyValue encompassing the entire json buffer. If `false` parses only the first JSON value and ignores trailing characters.

Note that validation is only fully done on `null`, `true`, and `false`,
while other values are only lazily inferred from the first non-whitespace character:
  * `'{'`: JSON object
  * `'['`: JSON array
  * `'"'`: JSON string
  * `'0'`-`'9'` or `'-'`: JSON number

Further validation for these values is done later when materialized, like `JSON.parse`,
or via selection syntax calls on a `LazyValue`.
"""
function lazy end

# helper struct we pack lazy-parsing keyword args into
# held by LazyValues for access
@kwdef struct LazyOptions
    allownan::Bool = false
    ninf::String = "-Infinity"
    inf::String = "Infinity"
    nan::String = "NaN"
    jsonlines::Bool = false
    duplicate_keys::Symbol = :overwrite
end

lazy(io::Union{IO, Base.AbstractCmd}; kw...) = lazy(Base.read(io); kw...)

lazyfile(file; jsonlines::Union{Bool, Nothing}=nothing, kw...) = open(io -> lazy(io; jsonlines=(jsonlines === nothing ? isjsonl(file) : jsonlines), kw...), file)

"See [`lazy`](@ref)."
lazyfile

function lazy(buf::Union{AbstractVector{UInt8}, AbstractString}; isroot::Bool=true, kw...)
    opts = LazyOptions(; kw...)
    opts.duplicate_keys in (:overwrite, :error) || throw(ArgumentError("`duplicate_keys` must be `:overwrite` or `:error`, got `$(repr(opts.duplicate_keys))`"))
    if !applicable(pointer, buf, 1) || (buf isa AbstractVector{UInt8} && !isone(only(strides(buf))))
        if buf isa AbstractString
            buf = String(buf)
        else
            buf = Vector{UInt8}(buf)
        end
    end
    len = getlength(buf)
    if len == 0
        error = UnexpectedEOF
        pos = 0
        @goto invalid
    end
    pos = 1
    # detect and error on UTF-16LE BOM
    if len >= 2 && getbyte(buf, pos) == 0xff && getbyte(buf, pos + 1) == 0xfe
        error = InvalidUTF16
        @goto invalid
    end
    # detect and error on UTF-16BE BOM
    if len >= 2 && getbyte(buf, pos) == 0xfe && getbyte(buf, pos + 1) == 0xff
        error = InvalidUTF16
        @goto invalid
    end
    # detect and ignore UTF-8 BOM
    pos = (len >= 3 && getbyte(buf, pos) == 0xef && getbyte(buf, pos + 1) == 0xbb && getbyte(buf, pos + 2) == 0xbf) ? pos + 3 : pos
    @nextbyte
    return _lazy(buf, pos, len, b, opts, isroot)

@label invalid
    invalid(error, buf, pos, Any)
end

"""
    JSON.LazyValue

A lazy representation of a JSON value. The `LazyValue` type
supports the "selection" syntax for lazily navigating the JSON value.
Lazy values can be materialized via `JSON.parse(x)`, `JSON.parse(x, T)`, or `JSON.parse!(x, y)`.
"""
struct LazyValue{T}
    buf::T # wrapped json source, AbstractVector{UInt8} or AbstractString
    pos::Int # byte position in buf where this value starts
    type::JSONTypes.T # scoped enum for type of value: OBJECT, ARRAY, etc.
    opts::LazyOptions
    isroot::Bool # true if this is the root LazyValue
end

# convenience types only used for defining `show` on LazyValue
# this allows, for example, a LazyValue w/ type OBJECT to be
# displayed like a Dict using Base AbstractDict machinery
# while a LazyValue w/ type ARRAY is displayed like an Array
struct LazyObject{T} <: AbstractDict{String, LazyValue}
    buf::T
    pos::Int
    opts::LazyOptions
    isroot::Bool
    LazyObject(x::LazyValue{T}) where {T} = new{T}(getbuf(x), getpos(x), getopts(x), getisroot(x))
end

struct LazyArray{T} <: AbstractVector{LazyValue}
    buf::T
    pos::Int
    opts::LazyOptions
    isroot::Bool
    LazyArray(x::LazyValue{T}) where {T} = new{T}(getbuf(x), getpos(x), getopts(x), getisroot(x))
end

# helper accessors so we can overload getproperty for convenience
getbuf(x) = getfield(x, :buf)
getpos(x) = getfield(x, :pos)
gettype(x) = getfield(x, :type)
getopts(x) = getfield(x, :opts)
getisroot(x) = getfield(x, :isroot)

const LazyValues{T} = Union{LazyValue{T}, LazyObject{T}, LazyArray{T}}

# default materialization that calls parse
Base.getindex(x::LazyValues) = parse(x)

# some overloads/usage of StructUtils + LazyValues
# this defines all the right getproperty, getindex methods
Selectors.@selectors LazyValues

Base.lastindex(x::LazyValues) = length(x)

# this ensures LazyValues can be "sources" in StructUtils.make
function StructUtils.applyeach(::StructUtils.StructStyle, f, x::LazyValues)
    type = gettype(x)
    if type == JSONTypes.OBJECT
        return applyobject(f, x)
    elseif type == JSONTypes.ARRAY
        return applyarray(f, x)
    end
    typename = get(JSONTypes.names, type, "UNKNOWN")
    throw(ArgumentError(string(
        "applyeach not applicable for `",
        _typename(typeof(x)),
        "` with JSON type = `JSONTypes.",
        typename,
        '`',
    )))
end

@inline function Base.foreach(f, x::LazyValues)
    type = gettype(x)
    if type == JSONTypes.OBJECT
        applyobject((k, v) -> f(convert(String, k) => v), x)
    elseif type == JSONTypes.ARRAY
        applyarray((i, v) -> f(v), x)
    else
        throw(ArgumentError("foreach not applicable for `$(typeof(x))` with JSON type = `$type`"))
    end
    return
end

StructUtils.structlike(::StructUtils.StructStyle, x::LazyValues) = gettype(x) == JSONTypes.OBJECT
StructUtils.arraylike(::StructUtils.StructStyle, x::LazyValues) = gettype(x) == JSONTypes.ARRAY
StructUtils.nulllike(::StructUtils.StructStyle, x::LazyValues) = gettype(x) == JSONTypes.NULL

# core method that detects what JSON value is at the current position
# and immediately returns an appropriate LazyValue instance
function _lazy(buf, pos::Int, len, b, opts, isroot=false)
    if opts.jsonlines
        return LazyValue(buf, pos, JSONTypes.ARRAY, opts, isroot)
    elseif b == UInt8('{')
        return LazyValue(buf, pos, JSONTypes.OBJECT, opts, isroot)
    elseif b == UInt8('[')
        return LazyValue(buf, pos, JSONTypes.ARRAY, opts, isroot)
    elseif b == UInt8('"')
        return LazyValue(buf, pos, JSONTypes.STRING, opts, isroot)
    elseif b == UInt8('n') && pos + 3 <= len &&
        getbyte(buf, pos + 1) == UInt8('u') &&
        getbyte(buf, pos + 2) == UInt8('l') &&
        getbyte(buf, pos + 3) == UInt8('l')
        return LazyValue(buf, pos, JSONTypes.NULL, opts, isroot)
    elseif b == UInt8('t') && pos + 3 <= len &&
        getbyte(buf, pos + 1) == UInt8('r') &&
        getbyte(buf, pos + 2) == UInt8('u') &&
        getbyte(buf, pos + 3) == UInt8('e')
        return LazyValue(buf, pos, JSONTypes.TRUE, opts, isroot)
    elseif b == UInt8('f') && pos + 4 <= len &&
        getbyte(buf, pos + 1) == UInt8('a') &&
        getbyte(buf, pos + 2) == UInt8('l') &&
        getbyte(buf, pos + 3) == UInt8('s') &&
        getbyte(buf, pos + 4) == UInt8('e')
        return LazyValue(buf, pos, JSONTypes.FALSE, opts, isroot)
    elseif b == UInt8('-') || (UInt8('0') <= b <= UInt8('9')) || (opts.allownan && (b == UInt8('+') || firstbyteeq(opts.nan, b) || firstbyteeq(opts.ninf, b) || firstbyteeq(opts.inf, b)))
        return LazyValue(buf, pos, JSONTypes.NUMBER, opts, isroot)
    else
        error = InvalidJSON
        @goto invalid
    end
@label invalid
    if !opts.allownan
        # quick check if the value here is inf/nan/+1 and we can provide
        # a more helpful error message about how to parse
        if b in (UInt8('N'), UInt8('n'), UInt8('I'), UInt8('i'), UInt8('+'))
            throw(ArgumentError("JSON parsing error: possible `NaN`, `Inf`, or `-Inf` which are not valid JSON values. Use the `allownan=true` option and `ninf`, `inf`, and/or `nan` keyword arguments to parse."))
        end
    end
    invalid(error, buf, pos, Any)
end

# core JSON object parsing function
# takes a `keyvalfunc` that is applied to each key/value pair
# `keyvalfunc` receives a PtrString => LazyValue pair
# `keyvalfunc` can return `StructUtils.EarlyReturn` to short-circuit parsing
# otherwise, it should return a `pos::Int` value that notes the next position to continue parsing
# to materialize the key, call `convert(String, key)`
# PtrString can be compared to String via `==` or `isequal` to help avoid allocating the full String in some cases
# returns a `pos` value that notes the next position where parsing should continue
# this is essentially the `StructUtils.applyeach` implementation for LazyValues w/ type OBJECT
function applyobject(keyvalfunc, x::LazyValues)
    pos::Int = getpos(x)
    buf = getbuf(x)
    len = getlength(buf)
    opts = getopts(x)
    seen = opts.duplicate_keys === :error ? Set{String}() : nothing
    b = getbyte(buf, pos)
    if b != UInt8('{')
        error = ExpectedOpeningObjectChar
        @goto invalid
    end
    pos += 1
    @nextbyte
    b == UInt8('}') && return pos + 1
    while true
        # parsestring returns key as a PtrString
        keypos = pos
        GC.@preserve buf begin
            key, pos = @inline parsestring(LazyValue(buf, pos, JSONTypes.STRING, opts, false))
            if seen !== nothing
                decoded = convert(String, key)
                decoded in seen && throw(DuplicateKeyError(decoded, keypos))
                push!(seen, decoded)
            end
            @nextbyte
            if b != UInt8(':')
                error = ExpectedColon
                @goto invalid
            end
            pos += 1
            @nextbyte
            # we're now positioned at the start of the value
            val = _lazy(buf, pos, len, b, opts)
            ret = keyvalfunc(key, val)
        end
        # if ret is an EarlyReturn, then we're short-circuiting
        # parsing via e.g. selection syntax, so return immediately
        ret isa StructUtils.EarlyReturn && return ret
        # if keyvalfunc didn't materialize `val` and return an
        # updated `pos`, then we need to skip val ourselves
        # WARNING: parsing can get corrupted if random Int values are returned from keyvalfunc
        pos = (ret isa Int && ret > pos) ? ret : skip(val)
        @nextbyte
        # check for terminating conditions
        if b == UInt8('}')
            return pos + 1
        elseif b != UInt8(',')
            error = ExpectedComma
            @goto invalid
        end
        pos += 1 # move past ','
        @nextbyte
    end
@label invalid
    invalid(error, buf, pos, "object")
end

# jsonlines is unique because it's an *implicit* array
# so newlines are valid delimiters (not ignored whitespace)
# and EOFs are valid terminators (not errors)
# these checks are injected after we've processed the "line"
# so we need to check for EOFs and newlines
macro jsonlines_checks()
    esc(quote
        # if we're at EOF, then we're done
        pos > len && return pos
        # now we want to ignore whitespace, but *not* newlines
        b = getbyte(buf, pos)
        while b == UInt8(' ') || b == UInt8('\t')
            pos += 1
            pos > len && return pos
            b = getbyte(buf, pos)
        end
        # any combo of '\r', '\n', or '\r\n' is a valid delimiter
        foundr = false
        if b == UInt8('\r')
            foundr = true
            pos += 1
            pos > len && return pos
            b = getbyte(buf, pos)
        end
        if b == UInt8('\n')
            pos += 1
            pos > len && return pos
            b = getbyte(buf, pos)
        elseif !foundr
            # if we didn't find a newline and we're not EOF
            # then that's an error; only whitespace, newlines,
            # and EOFs are valid in between lines
            error = ExpectedNewline
            @goto invalid
        end
        # since we found a newline, we now ignore all whitespace, including newlines (empty lines)
        # until we find EOF or non-whitespace
        while b == UInt8(' ') || b == UInt8('\t') || b == UInt8('\n') || b == UInt8('\r')
            pos += 1
            pos > len && return pos
            b = getbyte(buf, pos)
        end
    end)
end

# core JSON array parsing function
# takes a `keyvalfunc` that is applied to each index => value element
# `keyvalfunc` is provided a Int => LazyValue pair
# applyeach always requires a key-value pair function
# so we use the index as the key
# returns a `pos` value that notes the next position where parsing should continue
# this is essentially the `StructUtils.applyeach` implementation for LazyValues w/ type ARRAY
function applyarray(keyvalfunc, x::LazyValues)
    pos::Int = getpos(x)
    buf = getbuf(x)
    len = getlength(buf)
    opts = getopts(x)
    jsonlines = opts.jsonlines
    b = getbyte(buf, pos)
    if !jsonlines
        if b != UInt8('[')
            error = ExpectedOpeningArrayChar
            @goto invalid
        end
        pos += 1
        @nextbyte
        b == UInt8(']') && return pos + 1
    else
        # for jsonlines, we need to make sure that recursive
        # lazy values *don't* consider individual lines *also*
        # to be jsonlines
        opts = LazyOptions(; allownan=opts.allownan, ninf=opts.ninf, inf=opts.inf, nan=opts.nan, jsonlines=false, duplicate_keys=opts.duplicate_keys)
    end
    i = 1
    while true
        # we're now positioned at the start of the value
        val = _lazy(buf, pos, len, b, opts)
        ret = keyvalfunc(i, val)
        ret isa StructUtils.EarlyReturn && return ret
        # if keyvalfunc didn't materialize `val` and return an
        # updated `pos`, then we need to skip val ourselves
        # WARNING: parsing can get corrupted if random Int values are returned from keyvalfunc
        pos = (ret isa Int && ret > pos) ? ret : skip(val)
        if jsonlines
            @jsonlines_checks
        else
            @nextbyte
            if b == UInt8(']')
                return pos + 1
            elseif b != UInt8(',')
                error = ExpectedComma
                @goto invalid
            end
            pos += 1 # move past ','
            @nextbyte
        end
        i += 1
    end

@label invalid
    invalid(error, buf, pos, "array")
end

# temporary string type to enable deferrment of string allocation in certain cases (like navigating a lazy structure)
struct PtrString
    ptr::Ptr{UInt8}
    len::Int
    escaped::Bool
end

if VERSION < v"1.11"
    mem(n) = Vector{UInt8}(undef, n)
    _tostr(m::Vector{UInt8}, slen) = ccall(:jl_array_to_string, Ref{String}, (Any,), resize!(m, slen))
else
    mem(n) = Memory{UInt8}(undef, n)
    _tostr(m::Memory{UInt8}, slen) = ccall(:jl_genericmemory_to_string, Ref{String}, (Any, Int), m, slen)
end

function Base.convert(::Type{String}, x::PtrString)
    if x.escaped
        m = mem(x.len)
        slen = GC.@preserve m unsafe_unescape_to_buffer(x.ptr, x.len, pointer(m))
        return _tostr(m, slen)
    end
    return unsafe_string(x.ptr, x.len)
end

Base.convert(::Type{Symbol}, x::PtrString) = x.escaped ?
    Symbol(convert(String, x)) :
    ccall(:jl_symbol_n, Ref{Symbol}, (Ptr{UInt8}, Int), x.ptr, x.len)

function Base.convert(::Type{T}, x::PtrString) where {T <: Enum}
    sym = convert(Symbol, x)
    for (k, v) in Base.Enums.namemap(T)
        v === sym && return T(k)
    end
    throw(ArgumentError("invalid `$T` string value: \"$sym\""))
end

Base.:(==)(x::PtrString, y::AbstractString) = x.escaped ?
    convert(String, x) == y :
    x.len == sizeof(y) && ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), x.ptr, pointer(y), x.len) == 0
Base.:(==)(x::AbstractString, y::PtrString) = y == x
Base.:(==)(x::PtrString, y::PtrString) = x.escaped || y.escaped ?
    convert(String, x) == convert(String, y) :
    x.len == y.len && ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), x.ptr, y.ptr, x.len) == 0
Base.isequal(x::PtrString, y::AbstractString) = x == y
Base.isequal(x::AbstractString, y::PtrString) = y == x
Base.isequal(x::PtrString, y::PtrString) = x == y
Base.hash(x::PtrString, h::UInt) = x.escaped ?
    hash(convert(String, x), h) :
    hash(unsafe_string(x.ptr, x.len), h)
StructUtils.keyeq(x::PtrString, y::AbstractString) = x == y
StructUtils.keyeq(x::PtrString, y::String) = x == y
StructUtils.keyeq(x::PtrString, y::Symbol) = convert(Symbol, x) == y

# JSON owns PtrString and its comparison semantics, so it can use the ordered
# field cursor without changing StructUtils' behavior for arbitrary key types.
@inline StructUtils.orderedfieldmatch(x::PtrString, field::String) = x == field

# core JSON string parsing function
# returns a PtrString and the next position to parse
# a PtrString is a semi-lazy, internal-only representation
# that notes whether escape characters were encountered while parsing
# or not. It allows materialize, _binary, etc. to deal
# with the string data appropriately without forcing a String allocation
# PtrString should NEVER be visible to users though!
function parsestring(x::LazyValue)
    buf, pos = getbuf(x), getpos(x)
    len, b = getlength(buf), getbyte(buf, pos)
    if b != UInt8('"')
        error = ExpectedOpeningQuoteChar
        @goto invalid
    end
    pos += 1
    spos = pos
    escaped = false
    @nextbyte(false)
    while b != UInt8('"')
        # disallow raw control characters within a JSON string
        b <= UInt8(0x1F) && unescaped_control(b)
        if b == UInt8('\\')
            # skip next character
            escaped = true
            if pos + 2 > len
                error = UnexpectedEOF
                @goto invalid
            end
            pos += 2
        else
            pos += 1
        end
        @nextbyte(false)
    end
    str = PtrString(pointer(buf, spos), pos - spos, escaped)
    return str, pos + 1

@label invalid
    invalid(error, buf, pos, "string")
end

# core JSON number parsing function
# we rely on functionality in Parsers to help infer what kind
# of number we're parsing; valid return types include:
# Int64, BigInt, Float64 or BigFloat
const INT64_OVERFLOW_VAL = div(typemax(Int64), 10)
const INT64_OVERFLOW_DIGIT = typemax(Int64) % 10

macro check_special(special, value)
    esc(quote
        pos = startpos
        b = getbyte(buf, pos)
        bytes = codeunits($special)
        i = 1
        while b == @inbounds(bytes[i])
            pos += 1
            i += 1
            i > length(bytes) && break
            if pos > len
                error = UnexpectedEOF
                @goto invalid
            end
            b = getbyte(buf, pos)
            i += 1
        end
        if i > length(bytes)
            return NumberResult($value), pos
        end
    end)
end

const INT = 0x00
const FLOAT = 0x01
const BIGINT = 0x02
const BIGFLOAT = 0x03
const BIG_ZERO = BigInt(0)

struct NumberResult
    tag::UInt8
    int::Int64
    float::Float64
    bigint::BigInt
    bigfloat::BigFloat
    NumberResult(int::Int64) = new(INT, int)
    NumberResult(float::Float64) = new(FLOAT, Int64(0), float)
    NumberResult(bigint::BigInt) = new(BIGINT, Int64(0), 0.0, bigint)
    NumberResult(bigfloat::BigFloat) = new(BIGFLOAT, Int64(0), 0.0, BIG_ZERO, bigfloat)
end

isint(x::NumberResult) = x.tag == INT
isfloat(x::NumberResult) = x.tag == FLOAT
isbigint(x::NumberResult) = x.tag == BIGINT
isbigfloat(x::NumberResult) = x.tag == BIGFLOAT

@inline function parsenumber(x::LazyValue)
    buf = getbuf(x)
    pos::Int = getpos(x)
    len = getlength(buf)
    opts = getopts(x)
    b = getbyte(buf, pos)
    startpos = pos
    isneg = isfloat = overflow = false
    if !opts.allownan
        val = Int64(0)
        isneg = b == UInt8('-')
        if isneg || b == UInt8('+') # spec doesn't allow leading +, but we do
            pos += 1
            if pos > len
                error = UnexpectedEOF
                @goto invalid
            end
            b = getbyte(buf, pos)
        end
        # Parse integer part, check for leading zeros (invalid JSON)
        if b == UInt8('0')
            pos += 1
            if pos <= len
                b = getbyte(buf, pos)
                if UInt8('0') <= b <= UInt8('9')
                    error = InvalidNumber
                    @goto invalid
                end
            end
        elseif UInt8('1') <= b <= UInt8('9')
            while UInt8('0') <= b <= UInt8('9')
                digit = Int64(b - UInt8('0'))
                if val > INT64_OVERFLOW_VAL || (val == INT64_OVERFLOW_VAL && digit > INT64_OVERFLOW_DIGIT)
                    overflow = true
                    break
                end
                val = Int64(10) * val + digit
                pos += 1
                pos > len && break
                b = getbyte(buf, pos)
            end
            if overflow
                bval = BigInt(val)
                while UInt8('0') <= b <= UInt8('9')
                    digit = BigInt(b - UInt8('0'))
                    bval = BigInt(10) * bval + digit
                    pos += 1
                    pos > len && break
                    b = getbyte(buf, pos)
                end
            end
        else
            error = InvalidNumber
            @goto invalid
        end
        # Check for decimal or exponent
        if b == UInt8('.') || b == UInt8('e') || b == UInt8('E')
            isfloat = true
            # in strict JSON spec, we need at least one digit after the decimal
            if b == UInt8('.')
                pos += 1
                if pos > len
                    error = UnexpectedEOF
                    @goto invalid
                end
                b = getbyte(buf, pos)
                if !(UInt8('0') <= b <= UInt8('9'))
                    error = InvalidNumber
                    @goto invalid
                end
            end
        end
    end
    if isfloat || opts.allownan
        if opts.allownan
            # check for NaN, Inf, -Inf
            @check_special(opts.nan, NaN)
            @check_special(opts.inf, Inf)
            @check_special(opts.ninf, -Inf)
        end
        res = Parsers.xparse2(Float64, buf, startpos, len)
        if !opts.allownan && Parsers.specialvalue(res.code)
            # if we overflowed, then let's try BigFloat
            bres = Parsers.xparse2(BigFloat, buf, startpos, len)
            if !Parsers.invalid(bres.code)
                return NumberResult(bres.val), startpos + Int(bres.tlen)
            end
        end
        if Parsers.invalid(res.code)
            error = InvalidNumber
            @goto invalid
        end
        return NumberResult(res.val), Int(startpos + res.tlen)
    else
        if overflow
            return NumberResult(isneg ? -bval : bval), pos
        else
            return NumberResult(isneg ? -val : val), pos
        end
    end

@label invalid
    invalid(InvalidNumber, buf, startpos, "number")
end

# efficiently skip over a JSON value
# for object/array/string/number, we pass no-op functions
# and for bool/null, we just skip the appropriate number of bytes
function skip(x::LazyValues)
    T = gettype(x)
    if T == JSONTypes.OBJECT
        return applyobject((k, v) -> 0, x)
    elseif T == JSONTypes.ARRAY
        return applyarray((i, v) -> 0, x)
    elseif T == JSONTypes.STRING
        _, pos = parsestring(x)
        return pos
    elseif T == JSONTypes.NUMBER
        _, pos = parsenumber(x)
        return pos
    elseif T == JSONTypes.TRUE
        return getpos(x) + 4
    elseif T == JSONTypes.FALSE
        return getpos(x) + 5
    elseif T == JSONTypes.NULL
        return getpos(x) + 4
    else
        error("invalid JSON value type: $T")
    end
end

# helper definitions for LazyObject/LazyArray to they display as such
gettype(::LazyObject) = JSONTypes.OBJECT

Base.length(x::LazyObject) = StructUtils.applylength(x)

struct IterateObjectClosure
    kvs::Vector{Pair{String, LazyValue}}
end

function (f::IterateObjectClosure)(k, v)
    push!(f.kvs, convert(String, k) => v)
    return
end

function Base.iterate(x::LazyObject, st=nothing)
    if st === nothing
        # first iteration
        kvs = Pair{String, LazyValue}[]
        applyobject(IterateObjectClosure(kvs), x)
        i = 1
    else
        kvs = st[1]
        i = st[2]
    end
    i > length(kvs) && return nothing
    return kvs[i], (kvs, i + 1)
end

gettype(::LazyArray) = JSONTypes.ARRAY

Base.IndexStyle(::Type{<:LazyArray}) = Base.IndexLinear()

Base.size(x::LazyArray) = (StructUtils.applylength(x),)

Base.isassigned(x::LazyArray, i::Int) = true
Base.getindex(x::LazyArray, i::Int) = Selectors._getindex(x, i)

# show implementation for LazyValue
function Base.show(io::IO, x::LazyValue)
    T = gettype(x)
    if T == JSONTypes.OBJECT
        compact = get(io, :compact, false)::Bool
        lo = LazyObject(x)
        if compact
            show(io, lo)
        else
            io = IOContext(io, :compact => true)
            show(io, MIME"text/plain"(), lo)
        end
    elseif T == JSONTypes.ARRAY
        compact = get(io, :compact, false)::Bool
        la = LazyArray(x)
        if compact
            show(io, la)
        else
            io = IOContext(io, :compact => true)
            show(io, MIME"text/plain"(), la)
        end
    elseif T == JSONTypes.STRING
        buf = getbuf(x)
        GC.@preserve buf begin
            str, _ = parsestring(x)
            Base.print(io, "JSON.LazyValue(", repr(convert(String, str)), ")")
        end
    elseif T == JSONTypes.NULL
        Base.print(io, "JSON.LazyValue(nothing)")
    else # bool/number
        Base.print(io, "JSON.LazyValue(", parse(x), ")")
    end
end

# pre-1.11 compat
if VERSION < v"1.11"
    function _in!(x, s::Set)
        xT = convert(eltype(s), x)
        idx, sh = Base.ht_keyindex2_shorthash!(s.dict, xT)
        idx > 0 && return true
        Base._setindex!(s.dict, nothing, xT, -idx, sh)
        return false
    end
else
    const _in! = Base.in!
end

# hand-rolled scoped enum
module JSONTypes
    primitive type T 8 end
    T(x::UInt8) = reinterpret(T, x)
    const OBJECT = T(0x00)
    const ARRAY = T(0x01)
    const STRING = T(0x02)
    const INT = T(0x03)
    const FLOAT = T(0x04)
    const FALSE = T(0x05)
    const TRUE = T(0x06)
    const NULL = T(0x07)
    const NUMBER = T(0x08) # currently used by LazyValue
    const names = Dict(
        OBJECT => "OBJECT",
        ARRAY => "ARRAY",
        STRING => "STRING",
        INT => "INT",
        FALSE => "FALSE",
        TRUE => "TRUE",
        FLOAT => "FLOAT",
        NULL => "NULL",
        NUMBER => "NUMBER",
    )
    Base.show(io::IO, x::T) = Base.print(io, "JSONTypes.", names[x])
end

isjsonl(filename) = endswith(filename, ".jsonl") || endswith(filename, ".ndjson")

getlength(buf::AbstractVector{UInt8}) = length(buf)
getlength(buf::AbstractString) = sizeof(buf)

# unchecked
function getbyte(buf::AbstractVector{UInt8}, pos)
    @inbounds b = buf[pos]
    return b
end

# unchecked
function getbyte(buf::AbstractString, pos)
    @inbounds b = codeunit(buf, pos)
    return b
end

# helper macro to get the next byte from `buf` at index `pos`
# checks if `pos` is greater than `len` and @goto invalid if so
# if checkwh=true keep going until we get a non-whitespace byte
macro nextbyte(checkwh=true)
    esc(quote
        if pos > len
            error = UnexpectedEOF
            @goto invalid
        end
        b = getbyte(buf, pos)
        if $checkwh
            while b == UInt8('\t') || b == UInt8(' ') || b == UInt8('\n') || b == UInt8('\r')
                pos += 1
                if pos > len
                    error = UnexpectedEOF
                    @goto invalid
                end
                b = getbyte(buf, pos)
            end
        end
    end)
end

firstbyteeq(str::String, b::UInt8) = isempty(str) ? false : codeunit(str, 1) == b

# string escape/unescape utilities
const NEEDESCAPE = Set(map(UInt8, ('"', '\\', '\b', '\f', '\n', '\r', '\t')))

function escapechar(b)
    b == UInt8('"')  && return UInt8('"')
    b == UInt8('\\') && return UInt8('\\')
    b == UInt8('\b') && return UInt8('b')
    b == UInt8('\f') && return UInt8('f')
    b == UInt8('\n') && return UInt8('n')
    b == UInt8('\r') && return UInt8('r')
    b == UInt8('\t') && return UInt8('t')
    return 0x00
end

iscntrl(c::Char) = c <= '\x1f' || '\x7f' <= c <= '\u9f'
function escaped(b)
    if b == UInt8('/')
        return [UInt8('/')]
    elseif b >= 0x80
        return [b]
    elseif b in NEEDESCAPE
        return [UInt8('\\'), escapechar(b)]
    elseif iscntrl(Char(b))
        return UInt8[UInt8('\\'), UInt8('u'), Base.string(b, base=16, pad=4)...]
    else
        return [b]
    end
end

const ESCAPECHARS = [escaped(b) for b = 0x00:0xff]
const ESCAPELENS = [length(x) for x in ESCAPECHARS]

function escapelength(str)
    x = 0
    @simd for i = 1:ncodeunits(str)
        @inbounds len = ESCAPELENS[codeunit(str, i) + 1]
        x += len
    end
    return x
end

function reverseescapechar(b)
    b == UInt8('"')  && return UInt8('"')
    b == UInt8('\\') && return UInt8('\\')
    b == UInt8('/')  && return UInt8('/')
    b == UInt8('b')  && return UInt8('\b')
    b == UInt8('f')  && return UInt8('\f')
    b == UInt8('n')  && return UInt8('\n')
    b == UInt8('r')  && return UInt8('\r')
    b == UInt8('t')  && return UInt8('\t')
    return 0x00
end

utf16_is_surrogate(c::UInt16) = (c & 0xf800) == 0xd800
utf16_get_supplementary(lead::UInt16, trail::UInt16) = Char(UInt32(lead-0xd7f7)<<10 + trail)

@noinline invalid_escape(src, n) = throw(ArgumentError("encountered invalid escape character in json string: \"$(unsafe_string(src, n))\""))
@noinline unescaped_control(b) = throw(ArgumentError("encountered unescaped control character in json: '$(escape_string(Base.string(Char(b))))'"))

# unsafe because we're not checking that src or dst are valid pointers
# NOR are we checking that up to `n` bytes after dst are also valid to write to
function unsafe_unescape_to_buffer(src::Ptr{UInt8}, n::Int, dst::Ptr{UInt8})
    len = 1
    i = 1
    @inbounds begin
        while i <= n
            b = unsafe_load(src, i)
            if b == UInt8('\\')
                i += 1
                i > n && invalid_escape(src, n)
                b = unsafe_load(src, i)
                if b == UInt8('u')
                    # need at least 4 hex digits for '\uXXXX'
                    if i + 4 > n
                        invalid_escape(src, n)
                    end
                    # parse 4 hex digits into c without throwing
                    c = UInt16(0)
                    for offset in 1:4
                        bb = unsafe_load(src, i + offset)
                        nv = if UInt8('0') <= bb <= UInt8('9')
                                 bb - UInt8('0')
                             elseif UInt8('A') <= bb <= UInt8('F')
                                 bb - (UInt8('A') - 10)
                             elseif UInt8('a') <= bb <= UInt8('f')
                                 bb - (UInt8('a') - 10)
                             else
                                 invalid_escape(src, n)
                             end
                        c = (c << 4) + UInt16(nv)
                    end
                    # advance past the 4 hex digits
                    i += 4
                    b = unsafe_load(src, i)
                    if utf16_is_surrogate(c)
                        # check for a following "\uXXXX" to form a pair
                        if i + 6 > n || unsafe_load(src, i+1) != UInt8('\\') || unsafe_load(src, i+2) != UInt8('u')
                            # lone surrogate: emit raw code unit in WTF-8
                            b1 = UInt8(0xE0 | ((c >> 12) & 0x0F))
                            b2 = UInt8(0x80 | ((c >>  6) & 0x3F))
                            b3 = UInt8(0x80 | ( c         & 0x3F))
                            unsafe_store!(dst, b1, len); len += 1
                            unsafe_store!(dst, b2, len); len += 1
                            unsafe_store!(dst, b3, len); len += 1
                            continue
                        end
                        # parse next 4 hex digits into c2
                        c2 = UInt16(0)
                        for offset in 3:6
                            bb = unsafe_load(src, i + offset)
                            nv = if UInt8('0') <= bb <= UInt8('9')
                                     bb - UInt8('0')
                                 elseif UInt8('A') <= bb <= UInt8('F')
                                     bb - (UInt8('A') - 10)
                                 elseif UInt8('a') <= bb <= UInt8('f')
                                     bb - (UInt8('a') - 10)
                                 else
                                     invalid_escape(src, n)
                                 end
                            c2 = (c2 << 4) + UInt16(nv)
                        end
                        if utf16_is_surrogate(c2)
                            # valid surrogate pair: combine and emit as UTF-8
                            ch = utf16_get_supplementary(c, c2)
                            # consume the '\\uYYYY'
                            i += 6
                            st = codeunits(Base.string(ch))
                            for k = 1:length(st)-1
                                unsafe_store!(dst, st[k], len); len += 1
                            end
                            b = st[end]
                        else
                            # invalid trailing surrogate: treat lead as lone
                            b1 = UInt8(0xE0 | ((c >> 12) & 0x0F))
                            b2 = UInt8(0x80 | ((c >>  6) & 0x3F))
                            b3 = UInt8(0x80 | ( c         & 0x3F))
                            unsafe_store!(dst, b1, len); len += 1
                            unsafe_store!(dst, b2, len); len += 1
                            unsafe_store!(dst, b3, len); len += 1
                            continue
                        end
                    else
                        # non-surrogate: emit as usual
                        ch = Char(c)
                        st = codeunits(Base.string(ch))
                        for k = 1:length(st)-1
                            unsafe_store!(dst, st[k], len); len += 1
                        end
                        b = st[end]
                    end
                else
                    b = reverseescapechar(b)
                    b == 0x00 && invalid_escape(src, n)
                end
            end
            unsafe_store!(dst, b, len)
            len += 1
            i += 1
        end
    end
    return len-1
end

using JSON, Test, Logging

mutable struct CircularRef
    id::Int
    self::Union{Nothing, CircularRef}
end

struct CustomNumber <: Real
    x::Float64
end

@omit_null struct OmitNull
    id::Int
    name::Union{Nothing, String}
end

@omit_empty struct OmitEmpty
    id::Int
    value::Union{Nothing, String}
    values::Vector{Int}
end

@omit_null struct SentinelOverrides
    id::Int
    forced::Union{Nothing, JSON.Null}
    passthrough::Union{Nothing, String}
    dropped::Union{Nothing, JSON.Omit}
end

struct Issue447OrderedDict{K,V} <: AbstractDict{K,V}
    entries::Vector{Pair{K,V}}
end

Base.length(d::Issue447OrderedDict) = length(d.entries)
Base.iterate(d::Issue447OrderedDict, state=1) = state > length(d.entries) ? nothing : (d.entries[state], state + 1)
function Base.getindex(d::Issue447OrderedDict, key)
    for (k, v) in d
        isequal(k, key) && return v
    end
    throw(KeyError(key))
end

@enum JsonFruit Apple Orange

@testset "JSON.json" begin

@testset "Basics" begin
    @test JSON.json(nothing) == "null"
    @test JSON.json(true) == "true"
    @test JSON.json(false) == "false"
    # test the JSON output of a bunch of numbers
    @test JSON.json(0) == "0"
    @test JSON.json(1) == "1"
    @test JSON.json(1.0) == "1.0"
    @test JSON.json(1.0f0) == "1.0"
    @test JSON.json(1.0f1) == "10.0"
    @test JSON.json(1.0f-1) == "0.1"
    @test JSON.json(1.0f-2) == "0.01"
    @test JSON.json(1.0f-3) == "0.001"
    @test JSON.json(1.0f-4) == "0.0001"
    @test JSON.json(1.0f-5) == "1.0e-5"
    @test JSON.json(-1) == "-1"
    @test JSON.json(-1.0) == "-1.0"
    @test JSON.json(typemin(Int64)) == "-9223372036854775808"
    @test JSON.json(typemax(Int64)) == "9223372036854775807"
    @test JSON.json(BigInt(1)) == "1"
    @test JSON.json(BigInt(1) << 100) == "1267650600228229401496703205376"
    @test JSON.json(BigInt(-1)) == "-1"
    @test JSON.json(BigInt(-1) << 100) == "-1267650600228229401496703205376"
    @test JSON.json(typemin(UInt64)) == "0"
    @test JSON.json(typemax(UInt64)) == "18446744073709551615"
    @test_throws ArgumentError JSON.json(NaN)
    @test_throws ArgumentError JSON.json(Inf)
    @test_throws ArgumentError JSON.json(-Inf)
    @test JSON.json(NaN; allownan=true) == "NaN"
    @test JSON.json(Inf; allownan=true) == "Infinity"
    @test JSON.json(-Inf; allownan=true) == "-Infinity"
    # custom nan or inf strings
    @test JSON.json(NaN; allownan=true, nan="nan") == "nan"
    @test JSON.json(Inf; allownan=true, inf="inf") == "inf"
    @test JSON.json(-Inf; allownan=true, ninf="-inf") == "-inf"
    # test the JSON output of a bunch of strings
    @test JSON.json("") == "\"\""
    @test JSON.json("a") == "\"a\""
    @test JSON.json("a\"b") == "\"a\\\"b\""
    @test JSON.json("a\\b") == "\"a\\\\b\""
    @test JSON.json("a\b") == "\"a\\b\""
    @test JSON.json("a\f") == "\"a\\f\""
    # test the JSON output of a bunch of strings with unicode characters
    @test JSON.json("\u2200") == "\"∀\""
    @test JSON.json("\u2200\u2201") == "\"∀∁\""
    @test JSON.json("\u2200\u2201\u2202") == "\"∀∁∂\""
    @test JSON.json("\u2200\u2201\u2202\u2203") == "\"∀∁∂∃\""
    # test the JSON output of a bunch of arrays
    @test JSON.json(Int[]) == "[]"
    @test JSON.json(Int[1]) == "[1]"
    @test JSON.json(Int[1, 2]) == "[1,2]"
    @test JSON.json((1, 2)) == "[1,2]"
    @test JSON.json(Set([2])) == "[2]"
    @test JSON.json([1, nothing, "hey", 3.14, true, false]) == "[1,null,\"hey\",3.14,true,false]"
    # test the JSON output of a bunch of dicts/namedtuples
    @test JSON.json(Dict{Int, Int}()) == "{}"
    @test JSON.json(Dict{Int, Int}(1 => 2)) == "{\"1\":2}"
    @test JSON.json((a = 1, b = 2)) == "{\"a\":1,\"b\":2}"
    @test JSON.json((a = nothing, b=2, c="hey", d=3.14, e=true, f=false)) == "{\"a\":null,\"b\":2,\"c\":\"hey\",\"d\":3.14,\"e\":true,\"f\":false}"
    # test Vector{Pair} serializes as object, not array
    @test JSON.json(Pair{String, Int}[]) == "{}"
    @test JSON.json([:a => 1, :b => 2]) == "{\"a\":1,\"b\":2}"
    @test JSON.json(["x" => "value", "y" => 42]) == "{\"x\":\"value\",\"y\":42}"
    @test JSON.json([1 => "one", 2 => "two"]) == "{\"1\":\"one\",\"2\":\"two\"}"
    # test Vector{Pair} in nested structures
    @test JSON.json(Dict("data" => [:x => 1, :y => 2])) == "{\"data\":{\"x\":1,\"y\":2}}"
    # test the JSON output of nested array/objects
    @test JSON.json([1, [2, 3], [4, [5, 6]]]) == "[1,[2,3],[4,[5,6]]]"
    @test JSON.json(Dict{Int, Any}(1 => Dict{Int, Any}(2 => Dict{Int, Any}(3 => 4)))) == "{\"1\":{\"2\":{\"3\":4}}}"
    # now a mix of arrays and objects
    @test JSON.json([1, Dict{Int, Any}(2 => Dict{Int, Any}(3 => 4))]) == "[1,{\"2\":{\"3\":4}}]"
    @test JSON.json(Dict{Int, Any}(1 => [2, Dict{Int, Any}(3 => 4)])) == "{\"1\":[2,{\"3\":4}]}"
    # test undefined elements of an array
    arr = Vector{String}(undef, 3)
    arr[1] = "a"
    arr[3] = "b"
    @test JSON.json(arr) == "[\"a\",null,\"b\"]"
    # test custom struct writing
    # defined in the test/struct.jl file
    a = A(1, 2, 3, 4)
    @test JSON.json(a) == "{\"a\":1,\"b\":2,\"c\":3,\"d\":4}"
    x = LotsOfFields("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35")
    @test JSON.json(x) == "{\"x1\":\"1\",\"x2\":\"2\",\"x3\":\"3\",\"x4\":\"4\",\"x5\":\"5\",\"x6\":\"6\",\"x7\":\"7\",\"x8\":\"8\",\"x9\":\"9\",\"x10\":\"10\",\"x11\":\"11\",\"x12\":\"12\",\"x13\":\"13\",\"x14\":\"14\",\"x15\":\"15\",\"x16\":\"16\",\"x17\":\"17\",\"x18\":\"18\",\"x19\":\"19\",\"x20\":\"20\",\"x21\":\"21\",\"x22\":\"22\",\"x23\":\"23\",\"x24\":\"24\",\"x25\":\"25\",\"x26\":\"26\",\"x27\":\"27\",\"x28\":\"28\",\"x29\":\"29\",\"x30\":\"30\",\"x31\":\"31\",\"x32\":\"32\",\"x33\":\"33\",\"x34\":\"34\",\"x35\":\"35\"}"
    # test custom struct writing with custom field names
    x = L(1, "george", 33.3)
    @test JSON.json(x) == "{\"id\":1,\"firstName\":\"george\",\"rate\":33.3}"
    # test custom struct writing with undef fields
    x = UndefGuy()
    x.id = 10
    @test JSON.json(x) == "{\"id\":10,\"name\":null}"
    # test structs with circular references
    x = CircularRef(11, nothing)
    x.self = x
    @test JSON.json(x) == "{\"id\":11,\"self\":null}"
    # test lowering
    x = K(123, missing)
    @test JSON.json(x) == "{\"id\":123,\"value\":null}"
    x = UUID(typemax(UInt128))
    @test JSON.json(x) == "\"ffffffff-ffff-ffff-ffff-ffffffffffff\""
    @test JSON.json(:a) == "\"a\""
    @test JSON.json(apple) == "\"apple\""
    @test JSON.json('a') == "\"a\""
    @test JSON.json('∀') == "\"∀\""
    @test JSON.json(v"1.2.3") == "\"1.2.3\""
    @test JSON.json(r"1.2.3") == "\"1.2.3\""
    @test JSON.json(Date(2023, 2, 23)) == "\"2023-02-23\""
    @test JSON.json(DateTime(2023, 2, 23, 12, 34, 56)) == "\"2023-02-23T12:34:56\""
    @test JSON.json(Time(12, 34, 56)) == "\"12:34:56\""
    # test field-specific lowering
    x = ThreeDates(Date(2023, 2, 23), DateTime(2023, 2, 23, 12, 34, 56), Time(12, 34, 56))
    @test JSON.json(x) == "{\"date\":\"2023_02_23\",\"datetime\":\"2023/02/23 12:34:56\",\"time\":\"12/34/56\"}"
    # test matrix writing
    @test JSON.json([1 2; 3 4]) == "[[1,3],[2,4]]"
    @test JSON.json((a=[1 2; 3 4],)) == "{\"a\":[[1,3],[2,4]]}"
    # singleton writing
    @test JSON.json(C()) == "\"C()\""
    # module writing
    @test JSON.json(JSON) == "\"JSON\""
    # function writing
    @test JSON.json(JSON.json) == "\"json\""
    # SimpleVector writing
    @test JSON.json(Core.svec(1, 2, 3)) == "[1,2,3]"
    # DataType writing
    @test JSON.json(Float64) == "\"Float64\""
    @test JSON.json(Union{Missing, Float64}) == "\"Union{Missing, Float64}\""
    # LogLevel writing
    @test JSON.json(Logging.Info) == "\"Info\""
    @test JSON.json(Logging.LogLevel(1)) == "\"LogLevel(1)\""
    # multidimensional arrays
    # "[[1.0],[2.0]]" => (1, 2)
    m = Matrix{Float64}(undef, 1, 2)
    m[1] = 1
    m[2] = 2
    @test JSON.json(m) == "[[1.0],[2.0]]"
    # "[[1.0,2.0]]" => (2, 1)
    m = Matrix{Float64}(undef, 2, 1)
    m[1] = 1
    m[2] = 2
    @test JSON.json(m) == "[[1.0,2.0]]"
    # "[[[1.0]],[[2.0]]]" => (1, 1, 2)
    m = Array{Float64}(undef, 1, 1, 2)
    m[1] = 1
    m[2] = 2
    @test JSON.json(m) == "[[[1.0]],[[2.0]]]"
    # "[[[1.0],[2.0]]]" => (1, 2, 1)
    m = Array{Float64}(undef, 1, 2, 1)
    m[1] = 1
    m[2] = 2
    @test JSON.json(m) == "[[[1.0],[2.0]]]"
    # "[[[1.0,2.0]]]" => (2, 1, 1)
    m = Array{Float64}(undef, 2, 1, 1)
    m[1] = 1
    m[2] = 2
    @test JSON.json(m) == "[[[1.0,2.0]]]"

    m = Array{Float64}(undef, 1, 2, 3)
    m[1] = 1
    m[2] = 2
    m[3] = 3
    m[4] = 4
    m[5] = 5
    m[6] = 6
    @test JSON.json(m) == "[[[1.0],[2.0]],[[3.0],[4.0]],[[5.0],[6.0]]]"
    # 0-dimensional array
    m = Array{Float64,0}(undef)
    m[1] = 1.0
    @test JSON.json(m) == "1.0"
    # JSON.json forms
    io = IOBuffer()
    JSON.json(io, missing)
    @test String(take!(io)) == "null"
    fname, io = mktemp()
    close(io)
    JSON.json(fname, missing)
    @test read(fname, String) == "null"
    rm(fname)
    @testset "pretty output" begin
        @test JSON.json([1, 2, 3], pretty=4) == "[\n    1,\n    2,\n    3\n]"
        @test JSON.json([1, 2, 3], pretty=true) == "[\n  1,\n  2,\n  3\n]"
        @test JSON.json([1, 2, 3], pretty=0) == "[1,2,3]"
        # empty object/array
        @test JSON.json([], pretty=true) == "[]"
        @test JSON.json(Dict(), pretty=true) == "{}"
        # several levels of nesting
        @test JSON.json([1, [2, 3], [4, [5, 6]]], pretty=true) == "[\n  1,\n  [\n    2,\n    3\n  ],\n  [\n    4,\n    [\n      5,\n      6\n    ]\n  ]\n]"
        # several levels of nesting with a mix of nulls, numbers, strings, booleans, empty objects, arrays, etc.
        @test JSON.json([1, [2, 3], [4, [5, 6]], nothing, "hey", 3.14, true, false, Dict(), []], pretty=true) == "[\n  1,\n  [\n    2,\n    3\n  ],\n  [\n    4,\n    [\n      5,\n      6\n    ]\n  ],\n  null,\n  \"hey\",\n  3.14,\n  true,\n  false,\n  {},\n  []\n]"
        # JSON.jl pre-1.0 compat
        io = IOBuffer()
        JSON.print(io, [1, 2, 3], 2)
        @test String(take!(io)) == "[\n  1,\n  2,\n  3\n]"
        @test JSON.json([1, 2, 3], 2) == "[\n  1,\n  2,\n  3\n]"
        # inline_limit tests
        @test JSON.json([1, 2]; pretty=2, inline_limit=3) == "[1,2]"
        @test JSON.json([1, 2, 3]; pretty=2, inline_limit=3) == "[\n  1,\n  2,\n  3\n]"
    end
    # non-Integer/AbstractFloat but <: Real output
    @test_throws MethodError JSON.json(CustomNumber(3.14))
    JSON.tostring(x::CustomNumber) = string(x.x)
    @test JSON.json(CustomNumber(3.14)) == "3.14"
    # https://github.com/JuliaIO/JSON.jl/issues/440
    @test JSON.json(1 + 2im) == "{\"re\":1,\"im\":2}"
    @test JSON.parse(JSON.json(1.0 + 2.0im), ComplexF64) == 1.0 + 2.0im
    # jsonlines output
    @test JSON.json([1, 2, 3]; jsonlines=true) == "1\n2\n3\n"
    # jsonlines output with pretty not allowed
    @test_throws ArgumentError JSON.json([1, 2, 3]; jsonlines=true, pretty=true)
    # jsonlines each line is an object
    @test JSON.json([(a=1, b=2), (a=3, b=4)]; jsonlines=true) == "{\"a\":1,\"b\":2}\n{\"a\":3,\"b\":4}\n"
    # jsonlines with empty array
    @test JSON.json([]; jsonlines=true) == "\n"
    # jsonlines not allowed on objects
    @test_throws ArgumentError JSON.json((a=1, b=2); jsonlines=true)
    # circular reference tracking
    a = Any[1, 2, 3]
    push!(a, a)
    @test JSON.json(a) == "[1,2,3,null]"
    a = (a=1,)
    x = [a, a, a]
    @test JSON.json(x) == "[{\"a\":1},{\"a\":1},{\"a\":1}]"
    a = CircularRef(1, nothing)
    a.self = a
    x = [a, a, a]
    @test JSON.json(x) == "[{\"id\":1,\"self\":null},{\"id\":1,\"self\":null},{\"id\":1,\"self\":null}]"
    # custom key function
    @test_throws ArgumentError JSON.json(Dict(Point(1, 2) => "hi"))
    StructUtils.lowerkey(::JSON.JSONStyle, p::Point) = "$(p.x)_$(p.y)"
    @test JSON.json(Dict(Point(1, 2) => "hi")) == "{\"1_2\":\"hi\"}"
    x = JSONText("[1,2,3]")
    @test JSON.json(x) == "[1,2,3]"
    @test JSON.json((a=1, b=nothing)) == "{\"a\":1,\"b\":null}"
    @test JSON.json((a=1, b=nothing); omit_null=true) == "{\"a\":1}"
    @test JSON.json((a=1, b=nothing); omit_null=false) == "{\"a\":1,\"b\":null}"
    @test JSON.json((a=1, b=[]); omit_empty=true) == "{\"a\":1}"
    @test JSON.json((a=1, b=[]); omit_empty=false) == "{\"a\":1,\"b\":[]}"
    @testset "All string-like types as keys" begin
        date = Dates.DateTime(1970)
        @test JSON.json([
            UUID(0) => "uuid",
            'c' => "char",
            v"0.0.1" => "ver",
            Apple => "Enum 1",
            Orange => "Enum 2",
            date => "date"
        ]) == """{"00000000-0000-0000-0000-000000000000":"uuid","c":"char","0.0.1":"ver","Apple":"Enum 1","Orange":"Enum 2","1970-01-01T00:00:00":"date"}"""
    end

    @testset "Sentinel overrides" begin
        @test JSON.json(JSON.Null()) == "null"
        @test_throws ArgumentError JSON.json(JSON.Omit())
        @test JSON.json((a=1, b=JSON.Null()); omit_null=true) == "{\"a\":1,\"b\":null}"
        @test JSON.json((a=JSON.Omit(), b=JSON.Null())) == "{\"b\":null}"
        @test JSON.json((a=JSON.Omit(), b=2); omit_null=false) == "{\"b\":2}"
        @test JSON.json([JSON.Omit(), 1, JSON.Omit(), 2]) == "[1,2]"
        @test JSON.json([JSON.Omit(), JSON.Omit()]) == "[]"
        x = SentinelOverrides(1, JSON.Null(), nothing, JSON.Omit())
        @test JSON.json(x) == "{\"id\":1,\"forced\":null}"
        @test JSON.json(x; omit_null=false) == "{\"id\":1,\"forced\":null,\"passthrough\":null}"
    end
    # custom style overload
    JSON.lower(::CustomJSONStyle, x::Rational) = (num=x.num, den=x.den)
    @test JSON.json(1//3; style=CustomJSONStyle()) == "{\"num\":1,\"den\":3}"
    # @omit_null and @omit_empty
    @test JSON.json(OmitNull(1, nothing)) == "{\"id\":1}"
    @test JSON.json(OmitNull(1, nothing); omit_null=false) == "{\"id\":1,\"name\":null}"
    @test JSON.json(OmitEmpty(1, nothing, [])) == "{\"id\":1}"
    @test JSON.json(OmitEmpty(1, "abc", []); omit_empty=false) == "{\"id\":1,\"value\":\"abc\",\"values\":[]}"
    # float_style and float_precision
    @test JSON.json(Float64(π); float_style=:fixed, float_precision=2) == "3.14"
    @test JSON.json(Float64(π); float_style=:exp, float_precision=2) == "3.14e+00"
    @test_throws ArgumentError JSON.json(Float64(π); float_style=:fixed, float_precision=0)
    @test_throws ArgumentError JSON.json(Float64(π); float_style=:fixed, float_precision=-1)
    @test_throws ArgumentError JSON.json(Float64(π); float_style=:exp, float_precision=0)
    io = IOBuffer()
    @test_throws ArgumentError JSON.json(io, Float64(π); float_style=:fixed, float_precision=0)
    @test_throws ArgumentError JSON.json(Float64(π); float_style=:not_a_style)
end

@testset "Enhanced @omit_null and @omit_empty macros" begin
    # Test structs for new macro functionality

    # Test case 1: Apply @omit_null to existing struct
    struct ExistingStruct1
        id::Int
        name::Union{Nothing, String}
        value::Union{Nothing, Int}
    end
    @omit_null ExistingStruct1

    # Test case 2: Apply @omit_empty to existing struct
    struct ExistingStruct2
        id::Int
        items::Vector{String}
        data::Dict{String, Int}
    end
    @omit_empty ExistingStruct2

    # Test case 3: Chaining with StructUtils.@defaults macro
    @omit_null @defaults struct ChainedStruct1
        id::Int = 1
        name::Union{Nothing, String} = nothing
    end

    @omit_empty @defaults struct ChainedStruct2
        id::Int = 1
        items::Vector{String} = String[]
    end

    # Test case 4: Complex type expressions
    struct ParametricStruct{T}
        id::Int
        value::Union{Nothing, T}
    end
    @omit_null ParametricStruct{String}  # Apply to specific parametric type

    struct SimpleStruct
        id::Int
        name::Union{Nothing, String}
    end
    @omit_null SimpleStruct

    # Tests for case 1: Apply to existing struct
    @test JSON.json(ExistingStruct1(1, nothing, nothing)) == "{\"id\":1}"
    @test JSON.json(ExistingStruct1(1, "test", 42)) == "{\"id\":1,\"name\":\"test\",\"value\":42}"
    @test JSON.json(ExistingStruct1(1, nothing, nothing); omit_null=false) == "{\"id\":1,\"name\":null,\"value\":null}"

    @test JSON.json(ExistingStruct2(1, String[], Dict{String, Int}())) == "{\"id\":1}"
    @test JSON.json(ExistingStruct2(1, ["test"], Dict("key" => 1))) == "{\"id\":1,\"items\":[\"test\"],\"data\":{\"key\":1}}"
    @test JSON.json(ExistingStruct2(1, String[], Dict{String, Int}()); omit_empty=false) == "{\"id\":1,\"items\":[],\"data\":{}}"

    # Tests for case 3: Chained macros with @defaults
    @test JSON.json(ChainedStruct1()) == "{\"id\":1}"  # Uses default constructor from @defaults
    @test JSON.json(ChainedStruct1(2, "test")) == "{\"id\":2,\"name\":\"test\"}"

    @test JSON.json(ChainedStruct2()) == "{\"id\":1}"  # Uses default constructor from @defaults  
    @test JSON.json(ChainedStruct2(2, ["test"])) == "{\"id\":2,\"items\":[\"test\"]}"

    # Tests for case 4: Complex types
    @test JSON.json(ParametricStruct{String}(1, nothing)) == "{\"id\":1}"
    @test JSON.json(ParametricStruct{String}(1, "test")) == "{\"id\":1,\"value\":\"test\"}"

    @test JSON.json(SimpleStruct(1, nothing)) == "{\"id\":1}"
    @test JSON.json(SimpleStruct(1, "test")) == "{\"id\":1,\"name\":\"test\"}"

    # Test error cases
    @test_throws LoadError eval(:(@omit_null 123))
    @test_throws LoadError eval(:(@omit_empty "not_a_type"))
end

@testset "@omit_null/@omit_empty parametric types" begin
    # Test that @omit_null on parametric struct definition works for all instantiations
    @omit_null struct OmitNullParametric{T}
        id::Int
        value::Union{Nothing, T}
    end

    # Should work for any type parameter, not just a specific one
    @test JSON.json(OmitNullParametric{String}(1, nothing)) == "{\"id\":1}"
    @test JSON.json(OmitNullParametric{String}(1, "test")) == "{\"id\":1,\"value\":\"test\"}"
    @test JSON.json(OmitNullParametric{Int}(1, nothing)) == "{\"id\":1}"
    @test JSON.json(OmitNullParametric{Int}(1, 42)) == "{\"id\":1,\"value\":42}"
    @test JSON.json(OmitNullParametric{Float64}(1, nothing)) == "{\"id\":1}"
    @test JSON.json(OmitNullParametric{Float64}(1, 3.14)) == "{\"id\":1,\"value\":3.14}"

    # Verify omit_null can be overridden at callsite
    @test JSON.json(OmitNullParametric{String}(1, nothing); omit_null=false) == "{\"id\":1,\"value\":null}"

    # Test that @omit_empty on parametric struct definition works for all instantiations
    @omit_empty struct OmitEmptyParametric{T}
        id::Int
        items::Vector{T}
    end

    @test JSON.json(OmitEmptyParametric{String}(1, String[])) == "{\"id\":1}"
    @test JSON.json(OmitEmptyParametric{String}(1, ["a", "b"])) == "{\"id\":1,\"items\":[\"a\",\"b\"]}"
    @test JSON.json(OmitEmptyParametric{Int}(1, Int[])) == "{\"id\":1}"
    @test JSON.json(OmitEmptyParametric{Int}(1, [1, 2, 3])) == "{\"id\":1,\"items\":[1,2,3]}"

    # Verify omit_empty can be overridden at callsite
    @test JSON.json(OmitEmptyParametric{String}(1, String[]); omit_empty=false) == "{\"id\":1,\"items\":[]}"

    # Test chaining @omit_null with @defaults on parametric type
    @omit_null @defaults struct ChainedParametric{T}
        id::Int = 0
        value::Union{Nothing, T} = nothing
    end

    @test JSON.json(ChainedParametric{String}()) == "{\"id\":0}"
    @test JSON.json(ChainedParametric{Int}()) == "{\"id\":0}"
    @test JSON.json(ChainedParametric{String}(1, "test")) == "{\"id\":1,\"value\":\"test\"}"
end

@testset "Buffered IO" begin
    # Helper function to create large test data
    function create_large_object(size::Int)
        return Dict{String, Any}(
            "large_array" => collect(1:size),
            "nested_data" => Dict{String, Any}(
                "strings" => ["test_string_$i" for i in 1:div(size, 10)],
                "numbers" => [i * 3.14159 for i in 1:div(size, 10)],
                "booleans" => [i % 2 == 0 for i in 1:div(size, 10)]
            ),
            "metadata" => Dict{String, Any}(
                "size" => size,
                "type" => "test_data",
                "description" => "Large test object for buffered IO testing" * "x"^100
            )
        )
    end

    @testset "Basic buffered IO functionality" begin
        # Test with small buffer size (512 bytes)
        test_data = create_large_object(100)
        
        # Test writing to IOBuffer with small buffer
        io1 = IOBuffer()
        JSON.json(io1, test_data; bufsize=512)
        result1 = String(take!(io1))
        
        # Test writing to IOBuffer with default buffer size
        io2 = IOBuffer()
        JSON.json(io2, test_data)
        result2 = String(take!(io2))
        
        # Results should be identical regardless of buffer size
        @test result1 == result2
        
        # Test writing to IOBuffer with very large buffer
        io3 = IOBuffer()
        JSON.json(io3, test_data; bufsize=1024*1024)  # 1MB buffer
        result3 = String(take!(io3))
        
        @test result1 == result3
        
        # Verify the JSON can be parsed back correctly
        parsed = JSON.parse(result1)
        @test parsed["large_array"] == collect(1:100)
        @test parsed["metadata"]["size"] == 100
    end

    @testset "Buffer size boundary conditions" begin
        # Create data that will test buffer boundaries
        test_data = create_large_object(500)
        expected_result = JSON.json(test_data)
        
        # Test with various buffer sizes around typical JSON size
        buffer_sizes = [64, 128, 256, 512, 1024, 2048, 4096, 8192]
        
        for bufsize in buffer_sizes
            io = IOBuffer()
            JSON.json(io, test_data; bufsize=bufsize)
            result = String(take!(io))
            @test result == expected_result
        end
    end

    @testset "Multiple flush scenarios" begin
        # Create data large enough to trigger multiple flushes
        large_data = create_large_object(2000)
        
        # Test with very small buffer to force multiple flushes
        io = IOBuffer()
        JSON.json(io, large_data; bufsize=256)
        result_small_buf = String(take!(io))
        
        # Compare with large buffer (no flushes)
        io2 = IOBuffer()
        JSON.json(io2, large_data; bufsize=1024*1024)
        result_large_buf = String(take!(io2))
        
        @test result_small_buf == result_large_buf
        
        # Verify correctness by parsing
        parsed = JSON.parse(result_small_buf)
        @test length(parsed["large_array"]) == 2000
        @test parsed["metadata"]["size"] == 2000
    end

    @testset "Array and object combinations with buffering" begin
        # Test mix of arrays and objects that might cross buffer boundaries
        mixed_data = [
            Dict("id" => i, "data" => collect((i-1)*10+1:i*10), "metadata" => "item_$i" * "x"^50)
            for i in 1:100
        ]
        
        buffer_sizes = [128, 512, 2048]
        expected = JSON.json(mixed_data)
        
        for bufsize in buffer_sizes
            io = IOBuffer()
            JSON.json(io, mixed_data; bufsize=bufsize)
            result = String(take!(io))
            @test result == expected
        end
    end

    @testset "String escaping with buffering" begin
        # Test strings that require escaping across buffer boundaries
        strings_with_escaping = [
            "String with \"quotes\" and \\backslashes\\",
            "String with\nnewlines\tand\ttabs",
            "Unicode string: 🌟🚀💻🔥⭐",
            "Mixed content: \"Hello\\nWorld\"\t🌍",
            "Very long string: " * "A"^1000 * " with \" quotes \" and \\ backslashes \\"
        ]
        
        test_data = Dict("strings" => strings_with_escaping)
        expected = JSON.json(test_data)
        
        # Test with small buffer that will split escaped sequences
        io = IOBuffer()
        JSON.json(io, test_data; bufsize=64)
        result = String(take!(io))
        @test result == expected
        
        # Verify by parsing back
        parsed = JSON.parse(result)
        @test parsed["strings"] == strings_with_escaping
    end

    @testset "Pretty printing with buffering" begin
        test_data = create_large_object(50)
        
        # Test pretty printing with different buffer sizes
        buffer_sizes = [256, 1024, 4096]
        
        for bufsize in buffer_sizes
            # Pretty printing with 2 spaces
            io1 = IOBuffer()
            JSON.json(io1, test_data; pretty=2, bufsize=bufsize)
            result1 = String(take!(io1))
            
            # Compare with reference (large buffer)
            io2 = IOBuffer()
            JSON.json(io2, test_data; pretty=2, bufsize=1024*1024)
            result2 = String(take!(io2))
            
            @test result1 == result2
            
            # Ensure it's actually pretty printed
            @test contains(result1, "\n")
            @test contains(result1, "  ")  # indentation
        end
    end

    @testset "Edge cases and error conditions" begin
        # Test with minimal buffer size
        simple_data = Dict("key" => "value")
        
        # Very small buffer (smaller than a single JSON element)
        io = IOBuffer()
        JSON.json(io, simple_data; bufsize=8)
        result = String(take!(io))
        @test result == "{\"key\":\"value\"}"
        
        # Test with empty data
        io = IOBuffer()
        JSON.json(io, Dict{String,Any}(); bufsize=32)
        result = String(take!(io))
        @test result == "{}"
        
        # Test with array
        io = IOBuffer()
        JSON.json(io, Int[]; bufsize=32)
        result = String(take!(io))
        @test result == "[]"
    end

    @testset "File writing with buffering" begin
        # Test writing to actual file with different buffer sizes
        test_data = create_large_object(300)
        expected = JSON.json(test_data)
        
        temp_files = String[]
        
        try
            for (i, bufsize) in enumerate([512, 2048, 8192])
                filename = tempname() * ".json"
                push!(temp_files, filename)
                
                # Write with specific buffer size
                open(filename, "w") do io
                    JSON.json(io, test_data; bufsize=bufsize)
                end
                
                # Read back and verify
                content = read(filename, String)
                @test content == expected
                
                # Parse to verify correctness
                parsed = JSON.parse(content)
                @test parsed["large_array"][1] == 1
                @test parsed["large_array"][end] == 300
            end
        finally
            # Clean up temp files
            for filename in temp_files
                isfile(filename) && rm(filename)
            end
        end
    end

    @testset "JSONLines with buffering" begin
        # Test JSONLines format with buffering
        data = [
            Dict("id" => i, "value" => "item_$i", "data" => collect(1:i))
            for i in 1:20
        ]
        
        buffer_sizes = [128, 512, 2048]
        expected = JSON.json(data; jsonlines=true)
        
        for bufsize in buffer_sizes
            io = IOBuffer()
            JSON.json(io, data; jsonlines=true, bufsize=bufsize)
            result = String(take!(io))
            @test result == expected
            
            # Verify each line is valid JSON
            lines = split(strip(result), '\n')
            @test length(lines) == 20
            for (i, line) in enumerate(lines)
                parsed_line = JSON.parse(line)
                @test parsed_line["id"] == i
            end
        end
    end

    @testset "Circular references with buffering" begin
        # Test circular reference handling with small buffers
        a = Any[1, 2, 3]
        push!(a, a)  # circular reference
        
        buffer_sizes = [64, 256, 1024]
        expected = "[1,2,3,null]"  # circular ref becomes null
        
        for bufsize in buffer_sizes
            io = IOBuffer()
            JSON.json(io, a; bufsize=bufsize)
            result = String(take!(io))
            @test result == expected
        end
    end

    @testset "Test pre-1.0 compat for object Tuple keys" begin
        @test JSON.json(Dict(("a", "b") => 1)) == "{\"(\\\"a\\\", \\\"b\\\")\":1}"
    end
end

@testset "sort_keys" begin
    # default (nothing): Dict keys are sorted, Object and other AbstractDicts preserve iteration order
    @test JSON.json(Dict("c" => 3, "a" => 1, "b" => 2)) == "{\"a\":1,\"b\":2,\"c\":3}"
    obj = JSON.Object("c" => 3, "a" => 1, "b" => 2)
    @test JSON.json(obj) == "{\"c\":3,\"a\":1,\"b\":2}"
    ordered = Issue447OrderedDict([:b => 2, :a => 1])
    @test JSON.json(ordered) == "{\"b\":2,\"a\":1}"

    # sort_keys=true: all AbstractDicts sorted, including Object
    @test JSON.json(Dict("c" => 3, "a" => 1, "b" => 2); sort_keys=true) == "{\"a\":1,\"b\":2,\"c\":3}"
    @test JSON.json(obj; sort_keys=true) == "{\"a\":1,\"b\":2,\"c\":3}"
    @test JSON.json(ordered; sort_keys=true) == "{\"a\":1,\"b\":2}"

    # sort_keys=false: no sorting for any AbstractDict
    @test JSON.json(obj; sort_keys=false) == "{\"c\":3,\"a\":1,\"b\":2}"
    @test JSON.json(ordered; sort_keys=false) == "{\"b\":2,\"a\":1}"

    # empty dict
    @test JSON.json(Dict{String,Any}()) == "{}"
    @test JSON.json(Dict{String,Any}(); sort_keys=true) == "{}"

    # single key
    @test JSON.json(Dict("only" => 42)) == "{\"only\":42}"

    # nested dicts are sorted recursively by default
    @test JSON.json(Dict("z" => Dict("b" => 2, "a" => 1), "a" => 3)) == "{\"a\":3,\"z\":{\"a\":1,\"b\":2}}"

    # arrays are not affected, but dicts inside arrays are sorted
    @test JSON.json([Dict("b" => 2, "a" => 1), Dict("d" => 4, "c" => 3)]) == "[{\"a\":1,\"b\":2},{\"c\":3,\"d\":4}]"

    # Symbol keys (lowered to strings via lowerkey, sorted as strings)
    @test JSON.json(Dict(:zebra => 1, :apple => 2)) == "{\"apple\":2,\"zebra\":1}"

    # Integer keys (lowered to strings, sorted lexicographically as strings)
    @test JSON.json(Dict(3 => "c", 1 => "a", 2 => "b")) == "{\"1\":\"a\",\"2\":\"b\",\"3\":\"c\"}"

    # nested Object inside Dict: Dict sorted, Object preserves order (default)
    @test JSON.json(Dict("z" => JSON.Object("b" => 2, "a" => 1), "a" => 3)) == "{\"a\":3,\"z\":{\"b\":2,\"a\":1}}"
    # with sort_keys=true, both are sorted
    @test JSON.json(Dict("z" => JSON.Object("b" => 2, "a" => 1), "a" => 3); sort_keys=true) == "{\"a\":3,\"z\":{\"a\":1,\"b\":2}}"

    # sort_keys + pretty printing
    @test JSON.json(Dict("c" => 3, "a" => 1, "b" => 2); pretty=true) == "{\n  \"a\": 1,\n  \"b\": 2,\n  \"c\": 3\n}"

    # sort_keys + omit_null
    @test JSON.json(Dict("c" => nothing, "a" => 1, "b" => 2); omit_null=true) == "{\"a\":1,\"b\":2}"

    # sort_keys does not affect structs (struct field order is deterministic)
    @test JSON.json(A(1, 2, 3, 4); sort_keys=true) == "{\"a\":1,\"b\":2,\"c\":3,\"d\":4}"

    # sort_keys does not affect arrays
    @test JSON.json([3, 1, 2]; sort_keys=true) == "[3,1,2]"

    # sort_keys does not affect NamedTuples (field order is deterministic)
    @test JSON.json((z=1, a=2); sort_keys=true) == "{\"z\":1,\"a\":2}"

    # deeply nested mixed structures
    deep = Dict("z" => [Dict("b" => Dict("d" => 4, "c" => 3), "a" => 1)], "m" => 2)
    @test JSON.json(deep) == "{\"m\":2,\"z\":[{\"a\":1,\"b\":{\"c\":3,\"d\":4}}]}"

    # IO path
    io = IOBuffer()
    JSON.json(io, Dict("c" => 3, "a" => 1, "b" => 2))
    @test String(take!(io)) == "{\"a\":1,\"b\":2,\"c\":3}"

    # file path
    fname = tempname()
    JSON.json(fname, Dict("c" => 3, "a" => 1))
    @test read(fname, String) == "{\"a\":1,\"c\":3}"
    rm(fname)

    # sort_keys + jsonlines (dicts inside array should be sorted)
    @test JSON.json([Dict("b" => 2, "a" => 1), Dict("d" => 4, "c" => 3)]; jsonlines=true) == "{\"a\":1,\"b\":2}\n{\"c\":3,\"d\":4}\n"

    # sort_keys + buffered IO (small buffer forces flushes)
    io = IOBuffer()
    large = Dict(string(Char('a' + i)) => i for i in 0:25)
    JSON.json(io, large; bufsize=64)
    result = String(take!(io))
    parsed_keys = [m.match for m in eachmatch(r"\"([a-z])\"", result)]
    @test parsed_keys == sort(parsed_keys)
end

end # @testset "JSON.json"

using Dates, JSON

const ARRAY_JSON = "[1,2,3]"
const STRING_JSON = "\"Ada\""
const TRIM_FIXTURE_DIR = joinpath(@__DIR__, "trim")

JSON.@nonstruct struct TrimCode
    value::String
end

JSON.lower(x::TrimCode) = x.value

struct TrimLeaf
    id::Int
    name::String
end

struct TrimRoot
    item::Union{Nothing,TrimLeaf}
    items::Vector{TrimLeaf}
    tags::Vector{String}
    note::Union{Nothing,String}
end

JSON.StructUtils.@defaults struct TrimTagged
    value::Int = 0 & (json=(name="wire",),)
    secret::Int = 9 & (json=(ignore=true,),)
end

JSON.StructUtils.@noarg mutable struct TrimMutable
    value::Int = 0
end

struct TrimTemporal
    day::Dates.Date
    stamp::Dates.DateTime
    tick::Dates.Time
end

function checked(cond::Bool, msg::String)::Nothing
    cond || error(msg)
    return nothing
end

function exercise_lazy_entrypoints()::Nothing
    checked(JSON.lazy(ARRAY_JSON) isa JSON.LazyValue, "lazy failed")
    checked(JSON.lazyfile(joinpath(TRIM_FIXTURE_DIR, "value.json")) isa JSON.LazyValue, "lazyfile failed")
    return nothing
end

function exercise_parse_entrypoints()::Nothing
    # Open-ended untyped results are data-dependent. Narrow their runtime shape
    # before use in a safe-trim binary; `lazy` remains the arbitrary-shape path.
    untyped = JSON.parse("{\"name\":\"Ada\"}")
    checked(untyped isa JSON.Object{String,Any}, "untyped object parse failed")
    name = (untyped::JSON.Object{String,Any})["name"]
    checked(name isa String, "untyped string shape failed")
    checked((name::String) == "Ada", "untyped string value failed")

    checked(JSON.parse("7", Int) == 7, "typed scalar parse failed")
    checked(JSON.parse(IOBuffer(STRING_JSON), String) == "Ada", "typed IO parse failed")
    checked(JSON.parse(ARRAY_JSON, Vector{Int}) == [1, 2, 3], "typed array parse failed")
    checked(JSON.parse("{\"score\":7}", Dict{String,Int}) == Dict("score" => 7),
        "typed dictionary parse failed")

    root = JSON.parse(
        "{\"item\":{\"id\":1,\"name\":\"one\"},\"items\":[{\"id\":2,\"name\":\"two\"}],\"tags\":[\"a\"],\"note\":null}",
        TrimRoot,
    )
    checked(root.item !== nothing && root.item.id == 1, "nested struct parse failed")
    checked(length(root.items) == 1 && root.items[1].name == "two",
        "nested vector parse failed")
    checked(root.tags == ["a"] && root.note === nothing, "nullable field parse failed")

    tagged = JSON.parse(
        "{\"wire\":4,\"secret\":99}",
        TrimTagged;
        unknown_fields=:error,
    )
    checked(tagged == TrimTagged(4, 9), "field-tag parse failed")

    mutable_value = TrimMutable()
    JSON.parse!("{\"value\":8}", mutable_value; unknown_fields=:error)
    checked(mutable_value.value == 8, "parse! failed")

    unknown = try
        JSON.parse("{\"extra\":1}", TrimLeaf; unknown_fields=:error)
        nothing
    catch err
        err
    end
    checked(unknown isa ArgumentError, "unknown-field diagnostic failed")
    return nothing
end

function exercise_write_entrypoints()::Nothing
    obj = JSON.Object{String, Int}("score" => 7)
    obj[:score] = 10
    checked(obj.score == 10, "Object property access failed")
    checked(haskey(obj, "score"), "Object setindex! failed")
    delete!(obj, :score)
    checked(!haskey(obj, "score"), "Object delete! failed")

    checked(JSON.json([1, 2, 3]) == ARRAY_JSON, "json string output failed")

    io = IOBuffer()
    JSON.json(io, [1, 2, 3]; pretty = 2)
    checked(String(take!(io)) == "[\n  1,\n  2,\n  3\n]", "pretty IO json output failed")

    print_io = IOBuffer()
    JSON.print(print_io, [1, 2, 3], 2)
    checked(String(take!(print_io)) == "[\n  1,\n  2,\n  3\n]", "JSON.print failed")

    jsonlines = JSON.json([[1], [2]]; jsonlines = true)
    checked(jsonlines == "[1]\n[2]\n", "jsonlines write failed")
    checked(JSON.json(JSON.JSONText("{\"raw\":true}")) == "{\"raw\":true}", "JSONText write failed")
    checked(JSON.json(JSON.Null()) == "null", "JSON.Null write failed")
    checked(JSON.json(TrimCode("beta")) == "\"beta\"", "custom lower write failed")

    # Date, DateTime, and Time round-trip through their canonical ISO text.
    temporal = TrimTemporal(
        Dates.Date(2026, 8, 7),
        Dates.DateTime(2026, 8, 7, 15, 0, 0, 76),
        Dates.Time(12, 30, 15, 250),
    )
    temporal_json = JSON.json(temporal)
    checked(
        temporal_json ==
        "{\"day\":\"2026-08-07\",\"stamp\":\"2026-08-07T15:00:00.076\",\"tick\":\"12:30:15.25\"}",
        "temporal write failed",
    )
    checked(
        JSON.parse(temporal_json, TrimTemporal) == temporal,
        "temporal read failed",
    )
    checked(
        JSON.json(Dates.DateTime(2026, 1, 1)) == "\"2026-01-01T00:00:00\"",
        "zero-millisecond DateTime write failed",
    )
    return nothing
end

function run_json_trim_public_entrypoints()::Nothing
    exercise_lazy_entrypoints()
    exercise_parse_entrypoints()
    exercise_write_entrypoints()
    return nothing
end

function @main(args::Vector{String})::Cint
    _ = args
    run_json_trim_public_entrypoints()
    return 0
end

Base.Experimental.entrypoint(main, (Vector{String},))

using JSON, StructUtils, UUIDs, Dates, Test

struct CustomJSONStyle <: JSON.JSONStyle end
struct RefValueStyle <: JSON.JSONStyle end
struct DateStringStyle <: JSON.JSONStyle end
struct DateObjectStyle <: JSON.JSONStyle end
struct DateMaterializedObjectStyle <: JSON.JSONStyle end

struct A
    a::Int
    b::Int
    c::Int
    d::Int
end

@noarg mutable struct B
    a::Int
    b::Int
    c::Int
    d::Int
end

struct C
end

struct D
    a::Int
    b::Float64
    c::String
end

struct LotsOfFields
    x1::String
    x2::String
    x3::String
    x4::String
    x5::String
    x6::String
    x7::String
    x8::String
    x9::String
    x10::String
    x11::String
    x12::String
    x13::String
    x14::String
    x15::String
    x16::String
    x17::String
    x18::String
    x19::String
    x20::String
    x21::String
    x22::String
    x23::String
    x24::String
    x25::String
    x26::String
    x27::String
    x28::String
    x29::String
    x30::String
    x31::String
    x32::String
    x33::String
    x34::String
    x35::String
end

struct Wrapper
    x::NamedTuple{(:a, :b), Tuple{Int, String}}
end

@noarg mutable struct UndefGuy
    id::Int
    name::String
end

struct E
    id::Int
    a::A
end

@kwarg struct F
    id::Int
    rate::Float64
    name::String
end

@kwarg struct G
    id::Int
    rate::Float64
    name::String
    f::F
end

struct H
    id::Int
    name::String
    properties::Dict{String, Any}
    addresses::Vector{String}
end

@enum Fruit apple banana

struct I
    id::Int
    name::String
    fruit::Fruit
end

abstract type Vehicle end

struct Car <: Vehicle
    type::String
    make::String
    model::String
    seatingCapacity::Int
    topSpeed::Float64
end

struct Truck <: Vehicle
    type::String
    make::String
    model::String
    payloadCapacity::Float64
end

struct J
    id::Union{Int, Nothing}
    name::Union{String, Nothing}
    rate::Union{Int64, Float64}
end

struct K
    id::Int
    value::Union{Float64, Missing}
end

@kwarg struct System
    duration::Real = 0 # mandatory
    cwd::Union{Nothing, String} = nothing
    environment::Union{Nothing, Dict} = nothing
    batch::Union{Nothing, Dict} = nothing
    shell::Union{Nothing, Dict} = nothing
end

StructUtils.@defaults struct L
    id::Int
    first_name::String &(json=(name=:firstName,),)
    rate::Float64 = 33.3
end

StructUtils.@tags struct ThreeDates
    date::Date &(json=(dateformat=dateformat"yyyy_mm_dd",),)
    datetime::DateTime &(json=(dateformat=dateformat"yyyy/mm/dd HH:MM:SS",),)
    time::Time &(json=(dateformat=dateformat"HH/MM/SS",),)
end

struct M
    id::Int
    value::Union{Nothing,K}
end

struct Recurs
    id::Int
    value::Union{Nothing,Recurs}
end

struct N
    id::Int
    uuid::UUID
end

struct O
    id::Int
    name::Union{I,L,Missing,Nothing}
end

struct Point
    x::Int
    y::Int
end

@defaults struct P
    num::Int64
    foo::String = "bar"
end

# example from JSON.parse docstring
abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

JSON.lower(x::Dracula) = (type="vampire", num_victims=x.num_victims)

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

JSON.lower(x::Werewolf) = (type="werewolf", witching_hour=x.witching_hour)

JSON.@choosetype AbstractMonster x -> x.monster_type[] == "vampire" ? Dracula : Werewolf

@nonstruct struct Percent <: Number
    value::Float64
end

JSON.lift(::Type{Percent}, x) = Percent(Float64(x))
StructUtils.liftkey(::Type{Percent}, x::String) = Percent(parse(Float64, x))

@defaults struct FrankenStruct
    id::Int = 0
    name::String = "Jim"
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = nothing
    monster::AbstractMonster = Dracula(0)
    percent::Percent = Percent(0.0)
    birthdate::Date = Date(0) &(json=(dateformat="yyyy/mm/dd",),)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}()
    json_properties::JSONText = JSONText("")
    matrix::Matrix{Float64} = Matrix{Float64}(undef, 0, 0)
end

@tags struct Q
    id::Int
    any::Any &(choosetype=x -> x.type[] == "int" ? @NamedTuple{type::String, value::Int} : x.type[] == "float" ? @NamedTuple{type::String, value::Float64} : @NamedTuple{type::String, value::String},)
end

# https://github.com/JuliaIO/JSON.jl/issues/453 - custom JSONStyle dictlike dispatch
@kwdef struct DictlikeViaCustomStyle
    vals::Dict{String,Int} = Dict{String,Int}()
end
Base.keytype(::DictlikeViaCustomStyle) = String
Base.valtype(::DictlikeViaCustomStyle) = Int
StructUtils.addkeyval!(a::DictlikeViaCustomStyle, k, v) = StructUtils.addkeyval!(a.vals, k, v)
StructUtils.dictlike(::CustomJSONStyle, ::Type{DictlikeViaCustomStyle}) = true

StructUtils.structlike(::RefValueStyle, ::Type{Base.RefValue{Int}}) = false
StructUtils.lower(::RefValueStyle, x::Base.RefValue{Int}) = x[]
StructUtils.lift(::RefValueStyle, ::Type{Base.RefValue{Int}}, x::Integer) = Ref{Int}(x), nothing

JSON.lower(::DateStringStyle, d::Date) = string(d)
JSON.lift(::DateStringStyle, ::Type{Date}, x::String) = Date(x)
JSON.lower(::DateObjectStyle, d::Date) = (; time=string(d))
JSON.lift(::DateObjectStyle, ::Type{Date}, x::JSON.LazyValue) = Date(x.time[])
JSON.lower(::DateMaterializedObjectStyle, d::Date) = (; time=string(d))
JSON.lift(::DateMaterializedObjectStyle, ::Type{Date}, x::JSON.Object) = Date(x["time"])

@testset "JSON.parse" begin
    @testset "errors" begin
        # Unexpected character in array
        @test_throws ArgumentError JSON.lazy("[1,2,3/4,5,6,7]")[]
        # Unexpected character in object
        @test_throws ArgumentError JSON.lazy("{\"1\":2, \"2\":3 _ \"4\":5}")[]
        # Invalid escaped character
        @test_throws ArgumentError JSON.lazy("[\"alpha\\α\"]")[]
        # Invalid 'simple' and 'unknown value'
        @test_throws ArgumentError JSON.lazy("[tXXe]")[]
        @test_throws ArgumentError JSON.lazy("[fail]")[]
        @test_throws ArgumentError JSON.lazy("∞")[]
        # Invalid number
        @test_throws ArgumentError JSON.lazy("[5,2,-]")[]
        @test_throws ArgumentError JSON.lazy("[5,2,+β]")[]
        # Incomplete escape
        @test_throws ArgumentError JSON.lazy("\"\\")[]
        @test_throws ArgumentError JSON.lazy("[\"🍕\"_\"🍕\"")[]
        # incomplete surrogate pair *doesn't* throw, but resulting string is invalid utf8
        # https://github.com/JuliaIO/JSON.jl/issues/232
        x = JSON.parse("{\"id\":\"5\",\"name\":\"IllegalUnicodehalf-surrogateU+D800\",\"url\":\"http://www.example.com/#\\\\\\ud800\\\\\\u597D\",\"expect_url\":\"http://www.example.com/#\\\\\\uFFFD\\\\\\u597D\"}")
        @test !isvalid(x.url)
        @test x.url == "http://www.example.com/#\\\ud8000\\好"
    end # @testset "errors"

    # JSON.jl pre-1.0 compat
    x = JSON.parse("{}")
    @test isempty(x) && typeof(x) == JSON.Object{String, Any}
    x = JSON.parsefile(makefile("empty_object.json", "{}"))
    @test isempty(x) && typeof(x) == JSON.Object{String, Any}
    x = JSON.parsefile(makefile("empty_object.json", "{}"), Any)
    @test isempty(x) && typeof(x) == JSON.Object{String, Any}
    x = Dict{String, Any}()
    JSON.parsefile!(makefile("empty_object.json", "{}"), x)
    @test isempty(x)
    io = IOBuffer()
    write(io, "{}")
    seekstart(io)
    x = JSON.parse(io)
    @test isempty(x) && typeof(x) == JSON.Object{String, Any}
    seekstart(io)
    x = Dict{String, Any}()
    JSON.parse!(io, x)
    @test isempty(x)
    seekstart(io)
    @test JSON.isvalidjson(io)
    open(makefile("empty_object.json", "{}"), "r") do io
        x = Dict{String, Any}()
        JSON.parse!(io, x)
        @test isempty(x)
    end
    open(makefile("empty_object.json", "{}"), "r") do io
        @test JSON.isvalidjson(io)
    end
    @test JSON.isvalidjson("{}")
    @test !JSON.isvalidjson("{JSON")
    @test !JSON.isvalidjson("JSON")
    @test !JSON.isvalidjson(collect(codeunits("JSON")))
    x = JSON.parse("{}")
    @test isempty(x) && typeof(x) == JSON.Object{String, Any}
    @test_throws ArgumentError JSON.parse(JSON.LazyValue(".", 1, JSON.JSONTypes.OBJECT, JSON.LazyOptions(), true))
    x = JSON.lazy("1")
    @test_throws ArgumentError JSON.StructUtils.applyeach((k, v) -> nothing, x)
    x = JSON.parse("{\"a\": 1}")
    @test !isempty(x) && x["a"] == 1 && typeof(x) == JSON.Object{String, Any}
    x = JSON.parse("{\"a\": 1, \"b\": null, \"c\": true, \"d\": false, \"e\": \"\", \"f\": [], \"g\": {}}")
    @test !isempty(x) && x["a"] == 1 && x["b"] === nothing && x["c"] === true && x["d"] === false && x["e"] == "" && x["f"] == Any[] && x["g"] == JSON.Object{String, Any}()
    # https://github.com/JuliaIO/JSON.jl/issues/456
    x = JSON.parse("{\"a\": 1}", JSON.Object)
    @test x isa JSON.Object{String, Any} && x["a"] == 1
    # custom dicttype
    x = JSON.parse("{\"a\": 1, \"b\": null, \"c\": true, \"d\": false, \"e\": \"\", \"f\": [], \"g\": {}}"; dicttype=Dict{String, Any})
    # test that x isa Dict and nested x.g is also a Dict
    @test x isa Dict{String, Any} && !isempty(x) && x["a"] == 1 && x["b"] === nothing && x["c"] === true && x["d"] === false && x["e"] == "" && x["f"] == Any[] && x["g"] == Dict{String, Any}() && typeof(x["g"]) == Dict{String, Any}
    # alternative key types
    x = JSON.parse("{\"a\": 1, \"b\": null}"; dicttype=JSON.Object{Symbol, Any})
    @test x isa JSON.Object{Symbol, Any} && !isempty(x) && x[:a] == 1 && x[:b] === nothing
    x = JSON.parse("{\"apple\": 1, \"banana\": null}"; dicttype=JSON.Object{Fruit, Any})
    @test x isa JSON.Object{Fruit, Any} && !isempty(x) && x[apple] == 1 && x[banana] === nothing
    x = JSON.parse("[]")
    @test isempty(x) && x == Any[]
    x = JSON.parse("[1, null, true, false, \"\", [], {}]")
    @test !isempty(x) && x[1] == 1 && x[2] === nothing && x[3] === true && x[4] === false && x[5] == "" && x[6] == Any[] && x[7] == JSON.Object{String, Any}()
    x = JSON.parse("1")
    @test x == 1
    x = JSON.parse("true")
    @test x === true
    x = JSON.parse("false")
    @test x === false
    x = JSON.parse("null")
    @test x === nothing
    x = JSON.parse("\"\"")
    @test x == ""
    x = JSON.parse("\"a\"")
    @test x == "a"
    x = JSON.parse("\"\\\"\"")
    @test x == "\""
    x = JSON.parse("\"\\\\\"")
    @test x == "\\"
    x = JSON.parse("\"\\/\"")
    @test x == "/"
    x = JSON.parse("\"\\b\"")
    @test x == "\b"
    x = JSON.parse("\"\\f\"")
    @test x == "\f"
    x = JSON.parse("\"\\n\"")
    @test x == "\n"
    x = JSON.parse("\"\\r\"")
    @test x == "\r"
    x = JSON.parse("\"\\t\"")
    @test x == "\t"
    x = JSON.parse("\"\\u0000\"")
    @test x == "\0"
    x = JSON.parse("\"\\uD83D\\uDE00\"")
    @test x == "😀"
    x = JSON.parse("\"\\u0061\"")
    @test x == "a"
    x = JSON.parse("\"\\u2028\"")
    @test x == "\u2028"
    x = JSON.parse("\"\\u2029\"")
    @test x == "\u2029"
    @test_throws ArgumentError JSON.parse("nula")
    @test_throws ArgumentError JSON.parse("nul")
    @test_throws ArgumentError JSON.parse("trub")
    # allownan for parsing normally invalid json values
    @test JSON.parse("NaN"; allownan=true) === NaN
    @test JSON.parse("Inf"; inf="Inf", allownan=true) === Inf
    # jsonlines support
    @test JSON.parse("1"; jsonlines=true) == [1]
    @test JSON.parse("1 \t"; jsonlines=true) == [1]
    @test JSON.parse("1 \t\r"; jsonlines=true) == [1]
    @test JSON.parse("1 \t\r\n"; jsonlines=true) == [1]
    @test JSON.parse("1 \t\r\nnull"; jsonlines=true) == [1, nothing]
    @test JSON.lazy("1\nnull"; jsonlines=true)[] == [1, nothing]
    @test JSON.parse("1\n\n2\n\n"; jsonlines=true) == [1, 2]
    # auto-detected jsonlines
    @test JSON.parsefile(makefile("jsonlines.jsonl", "1\n2\n3\n4")) == [1, 2, 3, 4]
    # missing newline
    @test_throws ArgumentError JSON.parse("1 \t\bnull"; jsonlines=true)
    @test_throws ArgumentError JSON.parse(""; jsonlines=true)
    @test JSON.parse("1\n2\n3\n4"; jsonlines=true) == [1, 2, 3, 4]
    @test JSON.parse("[1]\n[2]\n[3]\n[4]"; jsonlines=true) == [[1], [2], [3], [4]]
    @test JSON.parse("{\"a\": 1}\n{\"b\": 2}\n{\"c\": 3}\n{\"d\": 4}"; jsonlines=true) == [Dict("a" => 1), Dict("b" => 2), Dict("c" => 3), Dict("d" => 4)]
    @test JSON.parse("""
    ["Name", "Session", "Score", "Completed"]
    ["Gilbert", "2013", 24, true]
    ["Alexa", "2013", 29, true]
    ["May", "2012B", 14, false]
    ["Deloise", "2012A", 19, true]
    """; jsonlines=true, allownan=true) ==
    [["Name", "Session", "Score", "Completed"],
     ["Gilbert", "2013", 24, true],
     ["Alexa", "2013", 29, true],
     ["May", "2012B", 14, false],
     ["Deloise", "2012A", 19, true]]
    @test JSON.parse("""
    {"name": "Gilbert", "wins": [["straight", "7♣"], ["one pair", "10♥"]]}
    {"name": "Alexa", "wins": [["two pair", "4♠"], ["two pair", "9♠"]]}
    {"name": "May", "wins": []}
    {"name": "Deloise", "wins": [["three of a kind", "5♣"]]}
    """; jsonlines=true) ==
    [Dict("name" => "Gilbert", "wins" => [["straight", "7♣"], ["one pair", "10♥"]]),
     Dict("name" => "Alexa", "wins" => [["two pair", "4♠"], ["two pair", "9♠"]]),
     Dict("name" => "May", "wins" => []),
     Dict("name" => "Deloise", "wins" => [["three of a kind", "5♣"]])]
    
    @test_throws ArgumentError JSON.parse("{\"a\" 1}")
    @test_throws ArgumentError JSON.parse("123a")
    @test_throws ArgumentError JSON.parse("123.4a")
    @test_throws ArgumentError JSON.parse("[1]e")
    @test_throws ArgumentError JSON.parse("\"abc\"e+")
    @test_throws ArgumentError JSON.parse("1a\n2\n3"; jsonlines=true)
    @test_throws ArgumentError JSON.parse("1\n2\n3a"; jsonlines=true)
    @test_throws ArgumentError JSON.parse(" 123a")

    @testset "Number parsing" begin
        @test JSON.parse("1") === Int64(1)
        @test JSON.parse("1 ") === Int64(1)
        @test JSON.parse("-1") === Int64(-1)
        @test_throws ArgumentError JSON.parse("1.")
        @test_throws ArgumentError JSON.parse("-1.")
        @test_throws ArgumentError JSON.parse("-1. ")
        @test JSON.parse("1.1") === 1.1
        @test JSON.parse("1e1") === 10.0
        @test JSON.parse("1E23") === 1e23
        # @test JSON.parse("1f23") === 1f23
        # @test JSON.parse("1F23") === 1f23
        @test JSON.parse("100000000000000000000000") == 100000000000000000000000
        for T in (Int8, Int16, Int32, Int64, Int128)
            @test JSON.parse(string(T(1))) == T(1)
            @test JSON.parse(string(T(-1))) == T(-1)
        end

        @test JSON.parse("428.0E+03") === 428e3
        @test JSON.parse("1e+1") === 10.0
        @test JSON.parse("1e-1") === 0.1
        @test JSON.parse("1.1e1") === 11.0
        @test JSON.parse("1.1e+1") === 11.0
        @test JSON.parse("1.1e-1") === 0.11
        @test JSON.parse("1.1e-01") === 0.11
        @test JSON.parse("1.1e-001") === 0.11
        @test JSON.parse("1.1e-0001") === 0.11
        @test JSON.parse("9223372036854775797") === 9223372036854775797
        @test JSON.parse("9223372036854775798") === 9223372036854775798
        @test JSON.parse("9223372036854775799") === 9223372036854775799
        @test JSON.parse("9223372036854775800") === 9223372036854775800
        @test JSON.parse("9223372036854775801") === 9223372036854775801
        @test JSON.parse("9223372036854775802") === 9223372036854775802
        @test JSON.parse("9223372036854775803") === 9223372036854775803
        @test JSON.parse("9223372036854775804") === 9223372036854775804
        @test JSON.parse("9223372036854775805") === 9223372036854775805
        @test JSON.parse("9223372036854775806") === 9223372036854775806
        @test JSON.parse("9223372036854775807") === 9223372036854775807
        # promote to BigInt
        x = JSON.parse("9223372036854775808")
        # only == here because BigInt don't compare w/ ===
        @test x isa BigInt && x == 9223372036854775808
        x = JSON.parse("170141183460469231731687303715884105727")
        @test x isa BigInt && x == 170141183460469231731687303715884105727
        x = JSON.parse("170141183460469231731687303715884105728")
        @test x isa BigInt && x == 170141183460469231731687303715884105728
        # BigFloat
        @test JSON.parse("1.7976931348623157e310") == big"1.7976931348623157e310"

        # zeros
        @test JSON.parse("0") === Int64(0)
        @test JSON.parse("0e0") === 0.0
        @test JSON.parse("-0e0") === -0.0
        @test JSON.parse("0e-0") === 0.0
        @test JSON.parse("-0e-0") === -0.0
        @test JSON.parse("0e+0") === 0.0
        @test JSON.parse("-0e+0") === -0.0
        @test JSON.parse("0e+01234567890123456789") == big"0.0"
        @test JSON.parse("0.00e-01234567890123456789") == big"0.0"
        @test JSON.parse("-0e+01234567890123456789") == big"0.0"
        @test JSON.parse("-0.00e-01234567890123456789") == big"0.0"
        @test JSON.parse("0e291") === 0.0
        @test JSON.parse("0e292") === 0.0
        @test JSON.parse("0e347") == big"0.0"
        @test JSON.parse("0e348") == big"0.0"
        @test JSON.parse("-0e291") === 0.0
        @test JSON.parse("-0e292") === 0.0
        @test JSON.parse("-0e347") == big"0.0"
        @test JSON.parse("-0e348") == big"0.0"
        @test JSON.parse("2e-324") === 0.0
        # extremes
        @test JSON.parse("1e310") == big"1e310"
        @test JSON.parse("-1e310") == big"-1e310"
        @test JSON.parse("1e-305") === 1e-305
        @test JSON.parse("1e-306") === 1e-306
        @test JSON.parse("1e-307") === 1e-307
        @test JSON.parse("1e-308") === 1e-308
        @test JSON.parse("1e-309") === 1e-309
        @test JSON.parse("1e-310") === 1e-310
        @test JSON.parse("1e-322") === 1e-322
        @test JSON.parse("5e-324") === 5e-324
        @test JSON.parse("4e-324") === 5e-324
        @test JSON.parse("3e-324") === 5e-324
        # errors
        @test_throws ArgumentError JSON.parse("1e")
        @test_throws ArgumentError JSON.parse("1.0ea")
        @test_throws ArgumentError JSON.parse("1e+")
        @test_throws ArgumentError JSON.parse("1e-")
        @test_throws ArgumentError JSON.parse(".")
        @test_throws ArgumentError JSON.parse("1.a")
        @test_throws ArgumentError JSON.parse("1e1.")
        @test_throws ArgumentError JSON.parse("-")
        @test_throws ArgumentError JSON.parse("1.1.")
        @test_throws ArgumentError JSON.parse("+0e0")
        @test_throws ArgumentError JSON.parse("+0e+0")
        @test_throws ArgumentError JSON.parse("+0e-0")
        @test_throws ArgumentError JSON.parse(".1")
        @test_throws ArgumentError JSON.parse("+1")
    end
    @testset "JSON.parse with types" begin
        obj = JSON.parse("""{ "a": 1,"b": 2,"c": 3,"d": 4}""", A)
        @test obj == A(1, 2, 3, 4)
        @test JSON.parse("""{ "a": 1,"b": 2,"c": 3,"d": 4, "e": 5}""", A) == A(1, 2, 3, 4)
        # test order doesn't matter
        obj2 = JSON.parse("""{ "d": 1,"b": 2,"c": 3,"a": 4}""", A)
        @test obj2 == A(4, 2, 3, 1)
        # NamedTuple
        obj = JSON.parse("""{ "d": 1,"b": 2,"c": 3,"a": 4}""", NamedTuple{(:a, :b, :c, :d), Tuple{Int, Int, Int, Int}})
        @test obj == (a = 4, b = 2, c = 3, d = 1)
        @test JSON.parse("{}", C) === C()
        # we also support materializing singleton from JSON.json output
        @test JSON.parse("\"C()\"", C) === C()
        obj = B()
        JSON.parse!("""{ "a": 1,"b": 2,"c": 3,"d": 4}""", obj)
        @test obj.a == 1 && obj.b == 2 && obj.c == 3 && obj.d == 4
        obj = JSON.parse("""{ "a": 1,"b": 2,"c": 3,"d": 4}""", B)
        @test obj.a == 1 && obj.b == 2 && obj.c == 3 && obj.d == 4
        # can materialize json array into struct assuming field order
        obj = JSON.parse("""[1, 2, 3, 4]""", A)
        @test obj == A(1, 2, 3, 4)
        # must be careful though because we don't check that the array is the same length as the struct
        @test JSON.parse("""[1, 2, 3, 4, 5]""", A) == A(1, 2, 3, 4)
        @test_throws Any JSON.parse("""[1, 2, 3]""", A)
        # materialize singleton from empty json array
        @test JSON.parse("""[]""", C) == C()
        # materialize mutable from json array
        obj = JSON.parse("""[1, 2, 3, 4]""", B)
        @test obj.a == 1 && obj.b == 2 && obj.c == 3 && obj.d == 4
        obj = B()
        JSON.parse!("""[1, 2, 3, 4]""", obj)
        @test obj.a == 1 && obj.b == 2 && obj.c == 3 && obj.d == 4
        # materialize kwdef from json array
        obj = JSON.parse("""[1, 3.14, "hey there sailor"]""", F)
        @test obj == F(1, 3.14, "hey there sailor")
        # materialize NamedTuple from json array
        obj = JSON.parse("""[1, 3.14, "hey there sailor"]""", NamedTuple{(:id, :rate, :name), Tuple{Int, Float64, String}})
        @test obj == (id = 1, rate = 3.14, name = "hey there sailor")
        # materialize Tuple from json array
        obj = JSON.parse("""[1, 3.14, "hey there sailor"]""", Tuple{Int, Float64, String})
        @test obj == (1, 3.14, "hey there sailor")
        obj = JSON.parse("""{ "a": 1,"b": 2.0,"c": "3"}""", Tuple{Int, Float64, String})
        @test obj == (1, 2.0, "3")
        obj = JSON.parse("""{ "a": 1,"b": 2.0,"c": "3"}""", D)
        @test obj == D(1, 2.0, "3")
        obj = JSON.parse("""{ "x1": "1","x2": "2","x3": "3","x4": "4","x5": "5","x6": "6","x7": "7","x8": "8","x9": "9","x10": "10","x11": "11","x12": "12","x13": "13","x14": "14","x15": "15","x16": "16","x17": "17","x18": "18","x19": "19","x20": "20","x21": "21","x22": "22","x23": "23","x24": "24","x25": "25","x26": "26","x27": "27","x28": "28","x29": "29","x30": "30","x31": "31","x32": "32","x33": "33","x34": "34","x35": "35"}""", LotsOfFields)
        @test obj == LotsOfFields("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30", "31", "32", "33", "34", "35")
        obj = JSON.parse("""{ "x": {"a": 1, "b": "2"}}""", Wrapper)
        @test obj == Wrapper((a=1, b="2"))
        obj = JSON.parse!("""{ "id": 1, "name": "2"}""", UndefGuy)
        @test obj.id == 1 && obj.name == "2"
        obj = JSON.parse!("""{ "id": 1}""", UndefGuy)
        @test obj.id == 1 && !isdefined(obj, :name)
        obj = JSON.parse("""{ "id": 1, "a": {"a": 1, "b": 2, "c": 3, "d": 4}}""", E)
        @test obj == E(1, A(1, 2, 3, 4))
        @test_throws ArgumentError JSON.parse("""{ "a": 1,"b": 2,"c": 3,"d": 4, "e": 5}""", A; unknown_fields=:error)
        @test_throws ArgumentError JSON.parse("""{ "id": 1, "a": {"a": 1, "b": 2, "c": 3, "d": 4, "e": 5}}""", E; unknown_fields=:error)
        obj = B()
        @test_throws ArgumentError JSON.parse!("""{ "a": 1,"b": 2,"c": 3,"d": 4, "e": 5}""", obj; unknown_fields=:error)
        @test_throws ArgumentError JSON.parse("""[1, 2, 3, 4, 5]""", A; unknown_fields=:error)
        @test_throws ArgumentError JSON.parse("""{ "a": 1,"b": 2,"c": 3,"d": 4}""", A; unknown_fields=:boom)
        @test_throws ArgumentError JSON.parse("""{ "a": 1}"""; unknown_fields=:error)
        obj = JSON.parse("""{ "id": 1, "rate": 2.0, "name": "3"}""", F)
        @test obj == F(1, 2.0, "3")
        obj = JSON.parse("""{ "id": 1, "rate": 2.0, "name": "3", "f": {"id": 1, "rate": 2.0, "name": "3"}}""", G)
        @test obj == G(1, 2.0, "3", F(1, 2.0, "3"))
        # Dict/Array fields
        obj = JSON.parse("""{ "id": 1, "name": "2", "properties": {"a": 1, "b": 2}, "addresses": ["a", "b"]}""", H)
        @test obj.id == 1 && obj.name == "2" && obj.properties == Dict("a" => 1, "b" => 2) && obj.addresses == ["a", "b"]
        # Enum
        @test JSON.parse("\"apple\"", Fruit) == apple
        @test JSON.parse("""{"id": 1, "name": "2", "fruit": "banana"}  """, I) == I(1, "2", banana)
        # abstract type
        @test JSON.parse("""{"id": 1, "name": "2", "fruit": "banana"}  """, Any) == JSON.Object("id" => 1, "name" => "2", "fruit" => "banana")
        @test JSON.parse("""{"id": 1, "f": {"id": 1, "rate": 2.0, "ints": [1, 2, 3]}}""", @NamedTuple{id::Int, f::Any}) == (id = 1, f = JSON.Object("id" => 1, "rate" => 2.0, "ints" => [1, 2, 3]))

        JSON.@choosetype Vehicle x -> x.type[] == "car" ? Car : x.type[] == "truck" ? Truck : throw(ArgumentError("Unknown vehicle type: $(x.type[])"))

        @test JSON.parse("""{"type": "car","make": "Mercedes-Benz","model": "S500","seatingCapacity": 5,"topSpeed": 250.1}""", Vehicle) == Car("car", "Mercedes-Benz", "S500", 5, 250.1)
        @test JSON.parse("""{"type": "truck","make": "Isuzu","model": "NQR","payloadCapacity": 7500.5}""", Vehicle) == Truck("truck", "Isuzu", "NQR", 7500.5)
        # union
        @test JSON.parse("""{"id": 1, "name": "2", "rate": 3}""", J) == J(1, "2", Int64(3))
        @test JSON.parse("""{"id": null, "name": null, "rate": 3.14}""", J) == J(nothing, nothing, 3.14)
        # test K
        @test JSON.parse("""{"id": 1, "value": null}""", K) == K(1, missing)
        # Real
        @test JSON.parse("""{"duration": 3600.0}""", System) == System(duration=3600.0)
        # struct + jsonlines
        for raw in [
            """
            { "a": 1,  "b": 3.14,  "c": "hey" }
            { "a": 2,  "b": 6.28,  "c": "hi"  }
            """,
            # No newline at end
            """
            { "a": 1,  "b": 3.14,  "c": "hey" }
            { "a": 2,  "b": 6.28,  "c": "hi"  }""",
            # No newline, extra whitespace at end
            """
            { "a": 1,  "b": 3.14,  "c": "hey" }
            { "a": 2,  "b": 6.28,  "c": "hi"  }   """,
            # Whitespace at start of line
            """
              { "a": 1,  "b": 3.14,  "c": "hey" }
              { "a": 2,  "b": 6.28,  "c": "hi"  }
            """,
            # Extra whitespace at beginning, end of lines, end of string
            " { \"a\": 1,  \"b\": 3.14,  \"c\": \"hey\" }  \n" *
            "  { \"a\": 2,  \"b\": 6.28,  \"c\": \"hi\"  }  \n  ",
        ]
            for nl in ("\n", "\r", "\r\n")
                jsonl = replace(raw, "\n" => nl)
                dss = JSON.parse(jsonl, Vector{D}, jsonlines=true)
                @test length(dss) == 2
                @test dss[1].a == 1
                @test dss[1].b == 3.14
                @test dss[1].c == "hey"
                @test dss[2].a == 2
                @test dss[2].b == 6.28
                @test dss[2].c == "hi"
            end
        end
        # test L
        @test JSON.parse("""{"id": 1, "firstName": "george", "first_name": "harry"}""", L) == L(1, "george", 33.3)
        # test Char
        @test JSON.parse("\"a\"", Char) == 'a'
        @test JSON.parse("\"\u2200\"", Char) == '∀'
        @test_throws ArgumentError JSON.parse("\"ab\"", Char)
        # test UUID
        @test JSON.parse("\"ffffffff-ffff-ffff-ffff-ffffffffffff\"", UUID) == UUID(typemax(UInt128))
        # test Symbol
        @test JSON.parse("\"a\"", Symbol) == :a
        # test VersionNumber
        @test JSON.parse("\"1.2.3\"", VersionNumber) == v"1.2.3"
        # test Regex
        @test JSON.parse("\"1.2.3\"", Regex) == r"1.2.3"
        # test Dates
        @test JSON.parse("\"2023-02-23T22:39:02\"", DateTime) == DateTime(2023, 2, 23, 22, 39, 2)
        @test JSON.parse("\"2023-02-23\"", Date) == Date(2023, 2, 23)
        @test JSON.parse("\"22:39:02\"", Time) == Time(22, 39, 2)
        @test JSON.parse("{\"date\":\"2023_02_23\",\"datetime\":\"2023/02/23 12:34:56\",\"time\":\"12/34/56\"}", ThreeDates) ==
            ThreeDates(Date(2023, 2, 23), DateTime(2023, 2, 23, 12, 34, 56), Time(12, 34, 56))
        # test Array w/ lifted value
        @test isequal(JSON.parse("[null,null]", Vector{Missing}), [missing, missing])
        # test Matrix
        @test JSON.parse("[[1,3],[2,4]]", Matrix{Int}) == [1 2; 3 4]
        @test JSON.parse("{\"a\": [[1,3],[2,4]]}", NamedTuple{(:a,),Tuple{Matrix{Int}}}) == (a=[1 2; 3 4],)
        # test Matrix w/ lifted value
        @test isequal(JSON.parse("[[null,null],[null,null]]", Matrix{Missing}), [missing missing; missing missing])
        # test lift on Dict values
        obj = JSON.parse("""{\"ffffffff-ffff-ffff-ffff-ffffffffffff\": null,\"ffffffff-ffff-ffff-ffff-fffffffffffe\": null}""", Dict{UUID,Missing})
        @test obj[UUID(typemax(UInt128))] === missing
        @test obj[UUID(typemax(UInt128) - 0x01)] === missing
        # parse! with custom dicttype
        obj = Dict{String, Any}()
        JSON.parse!("""{"a": {"a": 1, "b": 2}, "b": {"a": 3, "b": 4}}""", obj; dicttype=Dict{String, Any})
        @test obj["a"] == Dict("a" => 1, "b" => 2)
        @test obj["b"] == Dict("a" => 3, "b" => 4)
        # nested union struct field
        @test JSON.parse("""{"id": 1, "value": {"id": 1, "value": null}}""", M) == M(1, K(1, missing))
        # recusrive field materialization
        x = JSON.parse("""{ "id": 1, "value": { "id": 2 } }""", Recurs)
        @test x == Recurs(1, Recurs(2, nothing))
        # multidimensional arrays
        # "[[1.0],[2.0]]" => (1, 2)
        m = Matrix{Float64}(undef, 1, 2)
        m[1] = 1
        m[2] = 2
        @test JSON.parse("[[1.0],[2.0]]", Matrix{Float64}) == m
        # "[[1.0,2.0]]" => (2, 1)
        m = Matrix{Float64}(undef, 2, 1)
        m[1] = 1
        m[2] = 2
        @test JSON.parse("[[1.0,2.0]]", Matrix{Float64}) == m
        # "[[[1.0]],[[2.0]]]" => (1, 1, 2)
        m = Array{Float64}(undef, 1, 1, 2)
        m[1] = 1
        m[2] = 2
        @test JSON.parse("[[[1.0]],[[2.0]]]", Array{Float64, 3}) == m
        # "[[[1.0],[2.0]]]" => (1, 2, 1)
        m = Array{Float64}(undef, 1, 2, 1)
        m[1] = 1
        m[2] = 2
        @test JSON.parse("[[[1.0],[2.0]]]", Array{Float64, 3}) == m
        # "[[[1.0,2.0]]]" => (2, 1, 1)
        m = Array{Float64}(undef, 2, 1, 1)
        m[1] = 1
        m[2] = 2
        @test JSON.parse("[[[1.0,2.0]]]", Array{Float64, 3}) == m
        m = Array{Float64}(undef, 1, 2, 3)
        m[1] = 1
        m[2] = 2
        m[3] = 3
        m[4] = 4
        m[5] = 5
        m[6] = 6
        @test JSON.parse("[[[1.0],[2.0]],[[3.0],[4.0]],[[5.0],[6.0]]]", Array{Float64, 3}) == m
        # 0-dimensional array
        m = Array{Float64,0}(undef)
        m[1] = 1.0
        @test JSON.parse("1.0", Array{Float64,0}) == m
        # test custom JSONStyle
        # StructUtils.lift(::CustomJSONStyle, ::Type{UUID}, x) = UUID(UInt128(x))
        # @test JSON.parse("340282366920938463463374607431768211455", UUID; style=CustomJSONStyle()) == UUID(typemax(UInt128))
        # @test JSON.parse("{\"id\": 0, \"uuid\": 340282366920938463463374607431768211455}", N; style=CustomJSONStyle()) == N(0, UUID(typemax(UInt128)))
        # tricky unions
        @test JSON.parse("{\"id\":0}", O) == O(0, nothing)
        @test JSON.parse("{\"id\":0,\"name\":null}", O) == O(0, missing)
        # StructUtils.choosetype(::CustomJSONStyle, ::Type{Union{I,L,Missing,Nothing}}, val) = JSON.gettype(val) == JSON.JSONTypes.NULL ? Missing : hasproperty(val, :fruit) ? I : L
        # @test JSON.parse("{\"id\":0,\"name\":{\"id\":1,\"name\":\"jim\",\"fruit\":\"apple\"}}", O; style=CustomJSONStyle()) == O(0, I(1, "jim", apple))
        # @test JSON.parse("{\"id\":0,\"name\":{\"id\":1,\"firstName\":\"jim\",\"rate\":3.14}}", O; style=CustomJSONStyle()) == O(0, L(1, "jim", 3.14))

        StructUtils.liftkey(::JSON.JSONStyle, ::Type{Point}, x::String) = Point(parse(Int, split(x, "_")[1]), parse(Int, split(x, "_")[2]))
        @test JSON.parse("{\"1_2\":\"hi\"}", Dict{Point, String}) == Dict(Point(1, 2) => "hi")
        # https://github.com/JuliaIO/JSON.jl/issues/422 - numeric dict key round-tripping
        @test JSON.parse(JSON.json(Dict(1=>1)), Dict{Int,Int}) == Dict(1 => 1)
        @test JSON.parse(JSON.json(Dict(1=>"a", 2=>"b")), Dict{Int,String}) == Dict(1 => "a", 2 => "b")
        @test JSON.parse(JSON.json(Dict{Int,Int}()), Dict{Int,Int}) == Dict{Int,Int}()
        @test JSON.parse("{\"1\":1,\"2\":2}", Dict{Int64,Int64}) == Dict(1 => 1, 2 => 2)
        @test JSON.parse("{\"1.5\":1,\"2.5\":2}", Dict{Float64,Int}) == Dict(1.5 => 1, 2.5 => 2)
        @test JSON.parse(JSON.json(Dict(1.5=>1, 2.5=>2)), Dict{Float64,Int}) == Dict(1.5 => 1, 2.5 => 2)
        # https://github.com/quinnj/JSON3.jl/issues/138
        @test JSON.parse("""{"num": 42}""", P) == P(42, "bar")
    end
    x = JSON.parse("[1,2,3]", JSONText)
    @test x == JSONText("[1,2,3]")
    # frankenstruct
    json = """
        {
            "id": 1,
            "address": "123 Main St",
            "rate": null,
            "franken_type": "b",
            "notsure": {"key": "value"},
            "monster": {
                "monster_type": "vampire",
                "num_victims": 10
            },
            "percent": 0.1,
            "birthdate": "2023/10/01",
            "percentages": {
                "0.1": 1,
                "0.2": 2
            },
            "json_properties": {"key": "value"},
            "matrix": [[1.0, 2.0], [3.0, 4.0]],
            "extra_key": "extra_value"
        }
        """
    fr = JSON.parse(json, FrankenStruct)
    # FrankenStruct(1, "Jim", "123 Main St", missing, :b, JSON.Object{String, Any}("key" => "value"), Dracula(10), Percent(0.1), Date("2023-10-01"), Dict{Percent, Int64}(Percent(0.2) => 2, Percent(0.1) => 1), JSONText("{\"key\": \"value\"}"), [1.0 3.0; 2.0 4.0])
    @test fr.id == 1
    @test fr.name == "Jim"
    @test fr.address == "123 Main St"
    @test fr.rate === missing
    @test fr.type == :b
    @test fr.notsure == JSON.Object{String, Any}("key" => "value")
    @test fr.monster == Dracula(10)
    @test fr.percent == Percent(0.1)
    @test fr.birthdate == Date("2023-10-01")
    @test fr.percentages == Dict(Percent(0.2) => 2, Percent(0.1) => 1)
    @test fr.json_properties == JSONText("{\"key\": \"value\"}")
    @test fr.matrix == [1.0 3.0; 2.0 4.0]
    # test custom JSONStyle overload
    JSON.lift(::CustomJSONStyle, ::Type{Rational}, x) = Rational(x.num[], x.den[])
    @test JSON.parse("{\"num\": 1,\"den\":3}", Rational; style=CustomJSONStyle()) == 1//3
    @test JSON.parse("{\"num\": 1,\"den\":3}", Rational; style=CustomJSONStyle(), unknown_fields=:error) == 1//3
    # https://github.com/JuliaIO/JSON.jl/issues/434
    @test JSON.parse(JSON.json(Date(2023, 1, 1); style=DateStringStyle()), Date; style=DateStringStyle()) == Date(2023, 1, 1)
    @test JSON.parse(JSON.json(Date(2023, 1, 1); style=DateObjectStyle()), Date; style=DateObjectStyle()) == Date(2023, 1, 1)
    @test JSON.parse(JSON.json(Date(2023, 1, 1); style=DateMaterializedObjectStyle()), Date; style=DateMaterializedObjectStyle()) == Date(2023, 1, 1)
    # https://github.com/JuliaIO/JSON.jl/issues/453 - dictlike dispatch on custom JSONStyle must reach user method
    let res = JSON.parse("""{"a": 1, "b": 2}""", DictlikeViaCustomStyle; style=CustomJSONStyle())
        @test res.vals == Dict("a" => 1, "b" => 2)
    end
    # https://github.com/JuliaIO/JSON.jl/issues/462 - structlike dispatch on custom JSONStyle must reach user method
    let json = JSON.json(Ref{Int}(1); style=RefValueStyle())
        @test json == "1"
        @test JSON.parse(json, Base.RefValue{Int}; style=RefValueStyle())[] == 1
    end
    @test isequal(JSON.parse("{\"num\": 1,\"den\":null}", @NamedTuple{num::Int, den::Union{Int, Missing}}; null=missing, style=StructUtils.DefaultStyle()), (num=1, den=missing))
    # choosetype field tag on Any struct field
    @test JSON.parse("{\"id\":1,\"any\":{\"type\":\"int\",\"value\":10}}", Q) == Q(1, (type="int", value=10))
    @test JSON.parse("{\"id\":1,\"any\":{\"type\":\"float\",\"value\":3.14}}", Q) == Q(1, (type="float", value=3.14))
    @test JSON.parse("{\"id\":1,\"any\":{\"type\":\"string\",\"value\":\"hi\"}}", Q) == Q(1, (type="string", value="hi"))
    # extra tests for tuples since we have a custom implementation
    @test JSON.parse("[1,2,3]", Tuple{Int, Int, Int}) == (1, 2, 3)
    @test JSON.parse("[1,2,3, 4]", Tuple{Int, Int, Int}) == (1, 2, 3)
    @test_throws ArgumentError JSON.parse("[]", Tuple{Int, Int, Int})
    @test_throws ArgumentError JSON.parse("[1,2]", Tuple{Int, Int, Int})
    @test JSON.parse("{\"a\":1,\"b\":2,\"c\":3}", Tuple{Int, Int, Int}) == (1, 2, 3)
    @test JSON.parse("{\"a\":1,\"b\":2,\"c\":3,\"d\":4}", Tuple{Int, Int, Int}) == (1, 2, 3)
    @test_throws ArgumentError JSON.parse("{}", Tuple{Int, Int, Int})
    @test_throws ArgumentError JSON.parse("{\"a\":1,\"b\":2}", Tuple{Int, Int, Int})
end

@testset "isroot=false allows trailing" begin
    # default behavior: trailing content causes an error
    @test_throws ArgumentError JSON.parse("{\"hello\": \"world\"} asdaa")
    @test_throws ArgumentError JSON.parse("[1,2,3] extra")
    @test_throws ArgumentError JSON.parse("123 {}")

    # isroot=false: trailing content is ignored
    @test JSON.parse("{\"hello\": \"world\"} asdaa", isroot=false) == JSON.Object("hello" => "world")
    @test JSON.parse("[1,2,3] extra", isroot=false) == Any[1, 2, 3]
    @test JSON.parse("123 {}", isroot=false) == 123

    # isroot=false with typed parse
    @test JSON.parse("{\"a\": 1, \"b\": 2.0, \"c\": \"hi\"} trailing", D; isroot=false) == D(1, 2.0, "hi")
end

@testset "duplicate object keys" begin
    input = "{\"a\":1,\"a\":2}"
    @test JSON.parse(input) == JSON.Object("a" => 2)

    err = try
        JSON.parse(input; duplicate_keys=:error)
        nothing
    catch e
        e
    end
    @test err isa JSON.DuplicateKeyError
    @test err.key == "a"
    @test err.position == 8
    @test occursin("duplicate JSON object key", sprint(showerror, err))

    @test_throws JSON.DuplicateKeyError JSON.parse("{\"outer\":{\"x\":1,\"x\":2}}"; duplicate_keys=:error)
    @test_throws JSON.DuplicateKeyError JSON.parse("{\"a\":1,\"\\u0061\":2}"; duplicate_keys=:error)
    @test_throws JSON.DuplicateKeyError JSON.parse("{\"a\":1}\n{\"b\":1,\"b\":2}"; jsonlines=true, duplicate_keys=:error)
    @test_throws JSON.DuplicateKeyError JSON.parse(input, Dict{String, Int}; duplicate_keys=:error)
    @test JSON.isvalidjson(input)
    @test !JSON.isvalidjson(input; duplicate_keys=:error)
    @test_throws ArgumentError JSON.parse("{}"; duplicate_keys=:keep_first)
end

# JSON Reading

This guide to reading JSON in the JSON.jl package aims to:
  - Provide a comprehensive overview of the JSON reading process.
  - Explain the various options and configurations available for reading JSON data.
  - Offer practical examples to illustrate the usage of different functions and options.
  
## Core JSON Parsing - `JSON.lazy` and `JSON.LazyValue`

There are several "entrypoints" to reading JSON in JSON.jl, including:
  - [`JSON.parse`](@ref)/`JSON.parse!`
  - [`JSON.parsefile`](@ref)/[`JSON.parsefile!`](@ref)
  - [`JSON.lazy`](@ref)/[`JSON.lazyfile`](@ref)
  - [`JSON.isvalidjson`](@ref)

These functions are all built to accept the same kinds of JSON inputs:

| Accepted `json` sources                    | Notes                                             |
|:-------------------------------------------|:--------------------------------------------------|
| `AbstractString`                           | UTF‑8; UTF‑8‑BOM handled automatically            |
| `AbstractVector{UInt8}`                    | zero‑copy if already bytes                        |
| `IO`, `IOStream`, `Base.AbstractCmd`       | stream fully read into a byte vector              |

The core JSON parsing machinery is hence built around having an `AbstractVector{UInt8}` or `AbstractString` JSON input where individual bytes can be parsed to identify JSON structure, validate syntax, and ultimately produce Julia-level values.

Each entrypoint function first calls [`JSON.lazy`](@ref), which will consume the JSON input until the type of the next JSON value can be identified (`{` for objects, `[` for arrays, `"` for strings, `t` for true, `f` for false, `n` for null, and `-` or a digit for numbers). [`JSON.lazy`](@ref) returns a [`JSON.LazyValue`](@ref), which wraps the JSON input buffer (`AbstractVector{UInt8}` or `AbstractString`), and marks the byte position the value starts at, the type of the value, and any keyword arguments that were provided that may affect parsing. Currently supported parsing-specific keyword arguments to [`JSON.lazy`](@ref) (and thus all other entrypoint functions) include:

  - `allownan::Bool = false`: whether "special" float values shoudl be allowed while parsing (`NaN`, `Inf`, `-Inf`); these values are specifically _not allowed_ in the JSON spec, but many JSON libraries allow reading/writing
  - `ninf::String = "-Infinity"`: the string that will be used to parse `-Inf` if `allownan=true`
  - `inf::String = "Infinity"`: the string that will be used to parse `Inf` if `allownan=true`
  - `nan::String = "NaN"`: the string that will be sued to parse `NaN` if `allownan=true`
  - `jsonlines::Bool = false`: whether the JSON input should be treated as an implicit array, with newlines separating individual JSON elements with no leading `'['` or trailing `']'` characters. Common in logging or streaming workflows. Defaults to `true` when used with [`JSON.parsefile`](@ref) and the filename extension is `.jsonl` or `ndjson`. Note this ensures that parsing will _always_ return an array at the root-level.
  - Materialization-specific keyword arguments (i.e. they affect materialization, but not parsing)
    - `dicttype = JSON.Object{String, Any}`: type to parse JSON objects as by default (recursively)
    - `null = nothing`: value to return for JSON `null` value

So what can we do with a [`JSON.LazyValue`](@ref)?

```julia-repl
julia> x = JSON.lazy("{\"a\": 1, \"b\": null, \"c\": true, \"d\": false, \"e\": \"\", \"f\": [1,2,3], \"g\": {\"h\":{\"i\":\"foo\"}}}")
LazyObject{String} with 7 entries:
  "a" => JSON.LazyValue(1)
  "b" => JSON.LazyValue(nothing)
  "c" => JSON.LazyValue(true)
  "d" => JSON.LazyValue(false)
  "e" => JSON.LazyValue("")
  "f" => LazyValue[JSON.LazyValue(1), JSON.LazyValue(2), JSON.LazyValue(3)]
  "g" => LazyObject{String}("h"=>LazyObject{String}("i"=>JSON.LazyValue("foo")))
```

Note that for convenience at the REPL, special `show` overloads enable displaying the full contents of lazy values. In reality, remember the `LazyValue` only marks the _position_ of a value within the JSON.
`LazyValue`s support convenient syntax for both _navigating_ their structure and _materializing_, with an aim
to support lazy workflows. Examples include:

```julia-repl
# convenient "get" syntax on lazy objects
julia> x.a
JSON.LazyValue(1)

julia> x[:b]
JSON.LazyValue(nothing)

julia> x["c"]
JSON.LazyValue(true)

julia> propertynames(x)
7-element Vector{Symbol}:
 :a
 :b
 :c
 :d
 :e
 :f
 :g

julia> x.g.h.i
JSON.LazyValue("foo")

# array indexing on lazy arrays
julia> x.f[1]
JSON.LazyValue(1)

julia> x.f[end]
JSON.LazyValue(3)

julia> x.f[1:3]
3-element StructUtils.Selectors.List{Any}:
 JSON.LazyValue(1)
 JSON.LazyValue(2)
 JSON.LazyValue(3)

# default materialization of any LazyValue via empty getindex
julia> x.a[]
1

julia> x[]
JSON.Object{String, Any} with 7 entries:
  "a" => 1
  "b" => nothing
  "c" => true
  "d" => false
  "e" => ""
  "f" => Any[1, 2, 3]
  "g" => Object{String, Any}("h"=>Object{String, Any}("i"=>"foo"))
```

Let's take a closer look at one of these examples and talk through what's going on under the hood. For `x.g.h.i`, this deeply nested access of the `"foo"` value, is a chain of `getproperty` calls, with each call (i.e. `y = x.g`, then `z = y.h`, etc.) returning a `LazyValue` of where the next nested object begins in the raw JSON. With the final `getproperty` call (`h.i`), a non-object `LazyValue("foo")` is returned. In our raw JSON, the `"foo"` value is located near the end, so we can infer that by doing `x.g.h.i`, the underlying JSON was parsed or _navigated_ until the `i` key was found and its value returned. In this example, `"foo"` is indeed the last value in our raw JSON, but in the example of `x.c`, we can also be assured that only as much JSON as necessary was parsed/navigated before returning `LazyValue(true)`. In this way, the various syntax calls (`getproperty`, `getindex`, etc.) on `LazyValue`s can be thought of as purely _navigational_ as opposed to anything related to _materialization_. Indeed, the very purpose of the lazy machinery in JSON.jl is to _allow_ lazily navigating, specifically _without_ needing to materialize anything along the way.

Ok, but at some point, we _do_ actually need Julia values to operate on, so let's shift to how _materialization_ works in JSON.jl.

## `JSON.parse` - Untyped materialization

In the `LazyValue` syntax example, it was shown that empty `getindex` will result in a "default" materialization of a `LazyValue`:

```julia-repl
julia> x[]
JSON.Object{String, Any} with 7 entries:
  "a" => 1
  "b" => nothing
  "c" => true
  "d" => false
  "e" => ""
  "f" => Any[1, 2, 3]
  "g" => Object{String, Any}("h"=>Object{String, Any}("i"=>"foo"))
```

Under the hood, this `getindex` call is really calling `JSON.parse(lazyvalue)`. [`JSON.parse`](@ref) can also be called as a main entrypoint function with all the same input types as [`JSON.lazy`](@ref). This form of `parse` is referred to as "untyped parsing" or "untyped materialization". It allocates and _materializes_ the raw JSON values into appropriate "default" Julia-level values. In particular:

| JSON construct | Default Julia value                                                       |
|:---------------|:--------------------------------------------------------------------------|
| object         | `JSON.Object{String,Any}` (order‑preserving drop-in replacement for Dict) |
| array          | `Vector{Any}`                                                             |
| string         | `String`                                                                  |
| number         | `Int64`, `BigInt`, `Float64`, or `BigFloat`                               |
| `null`         | `nothing`                                                                 |
| `true/false`   | `Bool`                                                                    |

Mostly vanilla, but what is `JSON.Object`? It is a custom `AbstractDict` using an internal linked-list implementation that preserves insertion order, behaves as a drop-in replacement for `Dict`, and allows memory and performance benefits vs. `Dict` for small # of entries. It also supports natural JSON-object-like
syntax for accessing or setting values, like `x.g.h.i` and `x.c = false`.

Because `Object` uses a linked-list implementation, key lookups are `O(n)`, performing a linear scan on each access. For small number of entries (dozens), the real-performance difference vs. `Dict` hash-lookup is negligible, but for large objects, this can be prohibitive. For these cases, it's recommended to materialize JSON objects as regular Julia `Dict`, by utilizing the `dicttype` keyword argument, like: `JSON.parse(json; dicttype=Dict{String, Any})`.

## `JSON.parse` - Typed materialization

While untyped materialization is convenient for quick exploration, one of the most powerful features of JSON.jl is its ability to directly parse JSON into concrete Julia types. This is done by providing a type as the second argument to [`JSON.parse`](@ref) and opens up a world of type-safe JSON parsing with minimal boilerplate.

### Basic usage with structs

Let's start with a simple example. Suppose we have a Julia struct and a JSON string we want to parse into that type:

```julia
struct Person
    name::String
    age::Int
end

json = """{"name": "Alice", "age": 30}"""
person = JSON.parse(json, Person)
# Person("Alice", 30)
```

With this approach, JSON.jl automatically:
- Matches JSON object keys to struct field names
- Converts values to the appropriate field types
- Constructs the struct with the parsed values

By default, any extra JSON keys that don't match fields in the target type are
ignored. If you want those to error instead, pass `unknown_fields=:error`:

```julia
JSON.parse("""{"name": "Alice", "age": 30, "admin": true}""", Person; unknown_fields=:error)
# ERROR: ArgumentError: encountered unknown JSON member "admin" while parsing `Person`
```

This works for nested structs too:

```julia
struct Address
    street::String
    city::String
    country::String
end

struct Employee
    name::String
    age::Int
    address::Address
end

json = """
{
    "name": "Bob",
    "age": 42,
    "address": {
        "street": "123 Main St",
        "city": "Anytown",
        "country": "USA"
    }
}
"""

employee = JSON.parse(json, Employee)
```

### Arrays and collections

You can parse JSON arrays directly into Julia arrays with a specific element type:

```julia
# Parse into a Vector of integers
ints = JSON.parse("[1, 2, 3, 4, 5]", Vector{Int})
# 5-element Vector{Int64}: [1, 2, 3, 4, 5]

# Parse into a Vector of custom structs
people = JSON.parse("""
[
    {"name": "Alice", "age": 30},
    {"name": "Bob", "age": 42}
]
""", Vector{Person})
# 2-element Vector{Person}: [Person("Alice", 30), Person("Bob", 42)]
```

A particularly powerful feature is the ability to parse nested arrays into multi-dimensional arrays:

```julia
# Parse a nested array into a Matrix
matrix = JSON.parse("[[1, 2], [3, 4]]", Matrix{Int})
# 2×2 Matrix{Int64}:
#  1  3
#  2  4
```

Note that for matrices, JSON.jl expects column-major order (Julia's native format). The innermost arrays become the columns of the matrix.

### Primitive and simple types

JSON.jl can also parse JSON values directly into primitive types:

```julia
# Parse a JSON number into an Int
n = JSON.parse("42", Int)
# 42

# Parse a JSON string into a String
s = JSON.parse("\"hello\"", String)
# "hello"

# Parse a JSON string into a custom type like UUID
uuid = JSON.parse("\"123e4567-e89b-12d3-a456-426614174000\"", UUID)
# UUID("123e4567-e89b-12d3-a456-426614174000")

# Parse a JSON string into a Date
date = JSON.parse("\"2023-05-08\"", Date)
# Date("2023-05-08")
```

### Type conversions and handling nulls

JSON.jl provides smart handling for Union types, especially for dealing with potentially null values:

```julia
struct OptionalData
    id::Int
    description::Union{String, Nothing}
    score::Union{Float64, Missing}
end

json = """
{
    "id": 123,
    "description": null,
    "score": null
}
"""

data = JSON.parse(json, OptionalData)
# OptionalData(123, nothing, missing)
```

Note how JSON.jl automatically:
- Converts JSON `null` to Julia `nothing` for `Union{T, Nothing}` fields
- Converts JSON `null` to Julia `missing` for `Union{T, Missing}` fields

### Field customization through tags

You can customize how JSON fields map to struct fields using "field tags" from StructUtils.jl via the struct macros (`@tags`, `@defaults`, `@kwarg`, or `@noarg`):

```julia
using JSON, StructUtils

@tags struct UserProfile
    user_id::Int &(json=(name="id",),)
    first_name::String &(json=(name="firstName",),)
    last_name::String &(json=(name="lastName",),)
    birth_date::Date &(json=(dateformat=dateformat"yyyy/mm/dd",),)
end

json = """
{
    "id": 42,
    "firstName": "Jane",
    "lastName": "Doe",
    "birth_date": "1990/01/15"
}
"""

user = JSON.parse(json, UserProfile)
# UserProfile(42, "Jane", "Doe", Date("1990-01-15"))
```

The `&(json=(name="...",),)` syntax lets you:
- Map differently named JSON keys to your struct fields
- Specify custom date formats for parsing dates
- And many other customizations

Field tags are really named tuples of values, prefixed with the `&` character, so note the trailing `,` when the named tuple has a single element.
Also note that in this example, we "namespaced" our field tags with the `json=(...)` key. Then when "making" our struct, only the `json=(...)` field tags
are considered. This is because JSON.jl defines `json` as a "field tag key" for its custom `JSONStyle`, then passes a `JSONStyle` to be used when parsing.
That means you could specify the field tag like `&(name="id,)`, but if the field then is also used by any other package, it would also see that name.
Sometimes that may be desirable, but there are also cases where you want the namespacing, like: `&(json=(name="id",), postgres=(name="user_id",))`.

### Default values with `@defaults`

When some JSON fields might be missing, you can provide default values similar to field tags using any of the struct macros (`@tags`, `@defaults`, `@kwarg`, or `@noarg`):

```julia
@defaults struct Configuration
    port::Int = 8080
    host::String = "localhost"
    debug::Bool = false
    timeout::Int = 30
end

# Even with missing fields, parsing succeeds with defaults
json = """{"port": 9000}"""
config = JSON.parse(json, Configuration)
# Configuration(9000, "localhost", false, 30)
```

### Non-struct-like types with `@nonstruct`

What if you have a custom struct that you want to behave more like a primitive type rather than a struct? For example, you might want a custom email type that should be serialized as a JSON string rather than a JSON object.

The `@nonstruct` macro is perfect for this use case. By marking your struct as non-struct-like, you tell JSON.jl to treat it as a primitive type that should be converted directly using `lift` and `lower` methods rather than constructing it from field values.

Here's an example of a custom email type that should be serialized as a JSON string:

```julia
using JSON

@nonstruct struct Email
    value::String
    
    function Email(value::String)
        # Validate email format
        if !occursin(r"^[^@]+@[^@]+\.[^@]+$", value)
            throw(ArgumentError("Invalid email format: $value"))
        end
        new(value)
    end
end

# Define how to convert from various sources to Email
JSON.lift(::Type{Email}, x::String) = Email(x)

# Define how to convert Email to a serializable format
JSON.lower(x::Email) = x.value

# Now you can use Email in your structs and it will be serialized as a string
@defaults struct User
    id::Int = 1
    name::String = "default"
    email::Email
end

# Create a user with an email
user = User(email=Email("alice@example.com"))

# Convert to JSON - email will be a string, not an object
json_string = JSON.json(user)
# Result: {"id":1,"name":"default","email":"alice@example.com"}

# Parse back from JSON
user_again = JSON.parse(json_string, User)
```

Another example - a custom numeric type that represents a percentage:

```julia
@nonstruct struct Percent <: Number
    value::Float64
    
    function Percent(value::Real)
        if value < 0 || value > 100
            throw(ArgumentError("Percentage must be between 0 and 100"))
        end
        new(Float64(value))
    end
end

# Convert from various numeric types
JSON.lift(::Type{Percent}, x::Number) = Percent(x)
JSON.lift(::Type{Percent}, x::String) = Percent(parse(Float64, x))

# Convert to a simple number for serialization
JSON.lower(x::Percent) = x.value

# Use in a struct
@defaults struct Product
    name::String = "default"
    discount::Percent = Percent(0.0)
end

# Create and serialize
product = Product(discount=Percent(15.5))
json_string = JSON.json(product)
# Result: {"name":"default","discount":15.5}
```

The key points about `@nonstruct`:

1. **No field defaults or tags**: Since you're opting out of struct-like behavior, field defaults and tags are not supported.

2. **Requires `lift` and `lower` methods**: You must define how to convert to/from your type.

3. **Fields are private**: The struct's fields are considered implementation details for the parsing process.

4. **Perfect for wrapper types**: Great for types that wrap primitives but need custom validation or behavior.

### Advanced Example: The FrankenStruct

Let's explore a more comprehensive example that showcases many of JSON.jl's advanced typed parsing features:

```julia
using Dates, JSON, StructUtils

# First, define some types for polymorphic parsing
abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

# Define a custom type chooser for AbstractMonster
JSON.@choosetype AbstractMonster x -> x.monster_type[] == "vampire" ? Dracula : Werewolf

# Define a custom numeric type with special parsing
@nonstruct struct Percent <: Number
    value::Float64
end

# Custom lifting for the Percent type
JSON.lift(::Type{Percent}, x) = Percent(Float64(x))
StructUtils.liftkey(::Type{Percent}, x::String) = Percent(parse(Float64, x))

# Our complex struct with various field types and defaults
@defaults struct FrankenStruct
    id::Int = 0
    name::String = "Jim"
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = nothing
    monster::AbstractMonster = Dracula(0)
    percent::Percent = Percent(0.0)
    birthdate::Date = Date(0) &(json=(dateformat="yyyy/mm/dd",),)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}()
    json_properties::JSONText = JSONText("")
    matrix::Matrix{Float64} = Matrix{Float64}(undef, 0, 0)
end

# A complex JSON input with various features to demonstrate
json = """
{
    "id": 1,
    "address": "123 Main St",
    "rate": null,
    "franken_type": "b",
    "notsure": {"key": "value"},
    "monster": {
        "monster_type": "vampire",
        "num_victims": 10
    },
    "percent": 0.1,
    "birthdate": "2023/10/01",
    "percentages": {
        "0.1": 1,
        "0.2": 2
    },
    "json_properties": {"key": "value"},
    "matrix": [[1.0, 2.0], [3.0, 4.0]],
    "extra_key": "extra_value"
}
"""

franken = JSON.parse(json, FrankenStruct)
```

Let's walk through some notable features of the example above:
  * The `name` field isn't present in the JSON input, so the default value of `"Jim"` is used.
  * The `address` field uses a default `@choosetype` to determine that the JSON value is not `null`, so a `String` should be parsed for the field value.
  * The `rate` field has a `null` JSON value, so the default `@choosetype` recognizes it should be "lifted" to `Missing`, which then uses a predefined `lift` definition for `Missing`.
  * The `type` field is a `Symbol`, and has a fieldtag `json=(name="franken_type",)` which means the JSON key `franken_type` will be used to set the field value instead of the default `type` field name. A default `lift` definition for `Symbol` is used to convert the JSON string value to a `Symbol`.
  * The `notsure` field is of type `Any`, so the default object type `JSON.Object{String, Any}` is used to materialize the JSON value.
  * The `monster` field is a polymorphic type, and the JSON value has a `monster_type` key that determines which concrete type to use. The `@choosetype` macro is used to define the logic for choosing the concrete type based on the JSON input. Note that the `x` in `@choosetype` is a `LazyValue`, so we materialize via `x.monster_type[]` in order to compare with the string `"vampire"`.
  * The `percent` field is a custom type `Percent` and the `JSON.lift` macro defines how to construct a `Percent` from the JSON value, which is a `Float64` in this case.
  * The `birthdate` field uses a custom date format for parsing, specified in the JSON input.
  * The `percentages` field is a dictionary with keys of type `Percent`, which is a custom type. The `liftkey` function is defined to convert the JSON string keys to `Percent` types (parses the Float64 manually)
  * The `json_properties` field has a type of `JSONText`, which means the raw JSON will be preserved as a String of the `JSONText` type.
  * The `matrix` field is a `Matrix{Float64}`, so the JSON input array-of-arrays are materialized as such.
  * The `extra_key` field is not defined in the `FrankenStruct` type, so it is ignored and skipped over by default. Pass `unknown_fields=:error` if you want unknown keys to throw instead.

# Migration Guides

This guide provides an overview of how to migrate your code from either the pre-1.0 JSON.jl package to the 1.0 release or from JSON3.jl. The 1.0 release introduces several improvements and changes, particularly in how JSON is read and written, leveraging StructUtils.jl for customization and extensibility. Below, we outline the key differences and provide step-by-step instructions for updating your code.

---

## Migration guide from pre-1.0 -> 1.0

### Writing JSON
- [`JSON.json`](@ref)
  - What stayed the same:
    - Produces a compact String by default
    - Can automatically serialize basic structs in a sensible way
    - Can take an integer 2nd argument to induce "pretty printing" of the JSON output
  - What changed:
    - Can now pass `JSON.json(x; pretty=true)` or `JSON.json(x; pretty=4)` to control pretty printing
    - Can pass filename as first argument to write JSON directly to a file `JSON.json(file, x)` the file name is returned
    - Can pass any `IO` as 1st argument to write JSON to it: `JSON.json(io, x)`
    - Circular reference tracking is fixed/improved (previously peer references were written as null)
    - Explicit keyword arguments to control a number of serialization features, including:
      - `omit_null::Bool` whether `nothing`/`missing` Julia values should be skipped when serializing
      - `omit_empty::Bool` whether empty Julia collection values should be skipped when serializing
      - `allownan::Bool` similar to the parsing keyword argument to allow/disallow writing of invalid JSON values `NaN`, `-Inf`, and `Inf`
      - `ninf::String` the string to write if `allownan=true` and serializing `-Inf`
      - `inf::String` the string to write if `allownan=true` and serializing `Inf`
      - `nan::String` the string to write if `allownan=true` and serializing `NaN`
      - `jsonlines::String` when serializing an array, write each element independently on a new line as an implicit array; can be read back when parsing by also passing `jsonlines=true`
      - `inline_limit::Int` threshold number of elements in an array under which an array should be printed on a single line (only applicable when pretty printing)
      - `float_style::Symbol` allowed values are `:shortest`, `:fixed`, and `:exp` corresponding to printf format styles, `%g`, `%f`, and `%e`, respectively
      - `float_precision::Int` number of decimal places to use when printing floats
  - Why the changes:
    - Mostly just modernizing the interfaces (use of keyword arguments vs. positional)
    - Utilizing multiple dispatch to combine `JSON.print` and `JSON.json` and provide convenience for writing to files
    - Most opened issues over the last few years were about providing more controls around writing JSON without having to completely implement a custom serializer
    - More consistency with `JSON.parse` keyword args with `allownan` and `jsonlines`
- [`JSON.print`](@ref)
  - What stayed the same:
    - Technically still defined for backwards compatibility, but just calls `JSON.json` under the hood
  - Why the changes:
    - Not necessary as all the functionality can be combined without ambiguity or overlap with `JSON.json`
- `JSON.lower`
  - What stayed the same:
    - Still used to transform Julia values into JSON-appropriate values
  - What changed:
    - `lower` technically now lives in the StructUtils.jl package (though overloading in JSON is fine)
    - Can overload for a specific "style" for non-owned types, like `struct MyStyle <: JSON.JSONStyle end`, then `JSON.lower(::MyStyle, x::Rational) = (den=x.den, num=x.num)`, then have the style used when writing like `JSON.json(1//3; style=MyStyle())`
    - Probably don't need to `lower` except in rare cases; there are default `lower` defintions for common types and most structs/AbstractDict/AbstractArray will work out of the box; `lower` is mostly useful when wanting to have the JSON output of a struct be a string or a number, for example, so going between aggregate/non-aggregate from Julia to JSON
  - Why the changes:
    - Along with the new corresponding `lift` interface, the `lower` + `lift` combination is a powerful generalization of doing "domain transformations"
- `JSON.StructuralContext` / `JSON.show_json` / `JSON.Serialization`
  - What stayed the same:
    - These have been removed in favor of simpler interfaces and custom `JSONStyle` subtypes + overloads
  - Why the changes:
    - The use of distinct contexts for different writing styles (pretty, compact) is unnecessary and led to code duplication
    - There was often confusion about whether a custom Serialization or StructuralContext was needed and what intefaces were then required to implement
    - The need to customize separators, delimiters, and indentation, while powerful, can be accomplished much simpler via keyword arguments or is not necessary at all (i.e. JSON.jl shouldn't be too concerned with how to produce anything that isn't JSON)
    - Instead of overloading show_string/show_element/show_key/show_pair/show_json, `lower` can be used to accomplish any requirements of "overloading" how values are serialized; the addition of "styles" also allows customizing for non-owned types instead of needing a custom context + `show_json` method
- [`JSONText`](@ref)
  - What changed:
    - Nothing; `JSONText` can still be used to have a JSON-formatted string be written as-is when serializing

### Reading JSON
- [`JSON.parse`](@ref) / [`JSON.parsefile`](@ref)
  - What stayed the same:
    - These functions take the same JSON input arguments (String, IO, or filename for `parsefile`)
    - The `dicttype`, `allownan`, and `null` keyword arguments all remain and implement the same functionality
  - What changed:
    - `JSON.Object{String, Any}` is now the default type used when parsing instead of `Dict{String, Any}`; `JSON.Object` is a drop-in replacement for `Dict`, supporting the `AbstractDict` interface, mutation, dot-access (getproperty) to keys, memory and performance benefits for small objects vs. `Dict`, and preserves the JSON order of keys. For large objects (hundreds or thousands of keys), or to otherwise restore the pre-1.0 behavior, you can do `JSON.parse(json; dicttype=Dict{String, Any})`.
    - The `inttype` keyword argument has been removed
    - The `allownan` keyword argument now defaults to `false` instead of `true` to provide a more accurate JSON specification behavior as the default
    - The `use_mmap` keyword argument has been removed from `parsefile`; mmapping will now be decided automatically by the package and any mmaps used for parsing will be completely finalized when parsing has finished
    - Numbers in JSON will now be parsed as `Int64`, `BigInt`, `Float64`, or `BigFloat`, instead of only `Int64` or `Float64`. Many JSON libraries support arbitrary precision ints/floats, and now JSON.jl does too.
    - `JSON.parse(json, T)` and `JSON.parse!(json, x)` variants have been added for constructing a Julia value from JSON, or mutating an existing Julia value from JSON; `JSON.parsefile(json, T)` and `JSON.parsefile!(json, x)` are also supported; see [JSON Reading](@ref) for more details
  - Why the changes:
    - The `inttype` keyword argument is rare among other JSON libraries and doesn't serve a strong purpose; memory gains from possibly using smaller ints is minimal and leads to more error-prone code via overflows by trying to force integers into non-standard small types
    - For the `allownan` default value change, there are many benchmarks/JSON-accuracy checking test suites that enforce adherance to the specification; following the specification by default is recommended and common across language JSON libraries
    - Mmapping is an internal detail that most users shouldn't worry about anyway, and it can be done transparently without any outside affect to the user
- [`JSONText`](@ref)
  - `JSONText` can now also be used while parsing, as a field type of a struct or directly to return the raw JSON (similar to how writing with `JSONText` works)

## Migration guide for JSON3.jl

The JSON.jl 1.0 release incorporates many of the design ideas that were originally developed in JSON3.jl. This guide helps you transition your code from JSON3.jl to JSON.jl 1.0, highlighting what's changed, what's similar, and the best way to update your code.

### Writing JSON

- `JSON3.write` → `JSON.json`
  - What stayed the same:
    - The core functionality of serializing Julia values to JSON remains the same
    - Support for serializing custom structs in a sensible way
    - Both can output to a string or IO
  - What changed:
    - Function name: `JSON3.write` becomes `JSON.json`
    - Direct file writing: Instead of `open(file, "w") do io; JSON3.write(io, x); end`, you can use `JSON.json(file, x)`
    - Customization framework: JSON3.jl uses StructTypes.jl, while JSON.jl 1.0 uses StructUtils.jl
    - Pretty printing: `JSON3.pretty(JSON3.write(x))` becomes `JSON.json(x; pretty=true)`
    - Special numeric values: In JSON3.jl, writing NaN/Inf/-Inf required passing `allow_inf=true`, in JSON.jl 1.0 you pass `allownan=true`
  - Why the changes:
    - Preference was given to existing JSON.jl names where possible (`JSON.json`, `allownan`, etc)
    - JSON3 pretty printing support was an example of "bolted on" functionality that had a number of issues because it tried to operate on its own; in `JSON.json`, pretty printing is directly integrated with the core serializing code and thus doesn't suffer the same ergonomic problems
    - StructUtils.jl is overall simpler and provides much more functionality "by default" meaning its much more invisible for majority of use-cases. Its design is the direct result of wanting to provide roughly similar functionality as StructTypes.jl but avoiding the pitfalls and architectural complexities it had

- Custom Type Serialization
  - What stayed the same:
    - Both provide a way to customize how types are serialized
    - Both support serializing custom types to any valid JSON value
  - What changed:
    - Interface: No need to declare `StructTypes.StructType` explicitly on structs (StructUtils.jl can detect the vast majority of struct types automatically)
    - Non-owned types: JSON.jl (via StructUtils) provides the concept of defining a custom `StructStyle` subtype that allows customizing the lowering/lifting overloads of non-owned types (JSON3.jl had repeated requests/issues with users wanting more control over non-owned types without pirating)
  - Why the changes:
    - As noted above, the overall design of StructUtils is simpler and more automatic, with the default definitions working in the vast majority of cases. If you're the author of a custom Number, AbstractString, AbstractArray, or AbstractDict, you may need to dig further into StructUtil machinery to make your types serialize/deserialize as expected, but regular structs should "just work"
    - Defining custom styles is meant to balance having to do some extra work (defining the style, passing it to `JSON.json`/`JSON.parse`) with the power and flexibility of control over how JSON serialization/deserialization work for any type, owned or not

- Field Customization
  - What stayed the same:
    - Both allow renaming fields, excluding fields, and some control over manipulating fields from JSON output (keyword args, dateformats, etc.)
  - What changed:
    - StructUtils provides convenient "struct" macros (`@noarg`, `@kwarg`, `@tags`, `@defaults`, `@nonstruct`) that allow defining default values for fields, and specifying "field tags" which are named tuples of properties for fields. Via field tags, fields can customize naming, ignoring/excluding, dateformating, custom lowering/lifting, and even "type choosing" for abstract types.
  - Why the changes:
    - The field tags and defaults of StructUtils provide very powerful and generalized abilities to specify properties for fields. These are integrated directly with the serialize/deserialize process of StructUtils and provide a seemless way to enhance and control fields as desired. Instead of providing numerous StructType overloads, we can annotate individual fields appropriately, keeping context and information tidy and close to the source.

- Null and Empty Value Handling
  - What stayed the same:
    - Both allow control over including/omitting null values and empty collections
  - What changed:
    - Control mechanism: JSON3.jl uses `StructTypes.omitempties`, JSON.jl 1.0 uses keyword arguments `omit_null` and `omit_empty`; or struct-level overloads or annotations to control omission

### Reading JSON

- `JSON3.read` → `JSON.parse` / `JSON.lazy`
  - What stayed the same:
    - Core functionality of parsing JSON into Julia values
    - Support for typed parsing into custom structs
    - Lazy parsing features
  - What changed:
    - Function names: `JSON3.read` becomes either `JSON.parse` (eager) or `JSON.lazy` (lazy)
    - Default container type: `JSON3.Object/JSON3.Array` becomes `JSON.Object{String, Any}/Vector{Any}`
    - Type integration: JSON3.jl uses StructTypes.jl, JSON.jl 1.0 uses StructUtils.jl
    - Lazy value access: Both use property access syntax (`obj.field`) but with slightly different semantics
  - Migration examples:
    ```julia
    # JSON3.jl
    obj = JSON3.read(json_str)
    typed_obj = JSON3.read(json_str, MyType)
    
    # JSON.jl 1.0
    obj = JSON.parse(json_str)               # eager parsing
    lazy_obj = JSON.lazy(json_str)           # lazy parsing
    materialized = lazy_obj[]                # materialize lazy value
    typed_obj = JSON.parse(json_str, MyType) # typed parsing
    ```

- Lazy Parsing
  - What stayed the same:
    - Both support lazy parsing for efficient access to parts of large JSON documents
    - Both allow dot notation for accessing object fields
  - What changed:
    - Object types: `JSON3.Object` becomes `JSON.LazyValue` with object type
    - Array indexing: Similar, but slight syntax differences for materializing values
    - Materialization: In JSON3.jl specific values materialize when accessed, in JSON.jl 1.0 you explicitly use `[]` to materialize
  - Migration examples:
    ```julia
    # JSON3.jl
    obj = JSON3.read(json_str)
    value = obj.deeply.nested.field  # value is materialized
    
    # JSON.jl 1.0
    obj = JSON.lazy(json_str)
    lazy_value = obj.deeply.nested.field  # still lazy
    value = obj.deeply.nested.field[]     # now materialized
    ```
  - Why the changes:
    - The lazy support in JSON.jl is truly lazy and the underlying JSON is only parsed/navigated as explicitly requested. JSON3.jl still fully parsed the JSON into a fairly compact binary representation, avoiding full materialization of objects and arrays.

- Typed Parsing
  - What stayed the same:
    - Both allow parsing directly into custom types
    - Both support object mapping, handling nested types, unions with Nothing/Missing
  - What changed:
    - Interface: `StructTypes.StructType` becomes JSON.jl's StructUtils integration
    - Default values: `StructTypes.defaults` becomes `@defaults` macro
    - Type selection: Custom JSON3 dispatching becomes `JSON.@choosetype`
  - Migration examples:
    ```julia
    # JSON3.jl
    StructTypes.StructType(::Type{MyType}) = StructTypes.Struct()
    StructTypes.defaults(::Type{MyType}) = (field1=0, field2="default")
    
    # Type selection in JSON3.jl
    StructTypes.StructType(::Type{AbstractParent}) = StructTypes.AbstractType()
    StructTypes.subtypes(::Type{AbstractParent}) = (a=ConcreteA, b=ConcreteB)
    
    # JSON.jl 1.0
    @defaults struct MyType
        field1::Int = 0
        field2::String = "default"
    end
    
    # Type selection in JSON.jl 1.0
    JSON.@choosetype AbstractParent x -> x.type[] == "a" ? ConcreteA : ConcreteB
    ```

- Custom Field Mapping
  - What stayed the same:
    - Both support mapping between JSON property names and struct field names
    - Both handle date formatting and other special types
  - What changed:
    - Interface: JSON3.jl uses `StructTypes.names`, JSON.jl 1.0 uses field tags
    - Date handling: Different formats for specifying date formats
  - Migration examples:
    ```julia
    # JSON3.jl
    StructTypes.names(::Type{MyType}) = ((:json_name, :struct_field),)
    StructTypes.keywordargs(::Type{MyType}) = (date_field=(dateformat=dateformat"yyyy-mm-dd",),)
    
    # JSON.jl 1.0
    @tags struct MyType
        struct_field::Int &(json=(name="json_name",),)
        date_field::Date &(json=(dateformat="yyyy-mm-dd",),)
    end
    ```

### Features unique to each library

- Only in JSON3.jl:
  - **Struct Generation**: The ability to automatically generate Julia struct definitions from JSON examples
    ```julia
    # This functionality is not available in JSON.jl 1.0
    struct_def = JSON3.generate_struct(json_data, "MyStruct")
    ```
  - If you rely heavily on this feature, continue using JSON3.jl for this specific purpose until this functionality is migrated to a separate package

- Only in JSON.jl 1.0:
  - **Enhanced JSON Lines Support**: Better handling of JSON Lines format with auto-detection for files with `.jsonl` extension
  - **More Float Formatting Controls**: Additional options for float precision and format style
  - **Improved Circular Reference Handling**: Better detection and handling of circular references

# JSON Writing

This guide to writing JSON in the JSON.jl package aims to:
  - Provide a comprehensive overview of the JSON serialization process.
  - Explain the various options and configurations available for writing JSON data.
  - Offer practical examples to illustrate the usage of different functions and options.

## Core JSON Serialization - `JSON.json`

The main entrypoint for serializing Julia values to JSON in JSON.jl is the [`JSON.json`](@ref) function. This function offers flexible output options:

```julia
# Serialize to a String
JSON.json(x) -> String

# Serialize to an IO object
JSON.json(io::IO, x) -> IO

# Serialize to a file
JSON.json(file_name::String, x) -> String
```

The [`JSON.json`](@ref) function accepts a wide range of Julia types and transforms them into their JSON representation by knowing how to serialize a core set of types:

| Julia type                         | JSON representation                       |
|:-----------------------------------|:------------------------------------------|
| `Nothing`                          | `null`                                    |
| `Bool`                             | `true` or `false`                         |
| `Number`                           | Numeric value (integer or floating point) |
| `AbstractString`                   | String with escaped characters            |
| `AbstractDict`/`NamedTuple`        | Object (`{}`)                             |
| `AbstractVector`/`Tuple`/`Set`     | Array (`[]`)                              |
| Custom structs                     | Object (`{}`) with fields as keys         |
| `JSONText`                         | Raw JSON (inserted as-is)                 |

For values that don't fall into one of the above categories, `JSON.lower` will be called allowing a "domain transformation" from Julia value to an appropriate representation of the categories above.

## Customizing JSON Output

[`JSON.json`](@ref) supports numerous keyword arguments to control how data is serialized:

### Pretty Printing

By default, [`JSON.json`](@ref) produces compact JSON without extra whitespace. For human-readable output:

```julia
# Boolean flag for default pretty printing (2-space indent)
JSON.json(x; pretty=true)

# Or specify custom indentation level
JSON.json(x; pretty=4)  # 4-space indentation
```

Example of pretty printing:

```julia
data = Dict("name" => "Alice", "scores" => [95, 87, 92])

# Compact output
JSON.json(data)
# {"name":"Alice","scores":[95,87,92]}

# Pretty printed
JSON.json(data; pretty=true)
# {
#   "name": "Alice",
#   "scores": [
#     95,
#     87,
#     92
#   ]
# }
```

When pretty printing, you can also control which arrays get printed inline versus multiline using the `inline_limit` option:

```julia
JSON.json(data; pretty=true, inline_limit=10)
# {
#   "name": "Alice",
#   "scores": [95, 87, 92]
# }
```

### Null and Empty Value Handling

JSON.json provides options to control how `nothing`, `missing`, and empty collections are handled:

```julia
struct Person
    name::String
    email::Union{String, Nothing}
    phone::Union{String, Nothing}
    tags::Vector{String}
end

person = Person("Alice", "alice@example.com", nothing, String[])

# Default behavior writes all values, including null
JSON.json(person)
# {"name":"Alice","email":"alice@example.com","phone":null,"tags":[]}

# Exclude null values
JSON.json(person; omit_null=true)
# {"name":"Alice","email":"alice@example.com","tags":[]}

# Omit empty collections as well
JSON.json(person; omit_null=true, omit_empty=true)
# {"name":"Alice","email":"alice@example.com"}
```

Note that we can also control whether null or empty values are omitted at the type level, either by overloading `omit_null`/`omit_empty` functions:
```julia
JSON.omit_null(::Type{Person}) = true
```

Or by using a convenient macro annotation when defining the struct:
```julia
@omit_null struct Person
    name::String
    email::Union{String, Nothing}
    phone::Union{String, Nothing}
    tags::Vector{String}
end
```

#### Field-level overrides with `JSON.Null` / `JSON.Omit`

Sometimes you want a struct to opt into `omit_null=true` globally, while still forcing specific
fields to emit `null`, or vice-versa. JSON.jl provides two sentinel constructors (defined in the
`JSON` module but intentionally not exported) to cover those cases:

- `JSON.Null()` always serializes as the literal `null`, even when omit-null logic would normally
  skip it.
- `JSON.Omit()` drops the enclosing field/entry regardless of omit settings. (It is only valid
  inside an object/array; using it as the top-level value throws an error.)

You can reference these sentinels directly in your data types or return them from custom `lower`
functions attached via field tags.

```julia
struct Profile
    id::Int
    email::Union{String, JSON.Null}
    nickname::Union{String, JSON.Omit}
end

profile = Profile(1, JSON.Null(), JSON.Omit())

# `email` stays in the payload even with omit_null=true
JSON.json(profile; omit_null=true)
# {"id":1,"email":null}

@tags struct User
    id::Int
    display_name::Union{Nothing, String} &(json=(lower=n -> something(n, JSON.Omit()),),)
end

user = User(2, nothing)

# Field-level lowering can return JSON.Omit() to remove the entry entirely
JSON.json(user)
# {"id":2}
```

### Special Numeric Values

By default, JSON.json throws an error when trying to serialize `NaN`, `Inf`, or `-Inf` as they are not valid JSON. However, you can enable them with the `allownan` option:

```julia
numbers = [1.0, NaN, Inf, -Inf]

# Default behavior throws an error
try
    JSON.json(numbers)
catch e
    println(e)
end
# ArgumentError("NaN not allowed to be written in JSON spec; pass `allownan=true` to allow anyway")

# With allownan=true
JSON.json(numbers; allownan=true)
# [1.0,NaN,Infinity,-Infinity]

# Custom representations
JSON.json(numbers; allownan=true, nan="null", inf="1e999", ninf="-1e999")
# [1.0,null,1e999,-1e999]
```

### Float Formatting

Control how floating-point numbers are formatted in the JSON output:

```julia
pi_value = [Float64(π)]

# Default format (shortest representation)
JSON.json(pi_value)
# [3.141592653589793]

# Fixed decimal notation
JSON.json(pi_value; float_style=:fixed, float_precision=2)
# [3.14]

# Scientific notation
JSON.json(pi_value; float_style=:exp, float_precision=3)
# [3.142e+00]
```

`float_precision` must be a positive integer when `float_style` is `:fixed` or `:exp`.

### JSON Lines Format

The JSON Lines format is useful for streaming records where each line is a JSON value:

```julia
records = [
    Dict("id" => 1, "name" => "Alice"),
    Dict("id" => 2, "name" => "Bob"),
    Dict("id" => 3, "name" => "Charlie")
]

# Standard JSON array
JSON.json(records)
# [{"id":1,"name":"Alice"},{"id":2,"name":"Bob"},{"id":3,"name":"Charlie"}]

# JSON Lines format; each object on its own line, no begining or ending square brackets
JSON.json(records; jsonlines=true)
# {"id":1,"name":"Alice"}
# {"id":2,"name":"Bob"}
# {"id":3,"name":"Charlie"}
```

## Customizing Types

### Using `JSON.JSONText`

The `JSONText` type allows you to insert raw, pre-formatted JSON directly:

```julia
data = Dict(
    "name" => "Alice",
    "config" => JSON.JSONText("{\"theme\":\"dark\",\"fontSize\":16}")
)

JSON.json(data)
# {"name":"Alice","config":{"theme":"dark","fontSize":16}}
```

### Custom Type Serialization with `lower`

For full control over how a type is serialized, you can define a `JSON.lower` method:

```julia
struct Coordinate
    lat::Float64
    lon::Float64
end

# Serialize as an array instead of an object
JSON.lower(c::Coordinate) = [c.lat, c.lon]

point = Coordinate(40.7128, -74.0060)
JSON.json(point)
# [40.7128,-74.006]

# For serializing custom formats
struct UUID
    value::String
end

JSON.lower(u::UUID) = u.value

JSON.json(UUID("123e4567-e89b-12d3-a456-426614174000"))
# "123e4567-e89b-12d3-a456-426614174000"
```

### Custom Serialization for Non-Owned Types

To customize serialization for types you don't own (those from other packages), you can use a custom style:

```julia
using Dates

# Create a custom style that inherits from JSONStyle
struct DateTimeStyle <: JSON.JSONStyle end

# Define how to serialize Date and DateTime in this style
JSON.lower(::DateTimeStyle, d::Date) = string(d)
JSON.lower(::DateTimeStyle, dt::DateTime) = Dates.format(dt, "yyyy-mm-dd HH:MM:SS")

# Use the custom style
JSON.json(Date(2023, 1, 1); style=DateTimeStyle())
# "2023-01-01"

JSON.json(DateTime(2023, 1, 1, 12, 30, 45); style=DateTimeStyle())
# "2023-01-01 12:30:45"
```

## Customizing Struct Serialization

### Field Names and Tags

The JSON.jl package integrates with StructUtils.jl for fine-grained control over struct serialization. StructUtils.jl provides convenient "struct" macros:
  - `@noarg`: generates a "no-argument" constructor (`T()`)
  - `@kwarg`: generates an all-keyword-argument constructor, similar to `Base.@kwdef`; (`T(; kw1=v1, kw2=v2, ...)`)
  - `@tags`/`@defaults`: convenience macros to enable specifying field defaults and field tags
  - `@nonstruct`: marks a struct as non-struct-like, treating it as a primitive type for serialization

Each struct macro also supports the setting of field default values (using the same syntax as `Base.@kwdef`), as well as specifying "field tags"
using the `&(tag=val,)` syntax.

```julia
using JSON, StructUtils

# Using the @tags macro to customize field serialization
@tags struct User
    user_id::Int &(json=(name="id",),)
    first_name::String &(json=(name="firstName",),)
    last_name::String &(json=(name="lastName",),)
    created_at::DateTime &(json=(dateformat="yyyy-mm-dd",),)
    internal_note::String &(json=(ignore=true,),)
end

user = User(123, "Jane", "Doe", DateTime(2023, 5, 8), "Private note")

JSON.json(user)
# {"id":123,"firstName":"Jane","lastName":"Doe","created_at":"2023-05-08"}
```

The various field tags allow:
- Renaming fields with `name`
- Custom date formatting with `dateformat`
- Excluding fields from JSON output with `ignore=true`

### Default Values with `@defaults`

Combine with the `@defaults` macro to provide default values:

```julia
@defaults struct Configuration
    port::Int = 8080
    host::String = "localhost"
    debug::Bool = false
    timeout::Int = 30
end

config = Configuration(9000)
JSON.json(config)
# {"port":9000,"host":"localhost","debug":false,"timeout":30}
```

## Handling Circular References

[`JSON.json`](@ref) automatically detects circular references to prevent infinite recursion:

```julia
mutable struct Node
    value::Int
    next::Union{Nothing, Node}
end

# Create a circular reference
node = Node(1, nothing)
node.next = node

# Without circular detection, this would cause a stack overflow
JSON.json(node; omit_null=false)
# {"value":1,"next":null}
```

## Custom Dictionary Key Serialization

For dictionaries with non-string keys, [`JSON.json`](@ref) has a few default `lowerkey` definitions to convert keys to strings:

```julia
# Integer keys
JSON.json(Dict(1 => "one", 2 => "two"))
# {"1":"one","2":"two"}

# Symbol keys
JSON.json(Dict(:name => "Alice", :age => 30))
# {"name":"Alice","age":30}

# Custom key serialization
struct CustomKey
    id::Int
end

dict = Dict(CustomKey(1) => "value1", CustomKey(2) => "value2")
try
    JSON.json(dict)
catch e
    println(e)
end
# ArgumentError("No key representation for CustomKey. Define StructUtils.lowerkey(::CustomKey)")

# Define how the key should be converted to a string
StructUtils.lowerkey(::JSON.JSONStyle, k::CustomKey) = "key-$(k.id)"

JSON.json(dict)
# {"key-1":"value1","key-2":"value2"}
```

## Advanced Example: The FrankenStruct

Let's explore a comprehensive example that showcases many of JSON.jl's advanced serialization features:

```julia
using Dates, JSON, StructUtils

abstract type AbstractMonster end

struct Dracula <: AbstractMonster
    num_victims::Int
end

struct Werewolf <: AbstractMonster
    witching_hour::DateTime
end

struct Percent <: Number
    value::Float64
end

JSON.lower(x::Percent) = x.value
StructUtils.lowerkey(x::Percent) = string(x.value)

@noarg mutable struct FrankenStruct
    id::Int
    name::String # no default to show serialization of an undefined field
    address::Union{Nothing, String} = nothing
    rate::Union{Missing, Float64} = missing
    type::Symbol = :a &(json=(name="franken_type",),)
    notsure::Any = JSON.Object("key" => "value")
    monster::AbstractMonster = Dracula(10) &(json=(lower=x -> x isa Dracula ? 
        (monster_type="vampire", num_victims=x.num_victims) : 
        (monster_type="werewolf", witching_hour=x.witching_hour),),)
    percent::Percent = Percent(0.5)
    birthdate::Date = Date(2025, 1, 1) &(json=(dateformat="yyyy/mm/dd",),)
    percentages::Dict{Percent, Int} = Dict{Percent, Int}(Percent(0.0) => 0, Percent(1.0) => 1)
    json_properties::JSONText = JSONText("{\"key\": \"value\"}")
    matrix::Matrix{Float64} = [1.0 2.0; 3.0 4.0]
    extra_field::Any = nothing &(json=(ignore=true,),)
end

franken = FrankenStruct()
franken.id = 1

json = JSON.json(franken)
# "{\"id\":1,\"name\":null,\"address\":null,\"rate\":null,\"franken_type\":\"a\",\"notsure\":{\"key\":\"value\"},\"monster\":{\"monster_type\":\"vampire\",\"num_victims\":10},\"percent\":0.5,\"birthdate\":\"2025/01/01\",\"percentages\":{\"1.0\":1,\"0.0\":0},\"json_properties\":{\"key\": \"value\"},\"matrix\":[[1.0,3.0],[2.0,4.0]]}"
```

Let's analyze each part of this complex example to understand how JSON.jl's serialization features work:

### Custom Type Serialization Strategy

1. **The `AbstractMonster` Type Hierarchy**:
   - We define an abstract type `AbstractMonster` with two concrete subtypes: `Dracula` and `Werewolf`
   - Each type contains type-specific data (number of victims vs. witching hour)

2. **Custom Numeric Type**:
   - `Percent` is a custom numeric type that wraps a `Float64`
   - We provide two serialization methods:
     - `JSON.lower(x::Percent) = x.value`: This tells JSON how to serialize a `Percent` value (convert to the underlying Float64)
     - `StructUtils.lowerkey(x::Percent) = string(x.value)`: This handles when a `Percent` is used as a dictionary key

3. **The `FrankenStruct`**:
   - Created with `@noarg` making it a mutable struct that can be default constructed like `FrankenStruct()`

### Field-Level Serialization Control

Let's examine each field of `FrankenStruct` in detail:

1. **Basic Fields**: 
   - `id::Int`: Standard integer field (initialized explicitly to 1)
   - `name::String`: Intentionally left uninitialized to demonstrate `#undef` serialization

2. **Null Handling and Unions**:
   - `address::Union{Nothing, String} = nothing`: Demonstrates how `Nothing` values are serialized
   - `rate::Union{Missing, Float64} = missing`: Shows how `Missing` values are serialized (both become `null` in JSON)

3. **Field Renaming with Tags**:
   - `type::Symbol = :a &(json=(name="franken_type",),)`: 
     - The `name` tag changes the output JSON key from `"type"` to `"franken_type"`
     - The value `:a` is automatically serialized as the string `"a"` through a default `lower` method for symbols

4. **Any Type**:
   - `notsure::Any = JSON.Object("key" => "value")`: Shows how JSON handles arbitrary types

5. **Field-Specific Custom Serialization**:
   - ```
     monster::AbstractMonster = Dracula(10) &(json=(lower=x -> x isa Dracula ? 
         (monster_type="vampire", num_victims=x.num_victims) : 
         (monster_type="werewolf", witching_hour=x.witching_hour),),)
     ```
     - This demonstrates **field-specific custom serialization** using the `lower` field tag
     - The lambda function checks the concrete type and produces a different JSON structure based on the type
     - For `Dracula`, it adds a `"monster_type": "vampire"` field
     - For `Werewolf`, it would add a `"monster_type": "werewolf"` field
     - Unlike a global `JSON.lower` method, this approach only applies when this specific field is serialized

6. **Custom Numeric Type**:
   - `percent::Percent = Percent(0.5)`: Uses the global `JSON.lower` we defined to serialize as `0.5`

7. **Custom Date Formatting**:
   - `birthdate::Date = Date(2025, 1, 1) &(json=(dateformat="yyyy/mm/dd",),)`:
     - The `dateformat` field tag controls how the date is formatted
     - Instead of ISO format (`"2025-01-01"`), it's serialized as `"2025/01/01"`

8. **Dictionary with Custom Keys**:
   - `percentages::Dict{Percent, Int} = Dict{Percent, Int}(Percent(0.0) => 0, Percent(1.0) => 1)`:
     - This dictionary uses our custom `Percent` type as keys
     - JSON uses our `StructUtils.lowerkey` method to convert the keys to strings

9. **Raw JSON Inclusion**:
   - `json_properties::JSONText = JSONText("{\"key\": \"value\"}")`:
     - The `JSONText` wrapper indicates this should be included as-is in the output
     - No escaping or processing is done; the string is inserted directly into the JSON

10. **Matrices and Multi-dimensional Arrays**:
    - `matrix::Matrix{Float64} = [1.0 2.0; 3.0 4.0]`:
      - 2D array serialized as nested arrays in column-major order

11. **Ignoring Fields**:
    - `extra_field::Any = nothing &(json=(ignore=true,),)`:
      - The `ignore=true` field tag means this field will be completely excluded from serialization
      - Useful for internal fields that shouldn't be part of the JSON representation

### Output Analysis

When we serialize this struct, we get a JSON string with all the specialized serialization rules applied:

```json
{
  "id": 1,
  "name": null,
  "address": null,
  "rate": null,
  "franken_type": "a",
  "notsure": {"key": "value"},
  "monster": {"monster_type": "vampire", "num_victims": 10},
  "percent": 0.5,
  "birthdate": "2025/01/01",
  "percentages": {"1.0": 1, "0.0": 0},
  "json_properties": {"key": "value"},
  "matrix": [[1.0, 3.0], [2.0, 4.0]]
}
```

Some key observations:
- `extra_field` is completely omitted due to the `ignore` tag
- Field names are either their originals (`id`, `name`) or renamed versions (`franken_type` instead of `type`)
- The nested `monster` field has custom serialization, producing a specialized format
- The date is in the custom format we specified
- Dictionary keys using our custom `Percent` type are properly converted to strings
- The matrix is serialized in column-major order as nested arrays
- The `JSONText` data is inserted directly without any additional processing

This example demonstrates how JSON.jl provides extensive control over JSON serialization at multiple levels: global type rules, field-specific customization, and overall serialization options.
